<?php

    namespace HCM\FPA\ObrigacaoLegal\Demonstrativo_Eletronico;

    use HCM\Util\Util;
    use HCM\FPA\Entity\FpatipoassoceveEntity;
    use HCM\FPA\Registro\FPARegistro;
    
class RegistroHolerite extends FPARegistro{
    
    const LISTA_TIPO_REGISTROS_ARQUIVO = '0, 1, 2, 3, 9';
    const LISTA_TIPO_REGISTROS_UNICO = '0, 9';

    const TIPO_ARQUIVO_CARGA_LOTE_MES = 'T'; //Carga de Lote de Holerites do mês
    const TIPO_ARQUIVO_COMPL_HOLE_MES = 'C'; //Complemento de Holerites do mês
    const TIPO_ARQUIVO_SUBST_LOTE_PRO = 'S'; //Substituição de um Lote processado
    const TIPO_ARQUIVO_ALTER_HOLE_MES = 'A'; //Alteração de Holerites do mês
    const TIPO_ARQUIVO_EXCLU_LOTE_PRO = 'X'; //Exclusão de um Lote processado
    const TIPO_ARQUIVO_EXCLU_HOLE_IND = 'E'; //Exclusão de Holerite Individual
    const TIPO_ARQUIVO_DISPE_FUNCIONA = 'D'; //Dispensa de Funcionário

    const LISTA_REGISTROS_TIPO_ARQ_T = '0, 1, 2, 3, 9';
    const LISTA_REGISTROS_TIPO_ARQ_C = '0, 1, 2, 3, 9';
    const LISTA_REGISTROS_TIPO_ARQ_S = '0, 1, 2, 3, 9';
    const LISTA_REGISTROS_TIPO_ARQ_A = '0, 1, 2, 3, 9';
    const LISTA_REGISTROS_TIPO_ARQ_E = '0, 1, 9';
    const LISTA_REGISTROS_TIPO_ARQ_D = '0, 1, 9';
    const LISTA_REGISTROS_TIPO_ARQ_X = '0, 9';

    const TIPO_LANC_CREDITO = 'C';
    const TIPO_LANC_DEBITO = 'D';
    const TIPO_LANC_LIQUIDO = 'L';

    const TIPO_EVENTO_PROVENTO = 'PROVENTO';
    const TIPO_EVENTO_DESCONTO = 'DESCONTO';

    const REF_QUANT_LANC = 'QTDLANC';

    const REF_TOTAL_CREDITO = FpatipoassoceveEntity::ASSOC_PROVENTOS;
    const REF_TOTAL_DEBITO = FpatipoassoceveEntity::ASSOC_DESCONTOS;
    const REF_TOTAL_LIQUIDO = FpatipoassoceveEntity::ASSOC_LIQUIDO;
    const REF_BASE_IRRF = FpatipoassoceveEntity::ASSOC_INCID_IRRF;
    const REF_BASE_INSS = FpatipoassoceveEntity::ASSOC_INCID_INSS;
    const REF_BASE_FGTS = FpatipoassoceveEntity::ASSOC_INCID_FGTS;
    const REF_FGTS_MES = FpatipoassoceveEntity::ASSOC_FGTS;

    const PRIMEIRA_PARCELA_13 = 'A';
    const SEGUNDA_PARCELA_13 = 'B';
    const SALÁRIO_14 = 'C';
    const FOLHA_NORMAL_PARCIAL = 'D';
    const FOLHA_NORMAL = 'E';
    const PRÊMIO = 'F';
    const FÉRIAS = 'G';
    const BÔNUS = 'H';
    const COMPLEMENTO = 'I';
    const ADIANTAMENTO = 'J';
    const ANTECIPAÇÃO = 'K';
    const COMPROVANTE_1 = 'L';
    const COMPROVANTE_2 = 'M';
    const COMPROVANTE_3 = 'N';
    const COMPROVANTE_4 = 'O';
    const PAGAMENTO = 'P';
    const GRATIFICAÇÃO = 'Q';
    const PLR = 'R';
    const ABONO_SALARIAL = 'S';
    const PAGAMENTO_PARCIAL = 'T';
    const PAGAMENTO_NORMAL = 'U';

    private $_eventos_pagamento;

    protected function geraRegistro($tpRegistro, $cdBanco = null, $loteServico = null){
        $this->_atribuiDado($tpRegistro, 1);
    }

    public function setTipoPagamento($tipoPagamento)
    {
        switch($tipoPagamento) {
            case self::FOLHA_NORMAL :
                $this->_eventos_pagamento = array(
                    self::REF_TOTAL_CREDITO => FpatipoassoceveEntity::ASSOC_PROVENTOS,
                    self::REF_TOTAL_DEBITO => FpatipoassoceveEntity::ASSOC_DESCONTOS,
                    self::REF_TOTAL_LIQUIDO => FpatipoassoceveEntity::ASSOC_LIQUIDO,
                    self::REF_BASE_IRRF => FpatipoassoceveEntity::ASSOC_INCID_IRRF,
                    self::REF_BASE_INSS => FpatipoassoceveEntity::ASSOC_INCID_INSS,
                    self::REF_BASE_FGTS => FpatipoassoceveEntity::ASSOC_INCID_FGTS,
                    self::REF_FGTS_MES => FpatipoassoceveEntity::ASSOC_FGTS
                );
                break;
        }
    }

    public function getEventosPagamento($referencia = null)
    {
        if (is_null($referencia)) {
            return $this->_eventos_pagamento;
        } else {
            return $this->_eventos_pagamento[$referencia];
        }
    }

}