<?php

namespace HCM\SST\Services;

use Doctrine\ORM\EntityManager;
use HCM\SST\Repository\ExameRepository;
use HCM\Util\HCMParameters;
use HCM\Util\Messages;

class ExameService {
    
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, ExameRepository $exameRepository) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        $this->exameRepository = $exameRepository;
    }
    
    public function vdExameHasItem($nrexame) {
        try {
            $itens = $this->exameRepository->getItensFromExame($nrexame);
            if (!empty($itens)) {
                throw new \Exception(Messages::HCM05000_SST_EXAME_EXISTS_ITEM_ERROR, Messages::ERROR_MESSAGE_CODE);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function vdItemExameHasReferencia($nritemexame) {
        try {
            $itens = $this->exameRepository->getReferenciasFromItemExame($nritemexame);
            if (!empty($itens)) {
                throw new \Exception(Messages::HCM05000_SST_ITEMEXAME_EXISTS_REFERENCIA_ERROR, Messages::ERROR_MESSAGE_CODE);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function vdReferenciaHasFaixas($nrreferenciaitemexame) {
        try {
            $itens = $this->exameRepository->getFaixasFromReferenciaItemExame($nrreferenciaitemexame);
            if (!empty($itens)) {
                throw new \Exception(Messages::HCM05000_SST_REFITEMEXAME_EXISTS_FAIXA_ERROR, Messages::ERROR_MESSAGE_CODE);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function vdReferenciaHasClassificacoes($nrreferenciaitemexame) {
        try {
            $itens = $this->exameRepository->getClassificacoesFromReferenciaItemExame($nrreferenciaitemexame);
            if (!empty($itens)) {
                throw new \Exception(Messages::HCM05000_SST_REFITEMEXAME_EXISTS_CLASSIF_ERROR, Messages::ERROR_MESSAGE_CODE);
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }
}