<?php

namespace HCM\VAB\Services;

use Doctrine\ORM\EntityManager;
use Folha\Entities\VabLinhatarifa;
use Folha\Entities\VabLinha;
use HCM\Util\HCMParameters;

class LinhatransporteService {
    
    protected $linhatransp;
    protected $entityManager;
    protected $hcmParameters;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }
    
    public function deleteLinha($dataset) {
        
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $nrlinhatransp = $dataset["NRLINHATRANSP"];

        $linhatarifa = VabLinhatarifa::findByNrlinhatranspAndNrorg($nrlinhatransp, $nrorg);

        if (isset($linhatarifa[0])) {
            throw new \Exception("Existe(m) tarifa(s) relacionada(s) à esta linha.", 10);
        } else {
            $this->entityManager->beginTransaction();

            $linhatransp = VabLinha::findOneByNrlinhatranspAndNrorg($nrlinhatransp, $nrorg);

            $this->entityManager->remove($linhatransp);
            $this->entityManager->flush();
            $this->entityManager->commit();
        }
    }
}