<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\Util\FPA;
use HCM\Util\TkDI;
use HCM\Util\MsgCalculo;
use HCM\Util\Valor;
use HCM\FPA\Entity\FpatipocalculoEntity;
use HCM\FPA\Entity\FpaitecalcfolhaEntity;
use HCM\FPA\Entity\FpaTipodireitoEntity;
use HCM\FPA\Entity\FpaPtregraEntity;
use HCM\FPA\Entity\FpaformrescisaoEntity;
use HCM\FPA\Entity\FpaVinceventoEntity;
use HCM\FPA\Entity\FpaincideventoEntity;
use HCM\FPA\Entity\FpatpcalcmovEntity;
use HCM\FPA\Entity\FpatipomovimentEntity;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use HCM\FPA\Entity\FpaFormcalculoEntity;
use HCM\FPA\Entity\FpaProcessoEntity;
use HCM\FPA\Entity\FpaeventohEntity;
use HCM\FPA\Entity\FpaeventomEntity;
use HCM\FPA\Entity\FpaRegramEntity;
use HCM\FPA\Entity\FpaferiasEntity;
use HCM\FPA\Entity\FpaValorreferenciamEntity;
use HCM\FPA\Entity\FpaTpdemissaoEntity;
use HCM\FPA\Entity\FpatipoincideEntity;
use HCM\FPA\Entity\FpaGrpitemEntity;
use HCM\Geral\Entity\GpevinculomEntity;
use HCM\Geral\Entity\GpevinculohEntity;
use HCM\Geral\Entity\GpealtesitufuncEntity;
use HCM\Geral\Entity\GpesitufunchEntity;
use HCM\Geral\Entity\GpesitufuncmEntity;
use HCM\Geral\Entity\GpeescalatrabhEntity;
use HCM\Geral\Entity\GpealtesalarioEntity;
use HCM\Geral\Entity\GpeParamoperEntity;
use HCM\FPA\Entity\FpaTpcalcregraEntity;
use HCM\FPA\Calculos\Geral\CalculoRegra;
use HCM\Util\DateUtil;
use HCM\FPA\Calculos\Geral\MemoriaCalculo;
use Setforms2\Shared\ORM\DateTime;

class Calculo extends CalculoAbstract{
    
    public function calcular($vinculo, $tp_calc_mov, $demonstrativo, $contador){

        $this->_inicializaVariaveis($vinculo, $tp_calc_mov);
        
        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            return;
        }

        try {
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov($tp_calc_mov->retornaTpMovPrincipal()));
            $this->_itens_calculo_principal =  $obj_tp_calc_mov->getInstancia();
            $this->_itens_calculo_principal->setNrTipoCalculo($this->_nr_tipo_calculo);
        } catch(Exception $e) {
            $message = $e->getMessage();
            $message .= ' - CALCULO.PHP';
            MsgCalculo::getInstance()->adicionaMensagem($e->getMessage());
        }

        if ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_FECHAMENTO &&
            $this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){
            $liquido = $this->_controleLiquido();
            if ($liquido == true) {
                MsgCalculo::getInstance()->adicionaMensagem('Vinculo possui liquido.',MsgCalculo::ERRO);
                return;
            }
        }

        $this->_controleLiquidoParcial();
        $this->_inicializaVariaveisRegra();

        $this->_calculo_regra->geraVariaveis();
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_INICIO, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ) {
            $this->_verificaTrabalhoEfetivo($vinculo);

            MemoriaCalculo::getInstance()->criaCabecalho($this->_vinculo, $this->_nr_tipo_calculo, $this->_sit_func_resumo, $this->_salario, $this->_dias_uteis, $this->_dias_rsr,
                $this->_mes_competencia, $this->_dt_pagamento, $this->_nrOcorrenciaCalculo, $this->_obj_tipo_calculo->getNmtipocalculo(), $this->_gozo_ferias);

            $this->_geraReferenciaSitFunc();

            if ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_FOLHA){
                $this->_calculaDsrSuplementar($this->_itens_calculo_principal, $vinculo);
            }

            $this->_calculaRemuneracaoBase($vinculo, $this->_itens_calculo_principal, $this->_nr_tipo_calculo);

            if($this->_idDifSal === 'S'){
                $this->_verificaDifSalarial($this->_mes_competencia, $vinculo);
            }

            $this->_demonstraAdiantamento($tp_calc_mov);

            if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
                || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
            ) {
                
                if($this->_ultPagamento == FpaFormcalculoEntity::IDULTPGTOMES_S) {
                    $this->_demonstraIRRFCaixa();
                }
                
                $this->_demonstra13Salario($tp_calc_mov);
            }

            $this->_demonstraFerias($tp_calc_mov);

            if($this->_idDifFerias === 'S') {
                $this->_verificaDifFerias($tp_calc_mov, $vinculo);
            }
            $this->_calculaLicencaRemun();

            $this->_calculaValeTransporte();

            if((int)$this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_NORMAL]>0 ||
                (int)$this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE]>0)
            {
                $this->_calculaContribuicaoSindical($vinculo);
            }

            $this->_analisaSalMaternidade($vinculo, $tp_calc_mov);

            $this->_executaCalculoEspecifico($vinculo, $tp_calc_mov);

            $this->_calculaSalarioFamilia($vinculo);

            $this->_calculaGrupoIncidencias();
            
            $this->_calculaTotais();

        } elseif ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_PROVISAO_CONTABIL) {
            $this->_verificaTrabalhoEfetivo($vinculo);
            $this->_executaCalculoEspecifico($vinculo, $tp_calc_mov);
        } elseif ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FECHAMENTO) {
            $this->_fechamento->fechar($vinculo, $this->_itens_calculo_principal, $this->_tpCalcMov);
        } else {
            
            $this->_verificaTrabalhoEfetivo($vinculo);
            MemoriaCalculo::getInstance()->criaCabecalho($this->_vinculo, $this->_nr_tipo_calculo, $this->_sit_func_resumo, $this->_salario, $this->_dias_uteis, $this->_dias_rsr,
                $this->_mes_competencia, $this->_dt_pagamento, $this->_nrOcorrenciaCalculo, $this->_obj_tipo_calculo->getNmtipocalculo(), $this->_gozo_ferias);
            $this->_calculaRemuneracaoBase($vinculo, $this->_itens_calculo_principal, $this->_nr_tipo_calculo);
            $this->_executaCalculoEspecifico($vinculo, $tp_calc_mov);
            
            if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_13SAL){
                $this->_calculaGrupoIncidencias();
            }
            $this->_calculaTotais();
        }

        if (($this->_recalculo === true) || ($this->_nrOcorrenciaCalculo > 1)) {

            if($this->_nr_tipo_calculo===FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR){

                $comp_ocorr_resc = DateUtil::setDay($vinculo->getDtrescisaovinc(), 1);
            
                if($this->_mes_competencia->format('d/m/Y') === $comp_ocorr_resc->format('d/m/Y')){
                    if($this->_nrOcorrenciaCalculo==1){
                        MsgCalculo::getInstance()->adicionaMensagem('Para fazer Rescisao Complementar dentro do mês de competência da Rescisão o Nr de Ocorrencia deve ser maior que '.$this->_nrOcorrenciaCalculo);
                    }else{
                        $calculo_folha = Fpacalculofolha::retornaCalculoFolha($this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, 1,
                            $this->_nrOcorrenciaCalculo-1, $comp_ocorr_resc, $comp_ocorr_resc
                        );
                    }
                }elseif($this->_mes_competencia > $comp_ocorr_resc){
                    if($this->_nrOcorrenciaCalculo>1){
                        MsgCalculo::getInstance()->adicionaMensagem('Para fazer Rescisao Complementar após o mês de competência da Rescisão o Nr de Ocorrencia deve ser 1');
                    }else{
                        $calculo_folha = Fpacalculofolha::retornaCalculoFolha($this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, 1,
                            $this->_nrOcorrenciaCalculo, $comp_ocorr_resc, $comp_ocorr_resc
                        );
                    }

                }
                $listaNrCalculo = array();
                foreach ($calculo_folha as $calculo){
                    $listaNrCalculo[] = $calculo->getNrcalculofolha();
                }
                $this->_itens_origem->retornaItensPorVinculo($vinculo->getNrorg(), $vinculo->getNrvinculom(), $listaNrCalculo[0]);

                $eventoAuxCred = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_COMPLEMENTO_SAL_CR , $this->_eventom, $this->_nrorg
                );
                $recuperavalor=$this->_itens_origem->retornaValorPorEvento($eventoAuxCred, $comp_ocorr_resc);

                $eventoAuxDeb = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_COMPLEMENTO_SAL_DB , $this->_eventom, $this->_nrorg
                );
                if ($recuperavalor>0) {
                    MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAuxDeb,null, $this->_mes_competencia, $recuperavalor,0,null,null,null,100);
                    $this->_itens_calculo_principal->geraEvento($eventoAuxDeb, $this->_mes_competencia, $recuperavalor, 0, 1);
                }

                if($this->_id_fazDifComp== FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_SIM){

                    $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_SALARIO_1 , $this->_eventom, $this->_nrorg
                    );
                    $recuperareferencia=$this->_itens_origem->retornaReferenciaPorEvento($eventoAux, $comp_ocorr_resc);
                    MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAux,null, $this->_mes_competencia,1, $recuperareferencia,null,null,null,100);
                    $this->_itens_calculo_principal->geraEvento($eventoAux, $this->_mes_competencia,0, $recuperareferencia,1);

                    $this->_calculaSalario($this->_itens_calculo_principal);

                    $eventos_transf = $this->_itens_origem->preparaRecalculoProvEventual( $this->_itens_origem, $this->_eventom);
                    for ($i=0; $i < count($eventos_transf); $i++) {
                        $evento_aux = $this->_eventom->retornaEvento($eventos_transf[$i]['NREVENTO']);
                        if ($eventos_transf[$i]['VALOR']>0) {
                            MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAux,null, $eventos_transf[$i]['DTOCORRENCIA'], $eventos_transf[$i]['VALOR'], $eventos_transf[$i]['REFERENCIA'],null,null,null,100);
                            $this->_itens_calculo_principal->geraEvento($evento_aux, $eventos_transf[$i]['DTOCORRENCIA'],  $eventos_transf[$i]['VALOR'], $eventos_transf[$i]['REFERENCIA'], 1);
                        }
                    }

                    $this->_calculaFaltas($this->_itens_calculo_principal);

                    $this->_calculaAdicionais($this->_itens_calculo_principal);

                    $this->_calculo_regra->executaPontoRegra(
                        $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_ADICIONAIS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
                    );
                    
                    $this->_calculaReflexo($this->_itens_calculo_principal, FpatipoincideEntity::INC_REFLEXO_ADIC_NOTURNO, FpatipoassoceveEntity::ASSOC_REFLEXO_ADIC_NOTURNO);

                    $this->_calculaExtra($this->_itens_calculo_principal);

                    $this->_calculo_regra->executaPontoRegra(
                        $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_HORAS_EXTRAS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
                    );
                    
                    $this->_calculaReflexo($this->_itens_calculo_principal, FpatipoincideEntity::INC_REFLEXO_HORA_EXTRA, FpatipoassoceveEntity::ASSOC_REFLEXO_REP_REMUNERADO);

                }
                $this->_itens_calculo_principal->calculaDiferencaRecalculo($this->_itens_origem, $this->_eventom, $this->_id_fazDifComp);


                if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
                    $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
                } else{
                    $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
                }

                FGTS::calcula(
                    FpatipoincideEntity::INC_FGTS_RESC, FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO,
                    FpatipoassoceveEntity::ASSOC_INCID_FGTS_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                    $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                );

                if (in_array(FpaTipodireitoEntity::FGTS_PAGO, $this->_listaDireitos) === true){
                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_13SAL_RESC,
                        FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia,
                        $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $percentual,
                        $this->_nrorg
                    );
                }

                if (in_array(FpaTipodireitoEntity::FGTS_DEPOSITADO, $this->_listaDireitos) === true){
                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_13_RESCISAO,
                        FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                    );
                }

                if (in_array(FpaTipodireitoEntity::MULTA_FGTS_PAGO, $this->_listaDireitos) === true){
                    $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS_RESC_MULTA);
                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_IND_RESCISAO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_RESCISAO,
                        FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                    );

                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_IND_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_BANCO,
                        FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                    );
                }

                if (in_array(FpaTipodireitoEntity::MULTA_FGTS_DEPOSITADO, $this->_listaDireitos) === true){
                    $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS_RESC_MULTA);
                    
                    if($vinculo->getNrtpdemissao() == FpaTpdemissaoEntity::ACORDO_ENTRE_PARTES){
                        $percentual = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, FpaValorreferenciamEntity::INIVALID_NOVO_INSS);
                    }
                    
                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_IND_RESCISAO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_RESCISAO_ENC,
                        FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                    );

                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_IND_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_BANCO_ENC,
                        FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                    );

                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_IND_13_RESCISAO_ENC,
                        FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual * 8/100, $this->_nrorg
                    );
                }

                if (in_array(FpaTipodireitoEntity::MULTA_CONTRIBUICAO_SOCIAL, $this->_listaDireitos) === true){
                    $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::CONTRIB_SOC_RESC);
                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_CONTR_SOC_RESC_ENC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_RESC_ENC,
                        FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                    );

                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_CONTR_SOC_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_BANCO_ENC,
                        FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
                    );

                    FGTS::calcula(
                        FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_13_RESC_ENC,
                        FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                        $this->_assoc_eventos, $this->_eventom, $percentual * 8/100, $this->_nrorg
                    );
                }

                $this->_calculo_regra->executaPontoRegra(
                    $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
                );

                INSS::calcula(
                    FpatipoincideEntity::INC_INSS_RESC, FpatipoassoceveEntity::ASSOC_INSS_RESCISAO,
                    FpatipoassoceveEntity::ASSOC_INCID_INSS_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                    $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null,null,null,0,false
                );

                INSS::calcula(
                    FpatipoincideEntity::INC_INSS_13RESC, FpatipoassoceveEntity::ASSOC_INSS_13SAL_RESC,
                    FpatipoassoceveEntity::ASSOC_INCID_INSS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                    $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null,null,null,0,false
                );

                $this->_calculo_regra->executaPontoRegra(
                    $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
                );

                IRRF::calcula(
                    FpatipoincideEntity::INC_IRRF_RESC, FpatipoassoceveEntity::ASSOC_IRRF_RESCISAO,
                    FpatipoassoceveEntity::ASSOC_INCID_IRRF_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                    $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
                );

                IRRF::calcula(
                    FpatipoincideEntity::INC_IRRF_13RESC, FpatipoassoceveEntity::ASSOC_IRRF_13SAL_RESC,
                    FpatipoassoceveEntity::ASSOC_INCID_IRRF_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                    $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
                );
                $this->_calculo_regra->executaPontoRegra(
                    $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
                );

                $this->_calculaGrupoIncidencias();

                $this->_calculaTotais();

            }elseif($this->_nr_tipo_calculo===FpatipocalculoEntity::CALC_FOLHA){
                $difFolhaComp = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_DIF_FOLHA_COMP');
               
                if($difFolhaComp == 1){
                    if($this->_nrOcorrenciaCalculo==1){
                        MsgCalculo::getInstance()->adicionaMensagem('Para fazer Rescisao Complementar dentro do mês de competência da Rescisão o Nr de Ocorrencia deve ser maior que '.$this->_nrOcorrenciaCalculo);
                    }else{
                        $calculo_folha = Fpacalculofolha::retornaCalculoFolha($this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, 1,
                            $this->_nrOcorrenciaCalculo-1, $this->_mes_competencia, $this->_mes_competencia
                        );
                    }

                    $listaNrCalculo = array();
                    foreach ($calculo_folha as $calculo){
                        $listaNrCalculo[] = $calculo->getNrcalculofolha();
                    }
                    $this->_itens_origem->retornaItensPorVinculo($vinculo->getNrorg(), $vinculo->getNrvinculom(), $listaNrCalculo[0]);

                    /*Retorna objeto do evento associado ao credito de complemento de salario para gerar o evento de debito de complemento no calculo principal*/
                    $eventoAuxCred = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_COMPLEMENTO_SAL_CR , $this->_eventom, $this->_nrorg
                    );
                    $recuperavalor=$this->_itens_origem->retornaValorPorEvento($eventoAuxCred, $this->_mes_competencia);

                    $eventoAuxDeb = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_COMPLEMENTO_SAL_DB , $this->_eventom, $this->_nrorg
                    );
                    if ($recuperavalor>0) {
                        MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAuxDeb,null, $this->_mes_competencia, $recuperavalor,0,null,null,null,100);
                        $this->_itens_calculo_principal->geraEvento($eventoAuxDeb, $this->_mes_competencia, $recuperavalor, 0, 1);
                    }

                    $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                        FpatipoassoceveEntity::ASSOC_SALARIO_1 , $this->_eventom, $this->_nrorg
                    );
                    $recuperareferencia=$this->_itens_origem->retornaReferenciaPorEvento($eventoAux, $this->_mes_competencia);
                    MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAux,null, $this->_mes_competencia,1, $recuperareferencia,null,null,null,100);
                    $this->_itens_calculo_principal->geraEvento($eventoAux, $this->_mes_competencia,0, $recuperareferencia,1);

                    $this->_calculaSalario($this->_itens_calculo_principal);

                    $eventos_transf = $this->_itens_origem->preparaRecalculoProvEventual( $this->_itens_origem, $this->_eventom);
                    for ($i=0; $i < count($eventos_transf); $i++) {
                        $evento_aux = $this->_eventom->retornaEvento($eventos_transf[$i]['NREVENTO']);
                        
                        if ($eventos_transf[$i]['VALOR']>0) {
                            MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAux,null, $eventos_transf[$i]['DTOCORRENCIA'], $eventos_transf[$i]['VALOR'], $eventos_transf[$i]['REFERENCIA'],null,null,null,100);
                            $this->_itens_calculo_principal->geraEvento($evento_aux, $eventos_transf[$i]['DTOCORRENCIA'],  $eventos_transf[$i]['VALOR'], $eventos_transf[$i]['REFERENCIA'], 1);
                        }

                    }
					if ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_FOLHA){
						$this->_calculaDsrSuplementar($this->_itens_calculo_principal, $vinculo);
					}

					$this->_calculaValeTransporte();

                    $this->_calculaFaltas($this->_itens_calculo_principal);

                    $this->_calculaAdicionais($this->_itens_calculo_principal);

                    $this->_calculo_regra->executaPontoRegra(
                        $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_ADICIONAIS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
                    );
                    
                    $this->_calculaReflexo($this->_itens_calculo_principal, FpatipoincideEntity::INC_REFLEXO_ADIC_NOTURNO, FpatipoassoceveEntity::ASSOC_REFLEXO_ADIC_NOTURNO);

                    $this->_calculaExtra($this->_itens_calculo_principal);

                    $this->_calculo_regra->executaPontoRegra(
                        $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_HORAS_EXTRAS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
                    );
                    
                    $this->_calculaReflexo($this->_itens_calculo_principal, FpatipoincideEntity::INC_REFLEXO_HORA_EXTRA, FpatipoassoceveEntity::ASSOC_REFLEXO_REP_REMUNERADO);


                    $this->_itens_calculo_principal->calculaDiferencaRecalculo($this->_itens_origem, $this->_eventom, $this->_id_fazDifComp);
                } else {

                    $this->_id_fazDifComp='N';

                    if($this->_id_fazDifComp==FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_NAO) {
                        $this->_itens_calculo_principal->executaRecalculoMensal($this->_itens_calculo_principal, $this->_eventom, $this->_id_fazDifComp);
                    }

                    $this->_executaFolha($vinculo);
                    $this->_calculaGrupoIncidencias();
                    $this->_calculaTotais();
                }

            }elseif($this->_nr_tipo_calculo===FpatipocalculoEntity::CALC_13SAL){
                
                $calculo_folha = Fpacalculofolha::retornaCalculoFolha($this->_nrorg, FpatipomovimentEntity::TP_MOV_13SAL, $this->_nrTipoModalidadeCalculo,
                    $this->_nrOcorrenciaCalculo-1, $this->_mes_competencia, $this->_mes_competencia
                );

                $listaNrCalculo = array();
                foreach ($calculo_folha as $calculo){
                    $listaNrCalculo[] = $calculo->getNrcalculofolha();
                }
                $this->_itens_origem->retornaItensPorVinculo($vinculo->getNrorg(), $vinculo->getNrvinculom(), $listaNrCalculo[0]);
                $this->_calculo_regra->executaPontoRegra(
                    $this->_idDebug, FpaPtregraEntity::PTREGRA_FINAL, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
                );

                $this->_itens_calculo_principal->calculaDiferencaRecalculo($this->_itens_origem, $this->_eventom,'S');

                $this->_calculaTotais();
            }

        }

        if($this->_nr_tipo_calculo!=FpatipocalculoEntity::CALC_13SAL) {
            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_FINAL, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
            );
        }

        MemoriaCalculo::getInstance()->setMovimentos();
        MemoriaCalculo::getInstance()->setIncidencias();
        
        $msgcalculo = MsgCalculo::getInstance()->getDados();
        
        if ($msgcalculo['IDSTATUS'] === MsgCalculo::ID_COM_ERRO) {
            return;
        }
        elseif ($this->_simulacao === false) {
           $tp_calc_mov->persisteItensCalculo();
            return;
        } else {
            //$elementoDemonstrativo = $this->_preparaCabecalho($vinculo, $demonstrativo, $contador);

            $lista =$tp_calc_mov->retornaListaItensCalculo(
                $this->_mes_competencia, $this->_eventom, $elementoDemonstrativo, $vinculo->getNrvinculom()
            );

            return $lista;
        }

    }

    public function _inicializaVariaveis($vinculo,  $tpCalcMov, $competenciaBuscaSalario = null){
        
        $this->_vinculo =$vinculo;
        $this->_tpCalcMov = $tpCalcMov;
        $this->_gruposCalulos = $this->entityManager->getRepository(Repositories::FPA_TPAGRUPA)->getGruposCalculos($this->_nrOrgPadrao, $this->_nrorg);

        $this->_movimentoPrincipal = array(
            FpatipocalculoEntity::CALC_FOLHA, FpatipocalculoEntity::CALC_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR
        );

        $this->_movimentoAuxiliar = array(
            FpatipocalculoEntity::CALC_13SAL, FpatipocalculoEntity::CALC_ADIANT_13SAL, FpatipocalculoEntity::CALC_ADIANTAMENTO,
            FpatipocalculoEntity::CALC_FERIAS, FpatipocalculoEntity::CALC_PROVISAO_CONTABIL
        );
        $this->_dias_remuneracao = 0;
        $this->_dias_normais = 0;
        $this->_dias_uteis = 0;
        $this->_dias_rsr = 0;
        $this->_dias_afastados = 0;
        $this->_dias_ferias = 0;
        $this->_sit_func_resumo = array();
        $this->_dias_atestados = 0;
        $this->_dias_uteis_ferias = 0;
        $this->_dias_rsr_ferias = 0;
        
        $this->_salario = 0;
        
        if(!$competenciaBuscaSalario){
            $competenciaBuscaSalario = $this->_mes_competencia;
        }
        $this->_setaValorTipoSalario($competenciaBuscaSalario);
  
        $nrEscala =$vinculo->historico->getNrescalatrabm();
        if (is_numeric($nrEscala) === false) {
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem escala de trabalho.', MsgCalculo::ERRO);
            return false;
        }

        $this->escalaVinculo = $this->_escalam->retornaEscalaNrEscala($nrEscala, $this->_nrorg);
		if ($this->escalaVinculo->historico) {
            $this->_jornada_diaria = $this->escalaVinculo->historico->getQthrescalatrabh();
		} else {
		    MsgCalculo::getInstance()->adicionaMensagem('Escala de Trabalho sem histórico para a competência.', MsgCalculo::ERRO);
			return false;
		}
        $this->_jornada_semanal = $this->escalaVinculo->historico->getQthrsemesctrabh();
        if($this->_jornada_semanal==null){
            $this->_jornada_semanal = 44;
        }
        $nrEstrutura =$vinculo->historico->getNrestrutlegal();
        if ($nrEstrutura === null) {
            $this->_nrCalendario = null;
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem parametrização de Estrutura Legal.', MsgCalculo::ERRO);
            return false;
        }
        $this->_estrutura->carregaEstrutura($nrEstrutura);
        
        $this->estrutura = $this->_estrutura->getEstrutura();
        
        $this->_nrCalendario = $this->estrutura->historico->getNrcalendario();
        
        $this->_paramCalculo->carregaParametroEstrutura($nrEstrutura);
        
        if(!$this->_carregaParametroFolha()){
            return false;
        }
        
        if(!$this->_carregaParametroFerias()){
            return false;
        }
        
        $this->_carregaItensGrupo();

        $this->_dia_fecha_apuracao= $this->escalaVinculo->historico->getNrdiafinapur();
        if (!is_null($this->_dia_fecha_apuracao)){
            
            $this->_ini_periodo_apura = DateUtil::getDataDeString($this->_mes_competencia, DateUtil::FORMATO_BRASILEIRO, true);
            $this->_ini_periodo_apura = DateUtil::setDay($this->_ini_periodo_apura, $this->_dia_fecha_apuracao+1);
            $this->_ini_periodo_apura = DateUtil::subtraiIntervalo($this->_ini_periodo_apura, 1, DateUtil::MES);
            
            $this->_fim_periodo_apura = DateUtil::getDataDeString($this->_mes_competencia, DateUtil::FORMATO_BRASILEIRO, true);
            $this->_fim_periodo_apura = DateUtil::setDay($this->_fim_periodo_apura, $this->_dia_fecha_apuracao);
            $this->_vinculo->ajustaIntervaloAdmResc($this->_ini_periodo_apura, $this->_fim_periodo_apura, $this->_nrControleAfastamento);
        }
        return true;
    }

    public function _inicializaVariaveisRegra(){
        $this->_regram = new FpaRegramEntity($this->entityManager, $this->hcmParameters);
        $this->_calculo_regra = new CalculoRegra($this);
        $this->_tpCalcRegra = new FpaTpcalcregraEntity($this->entityManager, $this->hcmParameters);
    }

    public function _carregaParametroFolha() {
        try{
            $this->_paramCalculo->carregaParametroFolha();
            $paramFolha = $this->_paramCalculo->getParamFolha();
            if (is_object($paramFolha) === true) {
                
                $this->_idTipoArredonda   = $paramFolha->getTipoArredondamento();
                $this->_nrDigitoArredonda = $paramFolha->getDigitoArredondamento();
                $this->_nrLimiteArredonda = $paramFolha->getLimiteArredondamento();
                $this->_nrGrupoIncidencia = $paramFolha->getGrupoIncidencia();
                $this->_nrControleAdmissao = $paramFolha->getControleAdmissao();
                $this->_idIRAcumulaRecMinimo = $paramFolha->getAcumulaIRRecolhimentoMinimo();
                $this->_percentualAdiantamento = $paramFolha->getPercentualAdiantamento();
                $this->_nrDiasMinAdiantamento = $paramFolha->getNumeroMinimoAdiantamento();
                $this->_idRecAdianPriMes = $paramFolha->getIdRecebeAdiantPriMes();  
                $this->_nrControleFerias = $paramFolha->getControleFerias(); 
                $this->_nrControleAfastamento = $paramFolha->getControleAfastamento(); 
                $this->_vrEnc1Ferias    = $paramFolha->getVrEncargo1Ferias(); 
                $this->_vrEnc2Ferias    = $paramFolha->getVrEncargo2Ferias(); 
                $this->_vrEnc1Aviso     = $paramFolha->getVrEncargo1Aviso(); 
                $this->_vrEnc2Aviso     = $paramFolha->getVrEncargo2Aviso(); 
                $this->_vrEnc1DecTerceiro = $paramFolha->getVrEncargo1DecTerceiro(); 
                $this->_vrEnc2DecTerceiro = $paramFolha->getVrEncargo2DecTerceiro(); 
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('Não encontrado Parametro de Folha definido no Parâmetro da Estrutura.', MsgCalculo::ERRO);
                return false;
            }
            return true;
        } catch (Exception $e){
            throw $e;

        }
    }

    public function _carregaParametroFerias() {
        try{
            $this->_paramCalculo->carregaParametroFerias();
            $paramFerias = $this->_paramCalculo->getParamFerias();

            if (is_object($paramFerias) === true) {
                $this->_vrPercentualProvisao = $paramFerias->getPercentualProvisao();
                $this->_nrDiasFeriaProv = $paramFerias->getNrDiasFeriasProvisao();
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('Não encontrado Parâmetro de Férias definido no Parâmetro da Estrutura.', MsgCalculo::ERRO);
                return false;
            }
            return true;
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function _carregaItensGrupo(){
        $this->_itemGrupo->carregaItensGrupoPorGrupoIncidencia($this->_nrorg, $this->_nrOrgPadrao, $this->_nrGrupoIncidencia);
    }
    
    public function verificaEventosRecalculo(){
        $eventosRecalculo = $this->_itens_calculo_principal->verificaEventosRecalculo();
        return $eventosRecalculo;
    }
    
    public function _controleLiquido(){
        
        if($this->_idConsvincresc == 'S'){
            $calc_folhaAtual = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha(
                $this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, 1, 1, $this->_mes_competencia, $this->_mes_competencia
            )[0];
            $itemCalcCompetenciaAtual = new FpaitecalcfolhaEntity($this->entityManager, $this->hcmParameters, $calc_folhaAtual->getNrcalculofolha());
            $itemCalcCompetenciaAtual->retornaItensPorVinculo($this->_vinculo->getNrorg(), $this->_vinculo->getNrvinculom(), $calc_folhaAtual->getNrcalculofolha());
            $liquido = $itemCalcCompetenciaAtual->verificaLiquido(
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg
            );
            
            if ($liquido) {
                return true;
            }
        }
        
        if ($this->_obj_tipo_calculo->getIdctrlliquido() === FpatipocalculoEntity::IDCTRLLIQUIDO_EXIGE_LIQUIDO) {
            $liquido = $this->_itens_calculo_principal->verificaLiquido(
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg
            );
            
            if ($liquido === false) {
                return false;
            }
        } elseif ($this->_obj_tipo_calculo->getIdctrlliquido() === FpatipocalculoEntity::IDCTRLLIQUIDO_PROIBE_LIQUIDO) {
            $liquido = $this->_itens_calculo_principal->verificaLiquido(
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg
            );
            if ($liquido === true) {
             
            } else {
                return false;
            }
        }
        
        return true;
    }

    public function _controleLiquidoParcial(){
        $liquidoParcial = $this->_itens_calculo_principal->verificaLiquidoParcial(
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg
        );

        if ($liquidoParcial === true) {
            $this->_retrocesso($this->_itens_calculo_principal);
        }
    }

    public function retroceder($vinculo, $tp_calc_mov){
        
        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            MsgCalculo::getInstance()->adicionaMensagem('Não foram encontrados itens de calculo.');
        }
        
        $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov($tp_calc_mov->retornaTpMovPrincipal()));
        $this->_itens_calculo_principal =  $obj_tp_calc_mov->getInstancia();
        
        MsgCalculo::getInstance()->setDados($this->_itens_calculo_principal->getNrcalculofolha(), $vinculo->getNrvinculom(), $this->_nrorg, 'ERROSCALCULO');
        
        $liquido = $this->_itens_calculo_principal->verificaLiquido(
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg
        );
        
        $fechamento = $this->_itens_calculo_principal->verificaFechamento(
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg
        );
        
        if ($liquido === true) {
            if ($fechamento === false) {
                $this->_retrocesso($this->_itens_calculo_principal);
                $this->_itens_calculo_principal->persist();
            } else {
                MsgCalculo::getInstance()->adicionaMensagem('Vínculo Fechado e não foi retrocedido',MsgCalculo::ERRO);
            }
        } else {
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo não tem líquido',MsgCalculo::ERRO);
        }
    }
    
    public function cancelamento($vinculo, $tp_calc_mov){

        if ($tp_calc_mov->retornaItensCalculo($vinculo) === false) {
            MsgCalculo::getInstance()->adicionaMensagem('Não foram encontrados itens de calculo.', MsgCalculo::ERRO);
        }

        $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov($tp_calc_mov->retornaTpMovPrincipal()));
        $this->_itens_calculo_principal =  $obj_tp_calc_mov->getInstancia();
        MsgCalculo::getInstance()->setDados($this->_itens_calculo_principal->getNrcalculofolha(), $vinculo->getNrvinculom(), $this->_nrorg, 'ERROSCALCULO');

        $fechamento = $this->_itens_calculo_principal->verificaFechamento(
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg
        );
        if ($fechamento === false) {
            $tp_calc_mov->apagaItensCalculo();
            if($this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_FERIAS){
                $this->_cancelaGozoFerias($vinculo, $this->_dtInicioGozo, $this->_dtFimGozo);
            }
        } else {
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo Fechado e não foi retrocedido',MsgCalculo::ERRO);
        }
        
    }

    public function _executaCalculoEspecifico($vinculo, $tp_calc_mov){

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_ANTES_CALC_ESPECIFICO, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        switch($this->_nr_tipo_calculo){
            case FpatipocalculoEntity::CALC_FERIAS: $this->_executaFerias($vinculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_FOLHA: $this->_executaFolha($vinculo); break;
            case FpatipocalculoEntity::CALC_13SAL: $this->_executa13Sal($vinculo, $this->_nr_tipo_calculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_ADIANT_13SAL: $this->_executa13Sal($vinculo, $this->_nr_tipo_calculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_ADIANTAMENTO: $this->_executaAdiantamento($vinculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_RESCISAO: $this->_executaRescisao($vinculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR: $this->_executaRescisaocomplementar($vinculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_PROVISAO_CONTABIL: $this->_executaProvisaoContabil($vinculo, $tp_calc_mov);break;
            case FpatipocalculoEntity::CALC_ADIANT_PLR: $this->_executaPLR($vinculo, $this->_nr_tipo_calculo, $tp_calc_mov); break;
            case FpatipocalculoEntity::CALC_PLR: $this->_executaPLR($vinculo, $this->_nr_tipo_calculo, $tp_calc_mov); break;
        }
    }
    
    public function _pagaAdicionalFerias(){
        
        $this->_gozo_ferias->retornaGozoFerias($this->_nrorg, $this->_vinculo->getNrvinculom());
        
        $gozoFerias = $this->_gozo_ferias->procuraGozoFeriasSemAdicional();
        
        if($gozoFerias){
            $valor = 0;
            foreach($gozoFerias as $gozo){
                
                $nrGozoFerias = $gozo->getNrgozoferias();
                $itemTotal = $this->_itens_calculo_principal->retornaItemPorNrGozo($this->_nrorg, $this->_vinculo->getNrvinculom(), $nrGozoFerias, FpatipoassoceveEntity::ASSOC_TOTAL_ADIC_FERIAS);
                
                $itemTotalPago = $this->_itens_calculo_principal->retornaItemPorNrGozo($this->_nrorg, $this->_vinculo->getNrvinculom(), $nrGozoFerias, FpatipoassoceveEntity::ASSOC_PAGA_TOTAL_ADIC_FERIAS);
                
                if($itemTotal && !$itemTotalPago){
                    $valor += $itemTotal->getVreventofolha();
                }
            }
            if($valor > 0){
                $evento_totalAdicional = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_PAGA_TOTAL_ADIC_FERIAS);
                $this->_itens_calculo_principal->geraEvento($evento_totalAdicional, null, $valor, 0, 1, 'NORMAL', $nrGozoFerias);
            }
        }
        
    }
    
    public function naoPagarAdicionalFerias(){
        
        $gozoFerias = $this->_gozo_ferias->procuraGozoFerias($this->_dtInicioGozo);
        
        if($gozoFerias && $gozoFerias->getIdnaopagaadic() == 'S'){
            
            $items = $this->_itens_calculo_principal->getItems();
            $valor = 0;
            
            $incideventoEntity = new FpaincideventoEntity($this->entityManager, $this->hcmParameters);
            $incideEventosNaoPagaAdic = $incideventoEntity->getEventos(
                $this->_mes_competencia, FpatipoincideEntity::NAOPAGAADICIONAL
            );
            
            foreach($items as $item){
                if(in_array($item->getNreventom(), $incideEventosNaoPagaAdic)){
                    $valor += $item->getVreventofolha();
                    $this->_itens_calculo_principal->removeItem($item);
                }
                
            }
            $evento_totalAdicional = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_TOTAL_ADIC_FERIAS);
            $this->_itens_calculo_principal->geraEvento($evento_totalAdicional, null, $valor, 0, 1, 'NORMAL');
        }
    }
    
    public function _calculaRemuneracaoBase(
        $vinculo, $itens_calculo, $nr_tipo_calculo, $incidencia = null
    ){
        $this->_geraReferenciaSalario(
            $itens_calculo, $nr_tipo_calculo, $vinculo->historico->getIdremuneracao(), $vinculo->getNrvinculom()
        );
        
        $this->_calculaSalario($itens_calculo);

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_REMUNERACAO, $nr_tipo_calculo, $itens_calculo
        );
        
        if($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){
            $this->_geraEventoRelacionado();
        }
        
        $this->_calculaFaltas($itens_calculo);
        $this->_calculaAdicionais($itens_calculo);
        
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_ADICIONAIS, $nr_tipo_calculo, $itens_calculo
        );
        
        if($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR || $this->_id_fazDifComp==FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_NAO){
            
            $this->_calculaReflexo($itens_calculo, FpatipoincideEntity::INC_REFLEXO_ADIC_NOTURNO, FpatipoassoceveEntity::ASSOC_REFLEXO_ADIC_NOTURNO);
        }

        $this->_calculaExtra($itens_calculo);
        
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_HORAS_EXTRAS, $nr_tipo_calculo, $itens_calculo
        );
        
        if($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR || $this->_id_fazDifComp==FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_NAO) {
            $this->_calculaReflexo($itens_calculo, FpatipoincideEntity::INC_REFLEXO_HORA_EXTRA, FpatipoassoceveEntity::ASSOC_REFLEXO_REP_REMUNERADO);
        }

        if ($incidencia !== null) {
            $aux = $itens_calculo->calculaIncidencias($incidencia, $this->_mes_competencia, $this->_eventom);
            $calculoEvento = 'Valor da Incidência '.$incidencia;
            $evento_base_rem = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_BASE_REMUNERACAO);
            MemoriaCalculo::getInstance()->escreveEventos($itens_calculo->getNrcalculofolha(), $evento_base_rem, $calculoEvento, $this->_mes_competencia, $aux,0,null,null, $incidencia,null);
            $itens_calculo->geraEvento($evento_base_rem, null, $aux, 0, 1);
            return $aux;
        }

    }

    public function _executaFolha($vinculo){

        $evento_base_rem = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_BASE_REMUN);
        $base_resc= $this->_calculaBase($this->_itens_calculo_principal, FpatipoincideEntity::INC_REMUN_MES, $this->_mes_competencia);
        MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_base_rem, $this->calculoEventoMemoria, $this->_mes_competencia, $base_resc,0,null,null,null,100);
        $this->_itens_calculo_principal->geraEvento($evento_base_rem, null, $base_resc, 0, 2);

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
        
        if (in_array(FpaProcessoEntity::FGTS, $this->_listaProcessos) === true) {

            if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
                $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
            } else{
                $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
            }

            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_CALC, FpatipoassoceveEntity::ASSOC_FGTS,
                FpatipoassoceveEntity::ASSOC_INCID_FGTS, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
        
        if (in_array(FpaProcessoEntity::INSS, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_INSS_CALC, FpatipoassoceveEntity::ASSOC_INSS_CALC,
                FpatipoassoceveEntity::ASSOC_INCID_INSS, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null, null, null, 0, false
            );
        }
        
        if (in_array(FpaProcessoEntity::INSS_SOCIOS, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_INSS_CALC_PRO_LABORE, FpatipoassoceveEntity::ASSOC_INSS_SOCIOS,
                FpatipoassoceveEntity::ASSOC_INCID_INSS_PRO_LABORE, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null, null, null, 0, true
            );
        }
        
        if (in_array(FpaProcessoEntity::INSS_AUTONOMO, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_INSS_CALC_AUTONOMO, FpatipoassoceveEntity::ASSOC_INSS_AUTONOMO,
                FpatipoassoceveEntity::ASSOC_INCID_INSS_AUTONOMO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null, null, null, 0, true
            );
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        if (in_array(FpaProcessoEntity::IRRF, $this->_listaProcessos) === true){
            IRRF::calcula(
                FpatipoincideEntity::INC_IRRF_CALC, FpatipoassoceveEntity::ASSOC_IRRF_CALC,
                FpatipoassoceveEntity::ASSOC_INCID_IRRF, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
            );
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
    }

    public function _executaFerias($vinculo, $tp_calc_mov){

        if (in_array(FpaProcessoEntity::DECIMO_TERCEIRO_SALARIO, $this->_listaProcessos) === true){
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS_13SAL));
            $this->_itens_13sal_resc = $obj_tp_calc_mov->getInstancia();
            if (count($this->_itens_13sal_resc->getItems()) > 0){
                $base = $this->_calculaRemuneracaoBase(
                   $vinculo, $this->_itens_13sal_resc, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_13SAL
                );
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_ADIANT_13SAL,
                    FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, $base, 100
                );
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_12AVOS,
                    FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, $base, 100/2
                );
                
                /*$obj_tp_calc_mov13 = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_13SAL));
                $this->_itens_13sal = $obj_tp_calc_mov13->getInstancia();

                $itensCalc = $this->_itens_calculo_principal->getItems();
                
                foreach($itensCalc as $item){
                    if($item->getNreventom() == FpatipoassoceveEntity::ASSOC_ADIANT_13SAL){
                        
                        $vrAdiantamento = $item->getVreventofolha();
                        
                        $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
                        $fgts = $vrAdiantamento / 100 * $percentual;
                        
                        //3030
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_LIQUIDO, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_13sal->geraEvento($evento, $this->_mes_competencia, $vrAdiantamento, 30, 1);
                        
                        //120
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_13sal->geraEvento($evento, $this->_mes_competencia, $vrAdiantamento, 30, 1);
                        
                        //3120
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_INCID_FGTS_13SAL, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_13sal->geraEvento($evento, $this->_mes_competencia, $vrAdiantamento, 30, 1);
                        
                        //2020
                        $evento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_FGTS_13SAL, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_13sal->geraEvento($evento, $this->_mes_competencia, $fgts, 30, 1);
                    }
                }*/
            }
        }

        if (in_array(FpaProcessoEntity::FERIAS, $this->_listaProcessos) === false){
            return;
        }
        
        $base = $this->_salario;
        $base_media = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_FERIAS, $this->_mes_competencia, $this->_eventom
        );
        $base_media = $base_media>$base ? $base_media-$base : 0;
        
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_FERIAS, 100,
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_1_PARTE, (100),
            $this->_mes_competencia, $base_media
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIC_FERIAS, (100/3),
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_1_PARTE, (100/3),
            $this->_mes_competencia, $base_media
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, 100,
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_2_PARTE, (100),
            $this->_mes_competencia, $base_media
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIC_2_PARTE, (100/3),
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_2_PARTE, (100/3),
            $this->_mes_competencia, $base_media
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO, 100,
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIC_ABONO, (100/3),
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_MEDIA_ABONO_PECUNIARIO, 100,
            $this->_mes_competencia, $base_media
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_ABONO, (100/3),
            $this->_mes_competencia, $base_media
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_FERIAS_DOBRA, 100,
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIC_FERIAS_DOBRA, (100/3),
            $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_PROVIS_FERIAS_DB,
            $this->_vrPercentualProvisao, $this->_mes_competencia, $base
        );
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_PROVIS_2_PARTE_DB,
            $this->_vrPercentualProvisao, $this->_mes_competencia, $base
        );
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
        
        if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
            $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
        } else{
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        }
        
        $this->naoPagarAdicionalFerias();
        
        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_FERIAS, FpatipoassoceveEntity::ASSOC_FGTS_FERIAS,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_FERIAS, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );
        
        /*FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_13SAL, FpatipoassoceveEntity::ASSOC_FGTS_13SAL,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );*/

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        $qtdMaxFerias = $this->_gozo_ferias->getDias1aParte() + $this->_gozo_ferias->getDias2aParte();
        $proporcao = $this->_gozo_ferias->getDias2aParte() / $qtdMaxFerias;
        
        INSS::calcula(
            FpatipoincideEntity::INC_INSS_FERIAS, FpatipoassoceveEntity::ASSOC_INSS_FERIAS,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_FERIAS, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null,
            FpatipoassoceveEntity::ASSOC_INSS_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $proporcao,
            false
        );
        /*INSS::calcula(
            FpatipoincideEntity::INC_INSS_13SAL, FpatipoassoceveEntity::ASSOC_INSS_13SAL,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null,null,null,0,false
        );*/

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_FERIAS, FpatipoassoceveEntity::ASSOC_IRRF_FERIAS,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_FERIAS, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );
        
        /*IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_13SAL, FpatipoassoceveEntity::ASSOC_IRRF_13SAL,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );*/

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        $base_pensao = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_PENSAO_FERIAS, $this->_mes_competencia, $this->_eventom
        );

        if($base_pensao != 0){
            $recuperareferencia1=0;
            $recuperareferencia2=0;
            $recuperareferencia3=0;
            
            $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FERIAS, $this->_eventom, $this->_nrorg
            );
            $recuperareferencia1=$this->_itens_calculo_principal->retornaReferenciaPorEvento($eventoAux, $this->_mes_competencia);

            $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
            );
            $mes_2_parte = DateUtil::adicionaIntervalo($this->_mes_competencia, 1, DateUtil::MES);
            $recuperareferencia2=$this->_itens_calculo_principal->retornaReferenciaPorEvento($eventoAux, $mes_2_parte);

            $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO, $this->_eventom, $this->_nrorg
            );
            $recuperareferencia3=$this->_itens_calculo_principal->retornaReferenciaPorEvento($eventoAux, $this->_mes_competencia);

            $diasproporcao=$recuperareferencia1+$recuperareferencia2+$recuperareferencia3;

            if($recuperareferencia1>0){
                $valor=$base_pensao/$diasproporcao*($recuperareferencia1+$recuperareferencia3);
                $calculoEvento = $base_pensao.' (Base) / '.$diasproporcao.' (Dias Proporção) * '.$recuperareferencia1+$recuperareferencia3.'(Referência)';
                $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_PENSAO_FERIAS, $this->_eventom, $this->_nrorg
                );
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAux, $calculoEvento, $this->_mes_competencia, $valor, $recuperareferencia1+$recuperareferencia3,null, $base_pensao,null,100);
                $this->_itens_calculo_principal->geraEvento($eventoAux, $this->_mes_competencia, $valor, $recuperareferencia1+$recuperareferencia3,1);
            }
            if($recuperareferencia2>0) {
                $valor=$base_pensao/$diasproporcao*$recuperareferencia2;
                $calculoEvento = $base_pensao.' (Base) / '.$diasproporcao.' (Dias Proporção) * '.$recuperareferencia2.'(Referência)';
                $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_PENSAO_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
                );
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAux, $calculoEvento, $mes_2_parte, $valor, $recuperareferencia2,null, $base_pensao,null,100);
                $this->_itens_calculo_principal->geraEvento($eventoAux, $mes_2_parte, $valor, $recuperareferencia2,1);
            }
        }
    }

    public function _executaPLR($vinculo, $nr_tipo_calculo, $tp_calc_mov){

        if (in_array(FpaProcessoEntity::PLR, $this->_listaProcessos) === false) {
            return;
        }

        $base = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_PLR, $this->_mes_competencia, $this->_eventom
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
        if ($nr_tipo_calculo === FpatipocalculoEntity::CALC_PLR) {
            IRRF::calcula(
                FpatipoincideEntity::INC_IRRF_PLR, FpatipoassoceveEntity::ASSOC_IRRF_PLR,
                FpatipoassoceveEntity::ASSOC_INCID_IRRF_PLR, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo,
                true
            );
        }
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

    }

    public function _executa13Sal($vinculo, $nr_tipo_calculo, $tp_calc_mov){

        if (in_array(FpaProcessoEntity::DECIMO_TERCEIRO_SALARIO, $this->_listaProcessos) === false) {
            return;
        }
        $evento = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_ADIC_PERICULO, $this->_eventom, $this->_nrorg
        );
        $posicao = $this->_itens_calculo_principal->procuraEvento($evento, null);
        if ($posicao !== -1) {
            $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_SIM);
        }
        $evento = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_ADIC_INSALUBRE, $this->_eventom, $this->_nrorg
        );
        $posicao = $this->_itens_calculo_principal->procuraEvento($evento, null);
        if ($posicao !== -1) {
            $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_SIM);
        }

        $base = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_13SAL, $this->_mes_competencia, $this->_eventom
        );

        if ($nr_tipo_calculo === FpatipocalculoEntity::CALC_13SAL) {
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_13SAL, 100,
                $this->_mes_competencia, $base
            );
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_13_SAL_MATERNIDADE, 100,
                $this->_mes_competencia, $base/12
            );
            
            //Separa medias
            $eventom_110 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_13SAL);
            $indice = $this->_itens_calculo_principal->procuraEvento($eventom_110);
            $evento_110 = $this->_itens_calculo_principal->getItem($indice);
            
            $eventom_10 = $this->_eventom->retornaEvento(10);
            $indice = $this->_itens_calculo_principal->procuraEvento($eventom_10);
            $eventoSalario10 = $this->_itens_calculo_principal->getItem($indice);
            
            $eventom_20 = $this->_eventom->retornaEvento(20);
            $indice = $this->_itens_calculo_principal->procuraEvento($eventom_20);
            $eventoSalario20 = $this->_itens_calculo_principal->getItem($indice);
            
            $salario = 0;
            
            $salario += $eventoSalario10 ? $eventoSalario10->getVreventofolha() : 0;
            $salario += $eventoSalario20 ? $eventoSalario20->getVreventofolha() : 0;
            
            $valor = $evento_110->getVreventofolha() - (($salario / 12) * $evento_110->getVrreffolha());
            
            $evento_125 = $this->_eventom->retornaEvento(125);
            $this->_itens_calculo_principal->geraEvento($evento_125, null, $valor, $evento_110->getVrreffolha(), 1);
            

        } else {
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, 100,
                $this->_mes_competencia, $base
            );
            $evento_base = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_13SAL_12AVOS);
            $indice = $this->_itens_calculo_principal->procuraEvento($evento_base, null);
            if ($indice !== -1) {
                $base = $this->_itens_calculo_principal->retornaValor($indice);
            } else {
                $base = 0.0;
            }
            
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, 100,
                $this->_mes_competencia, $base
            );
            
            //Separa medias 13 adiantamento
            $eventom_base = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_13SAL_12AVOS);
            $indice = $this->_itens_calculo_principal->procuraEvento($eventom_base);
            $eventoBase = $this->_itens_calculo_principal->getItem($indice);
            
            $eventom_Adiantamento = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_ADIANT_13SAL);
            $indice = $this->_itens_calculo_principal->procuraEvento($eventom_Adiantamento);
            $eventoAdiantamento = $this->_itens_calculo_principal->getItem($indice);
            
            $eventom_10 = $this->_eventom->retornaEvento(10);
            $indice = $this->_itens_calculo_principal->procuraEvento($eventom_10);
            $eventoSalario10 = $this->_itens_calculo_principal->getItem($indice);
            
            $eventom_20 = $this->_eventom->retornaEvento(20);
            $indice = $this->_itens_calculo_principal->procuraEvento($eventom_20);
            $eventoSalario20 = $this->_itens_calculo_principal->getItem($indice);
            
            $salario = 0;
            
            $salario += $eventoSalario10 ? $eventoSalario10->getVreventofolha() : 0;
            $salario += $eventoSalario20 ? $eventoSalario20->getVreventofolha() : 0;
            
            $valor = ($eventoBase->getVreventofolha() - (($salario / 12) * $eventoBase->getVrreffolha())) / 2;
            
            $evento_124 = $this->_eventom->retornaEvento(124);
            $this->_itens_calculo_principal->geraEvento($evento_124, null, $valor, $eventoBase->getVrreffolha(), 1);
            
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
            $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
        } else{
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        }

        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_13SAL, FpatipoassoceveEntity::ASSOC_FGTS_13SAL,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
        
        if ($nr_tipo_calculo === FpatipocalculoEntity::CALC_13SAL) {
            INSS::calcula(
                FpatipoincideEntity::INC_INSS_13SAL, FpatipoassoceveEntity::ASSOC_INSS_13SAL,
                FpatipoassoceveEntity::ASSOC_INCID_INSS_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null,null,null,0,false
            );

            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
            );

            IRRF::calcula(
                FpatipoincideEntity::INC_IRRF_13SAL, FpatipoassoceveEntity::ASSOC_IRRF_13SAL,
                FpatipoassoceveEntity::ASSOC_INCID_IRRF_13SAL, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
            );

            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
            );

        }
    }
    
    public function _executaRescisaocomplementar($vinculo, $tp_calc_mov){

        $this->_recalculo=true;
        if($this->_id_fazDifComp==FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_NAO) {
            unset($this->_listaDireitos);
        }
        $this->_executaRescisao($vinculo, $tp_calc_mov);
    }
    
    public function _executaRescisao($vinculo, $tp_calc_mov){

        if (in_array(FpaProcessoEntity::RESCISAO, $this->_listaProcessos) === false) {
            return;
        }
        $diasExp1 =$vinculo->getNrdiascontratoexp() ?$vinculo->getNrdiascontratoexp()-1 : 0;
        $diasExp2 =$vinculo->getNrdiascontratoexppro() ?$vinculo->getNrdiascontratoexppro() : 0;

        $this->_dt_fim_exp1 = DateUtil::adicionaIntervalo($vinculo->getDtadmissaovinc(), $diasExp1);
        $this->_dt_fim_exp2 = DateUtil::adicionaIntervalo($vinculo->getDtadmissaovinc(), $diasExp1 + $diasExp2);

        $dtRescisao = DateUtil::adicionaIntervalo($vinculo->getDtrescisaovinc());
        if (in_array(FpaTipodireitoEntity::AVISO_PREVIO, $this->_listaDireitos) === true && ($this->_dt_fim_exp1 < $dtRescisao &&
                $this->_dt_fim_exp2 < $dtRescisao)){
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_AVISO_PREVIO_RESC));
            $this->_itens_aviso_previo = $obj_tp_calc_mov->getInstancia();
        
            if (count($this->_itens_aviso_previo->getItems()) > 0){
                $this->_calculo_regra->executaPontoRegra(
                    $this->_idDebug, FpaPtregraEntity::PTREGRA_CALC_AVISO_PREVIO_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO, $this->_itens_aviso_previo
                );
                $base = $this->_calculaRemuneracaoBase(
                   $vinculo, $this->_itens_aviso_previo, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_AVISO_PREVIO
                );
                
                if($vinculo->getDtavisoprevio() && DateUtil::getDataDeString($vinculo->getDtrescisaovinc())->format('d/m/Y') == DateUtil::getDataDeString($vinculo->getDtavisoprevio())->format('d/m/Y')){
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN,
                        FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_INDEN, $base, 100
                    );
                }
                
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_aviso_previo, FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ,
                    FpatipoassoceveEntity::ASSOC_COMPL_AV_PREV_INDZ, $base, 100
                );
            }
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_INDENIZ_DISSIDIO, 100,
                $this->_mes_competencia, 0.0
            );
            
        }else{
            if(($this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_RESCISAO)
                ||($this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR
                    && $this->_id_fazDifComp==FpaformrescisaoEntity::ID_FAZDIFERENCACOMP_SIM)
            ){
                $this->_calculaDiversos(
                    $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_INDENIZ_ART_480, 100,
                    $this->_mes_competencia, 0.0
                );
            }
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_INDENIZ_ART_479, 100,
                $this->_mes_competencia, 0.0
            );
        }
        
        if (in_array(FpaTipodireitoEntity::AVISO_PREVIO_DESC, $this->_listaDireitos)=== true){
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_AVISO_PREVIO_DESC, 100,
                $this->_mes_competencia, 0.0
            );
        }
        
        if (in_array(FpaTipodireitoEntity::FERIAS_VENCIDAS, $this->_listaDireitos) === true){
            $obj_tp_calc_mov =$tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS_VENC_RESC);
            foreach ($obj_tp_calc_mov as $obj) {
                $this->_itens_ferias_vencidas_rescisao =  $obj->getInstancia();
                if (count($this->_itens_ferias_vencidas_rescisao->getItems()) > 0){
                    $this->_calculo_regra->executaPontoRegra(
                        $this->_idDebug, FpaPtregraEntity::PTREGRA_CALC_FERIAS_VENCIDAS_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO, $this->_itens_ferias_vencidas_rescisao
                    );
                    $base = $this->_calculaRemuneracaoBase(
                       $vinculo, $this->_itens_ferias_vencidas_rescisao, FpatipocalculoEntity::CALC_FERIAS,
                        FpatipoincideEntity::INC_FERIAS
                    );
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC,
                        FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC, $base, 100
                    );
                    if (in_array(FpaTipodireitoEntity::FERIAS_VENCIDAS_ADICIONAL, $this->_listaDireitos) === true){
                        $this->_geraEventoProvisaoRescisao(
                            $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES,
                            FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES, $base, 33.333
                        );
                    }
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_FER_VENC_RESC_DOBRO,
                        FpatipoassoceveEntity::ASSOC_FER_VENC_RESC_DOBRO, $base, 100
                    );
                    if (in_array(FpaTipodireitoEntity::FERIAS_VENCIDAS_ADICIONAL, $this->_listaDireitos) === true){
                        $this->_geraEventoProvisaoRescisao(
                            $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_AD_FER_VENC_RESC_DOBRO,
                            FpatipoassoceveEntity::ASSOC_AD_FER_VENC_RESC_DOBRO, $base, 33.333
                        );
                    }
                }
            }
        }

        if (in_array(FpaTipodireitoEntity::FERIAS_PROPORCIONAIS, $this->_listaDireitos) === true){
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS_PROP_RESC));
            $this->_itens_ferias_proporcionais_rescisao = $obj_tp_calc_mov->getInstancia();
            if (count($this->_itens_ferias_proporcionais_rescisao->getItems()) > 0){
                $this->_calculo_regra->executaPontoRegra(
                    $this->_idDebug, FpaPtregraEntity::PTREGRA_CALC_FERIAS_PROPORCIONAIS_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO, $this->_itens_ferias_proporcionais_rescisao
                );
                $base = $this->_calculaRemuneracaoBase(
                   $vinculo, $this->_itens_ferias_proporcionais_rescisao, FpatipocalculoEntity::CALC_FERIAS,
                    FpatipoincideEntity::INC_FERIAS
                );
                
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC,
                    FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $base, 100
                );
                
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL,
                    FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL, $base, 100
                );
                
                $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL, $this->_eventom, $this->_nrorg
                );
                $refeventoAux=$this->_itens_ferias_proporcionais_rescisao->retornaReferenciaPorEvento($eventoAux);
                
                $eventoAuxCompl = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL_COMPL, $this->_eventom, $this->_nrorg
                );
                $refeventoAuxCompl=$this->_itens_ferias_proporcionais_rescisao->retornaReferenciaPorEvento($eventoAuxCompl);
                
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL,
                    FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL, 0, 0
                );
                $this->_geraEventoProvisaoRescisao(
                    $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL_COMPL,
                    FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL_COMPL, 0, 0
                );

                $this->_itens_ferias_proporcionais_rescisao->retiraitem($eventoAux);
                $this->_itens_ferias_proporcionais_rescisao->retiraitem($eventoAuxCompl);
                
                $evento = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC, $this->_eventom, $this->_nrorg);
                $refeventoOriginal=$this->_itens_ferias_proporcionais_rescisao->retornaReferenciaPorEvento($evento);

                $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha', $refeventoAux);
                $this->_itens_ferias_proporcionais_rescisao->alteratributoitem($evento,'Vrreffolha', $refeventoAux);
                $this->_itens_calculo_principal->alteratributoitem($eventoAux,'Vrreffolha', $refeventoOriginal);

                $evento=$this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC_COMPL, $this->_eventom, $this->_nrorg);
                $refeventoOriginalCompl=$this->_itens_ferias_proporcionais_rescisao->retornaReferenciaPorEvento($evento);

                $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha', $refeventoAuxCompl);
                $this->_itens_ferias_proporcionais_rescisao->alteratributoitem($evento,'Vrreffolha', $refeventoAuxCompl);
                $this->_itens_calculo_principal->alteratributoitem($eventoAuxCompl,'Vrreffolha', $refeventoOriginalCompl);

                if (in_array(FpaTipodireitoEntity::FERIAS_PROPORCIONAIS_ADICIONAL, $this->_listaDireitos) === true){
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP,
                        FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $base, 33.333
                    );
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL,
                        FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL, $base, 33.333
                    );
                    $evento = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP, $this->_eventom, $this->_nrorg);
                    $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha', $refeventoAux);
                    $this->_itens_ferias_proporcionais_rescisao->alteratributoitem($evento,'Vrreffolha', $refeventoAux);
                    
                    $evento=$this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP_COMPL, $this->_eventom, $this->_nrorg);
                    $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha', $refeventoAuxCompl);
                    $this->_itens_ferias_proporcionais_rescisao->alteratributoitem($evento,'Vrreffolha', $refeventoAuxCompl);
                }
            }
        }
        if (in_array(FpaTipodireitoEntity::DECIMO_TERCEIRO_SALARIO, $this->_listaDireitos) === true){
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_13SAL_RESC));
            $this->_itens_13sal_resc = $obj_tp_calc_mov->getInstancia();
           
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_13SAL));
            $itens13 = $obj_tp_calc_mov->getInstancia();
            
            //if(count($itens13->getItems()) > 0 && $this->_mes_competencia->format('m') == '12') {
            //    $itens = $this->_itens_calculo_principal->getItems();
            //    foreach($itens as $item){
            //        if($item->getNreventom() == 600 || $item->getNreventom() == 580){
            //            $this->_itens_calculo_principal->removeItem($item);
            //        }
            //    }
            //}else{
                if (count($this->_itens_13sal_resc->getItems()) > 0){
                    $this->_calculo_regra->executaPontoRegra(
                        $this->_idDebug, FpaPtregraEntity::PTREGRA_CALC_13_SALARIO_RESCISAO, FpatipocalculoEntity::CALC_RESCISAO, $this->_itens_13sal_resc
                    );
    
                    $base = $this->_calculaRemuneracaoBase(
                       $vinculo, $this->_itens_13sal_resc, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_13SAL
                    );
                    
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_RESC,
                        FpatipoassoceveEntity::ASSOC_13SAL_RESC, $base, 100
                    );
                    $this->_geraEventoProvisaoRescisao(
                        $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC,
                        FpatipoassoceveEntity::ASSOC_13SAL_COMPL_RESC, $base, 100
                    );
                }
            //}
        }

        if ($this->_nrorg==20){
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_MEDIA_MENSAL));
            $this->_itens_media_mensal = $obj_tp_calc_mov->getInstancia();

            if (count($this->_itens_media_mensal->getItems()) > 0){
                $base = $this->_calculaRemuneracaoBase(
                       $vinculo, $this->_itens_media_mensal, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_MEDIA_MENSAL
                    ) - $this->_salario;
                $calculoEvento = 'Base Remuneração';
                $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_MEDIA_MENSAL, $this->_eventom, $this->_nrorg
                );
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAux, $calculoEvento, $this->_mes_competencia, $base,0,null, $base,null,100);
                $this->_itens_calculo_principal->geraEvento($eventoAux, $this->_mes_competencia, $base,0,1);

            }
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
            $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
        } else{
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
        }

        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_RESC, FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
        );
        FGTS::calcula(
            FpatipoincideEntity::INC_FGTS_FERESC, FpatipoassoceveEntity::ASSOC_FGTS_FERIAS_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_FGTS_FERIAS_RESC, $this->_mes_competencia,
            $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $percentual,
            $this->_nrorg
        );

        if (in_array(FpaTipodireitoEntity::FGTS_PAGO, $this->_listaDireitos) === true){
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_13SAL_RESC,
                FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia,
                $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $percentual,
                $this->_nrorg
            );
        }

        if (in_array(FpaTipodireitoEntity::FGTS_DEPOSITADO, $this->_listaDireitos) === true){
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_13_RESCISAO,
                FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }
        
        if (in_array(FpaTipodireitoEntity::MULTA_FGTS_PAGO, $this->_listaDireitos) === true){
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS_RESC_MULTA);
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_IND_RESCISAO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_RESCISAO,
                FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );

            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_IND_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_BANCO,
                FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }

        if (in_array(FpaTipodireitoEntity::MULTA_FGTS_DEPOSITADO, $this->_listaDireitos) === true){
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS_RESC_MULTA);
            
            if($vinculo->getNrtpdemissao() == FpaTpdemissaoEntity::ACORDO_ENTRE_PARTES){
                $percentual = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, FpaValorreferenciamEntity::FGTS_RESC_MULTA_ACORDO);
            }
            
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_IND_RESCISAO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_RESCISAO_ENC,
                FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );

            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_IND_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_IND_BANCO_ENC,
                FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );

            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_IND_13_RESCISAO_ENC,
                FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual * 8/100, $this->_nrorg
            );
        }

        if (in_array(FpaTipodireitoEntity::MULTA_CONTRIBUICAO_SOCIAL, $this->_listaDireitos) === true){
            $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::CONTRIB_SOC_RESC);
            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_CONTR_SOC_RESC_ENC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_RESC_ENC,
                FpatipoassoceveEntity::ASSOC_FGTS_RESC_DEPOSITADO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );

            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_CONTR_SOC_BANCO_ENC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_BANCO_ENC,
                FpatipoassoceveEntity::ASSOC_FGTS_TOTAL_BANCO, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );

            FGTS::calcula(
                FpatipoincideEntity::INC_FGTS_13RESC, FpatipoassoceveEntity::ASSOC_FGTS_CONTR_SOC_13_RESC_ENC,
                FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual * 8/100, $this->_nrorg
            );
        }

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_FGTS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        INSS::calcula(
            FpatipoincideEntity::INC_INSS_RESC, FpatipoassoceveEntity::ASSOC_INSS_RESCISAO,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null,null,null,0,false
        );
        INSS::calcula(
            FpatipoincideEntity::INC_INSS_FERESC, FpatipoassoceveEntity::ASSOC_INSS_FERIAS_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_FERIAS_RESC, $this->_mes_competencia,
            $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null
        );
        INSS::calcula(
            FpatipoincideEntity::INC_INSS_13RESC, FpatipoassoceveEntity::ASSOC_INSS_13SAL_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_INSS_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_nrorg, null,null,null,0,false
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_INSS, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_RESC, FpatipoassoceveEntity::ASSOC_IRRF_RESCISAO,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_FERESC, FpatipoassoceveEntity::ASSOC_IRRF_FERIAS_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_FERIAS_RESC, $this->_mes_competencia,
            $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia,
           $vinculo, $this->_idIRAcumulaRecMinimo
        );

        IRRF::calcula(
            FpatipoincideEntity::INC_IRRF_13RESC, FpatipoassoceveEntity::ASSOC_IRRF_13SAL_RESC,
            FpatipoassoceveEntity::ASSOC_INCID_IRRF_13_RESC, $this->_mes_competencia, $this->_itens_calculo_principal,
            $this->_assoc_eventos, $this->_eventom, $this->_valores_referencia, $vinculo, $this->_idIRAcumulaRecMinimo
        );

        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_IRRF, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
    }

    public function _executaProvisaoContabil($vinculo, $tp_calc_mov){
        if (in_array(FpaProcessoEntity::PROVISAO, $this->_listaProcessos) === false){
            return;
        }
       
        $incideventoEntity = new FpaincideventoEntity($this->entityManager, $this->hcmParameters);
        $incideDemonstraFolha = $incideventoEntity->getEventos(
        	$this->_mes_competencia, FpatipoincideEntity::COMP_SAL_PROVISAO
        );
        
        $valorComplemento = 0;
        $valorComplemento = $this->_calculaRemuneracaoBase(
           $vinculo, $this->_itens_calculo_principal, FpatipocalculoEntity::CALC_FOLHA,
            FpatipoincideEntity::COMP_SAL_PROVISAO
        );
            
        $obj_tp_calc_mov =$tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_PROV_FERIAS_VENC);
        foreach ($obj_tp_calc_mov as $obj) {
            $this->_itens_ferias_vencidas_rescisao =  $obj->getInstancia();
            
            $base = $this->_calculaRemuneracaoBase(
               $vinculo, $this->_itens_ferias_vencidas_rescisao, FpatipocalculoEntity::CALC_FERIAS,
                FpatipoincideEntity::INC_FERIAS
            );
            
            $base += $valorComplemento;
            
            $this->_geraEventoProvisaoRescisao(
                $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_VENC_RESC,
                FpatipoassoceveEntity::ASSOC_PROV_FERIAS_VENC, $base, 100
            );

            $this->_geraEventoProvisaoRescisao(
                $this->_itens_ferias_vencidas_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FER_VENC_RES,
                FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_VENC, $base, 33.3333333333333
            );
            
            $vr_media = ($base - $valorComplemento) - $this->_salario;
            $evento_media = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_PROV_MEDIAS_FERIAS_VENC, $this->_eventom, $this->_nrorg
            );
            
            $evento_Aux=$this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_PROV_FERIAS_VENC, $this->_eventom, $this->_nrorg
            );
            $dt_ocorr=$this->_itens_calculo_principal->retornaDtOcorrenciaPorEvento($evento_Aux);
            $this->_itens_calculo_principal->geraEvento($evento_media, $dt_ocorr, $vr_media,0,1);
        }
        
        //Ferias proporcional.
        $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_PROV_FERIAS_PROP));
        $this->_itens_ferias_proporcionais_rescisao = $obj_tp_calc_mov->getInstancia();
        
        $baseFerProp = $this->_calculaRemuneracaoBase(
           $vinculo, $this->_itens_ferias_proporcionais_rescisao, FpatipocalculoEntity::CALC_FERIAS,
            FpatipoincideEntity::INC_FERIAS
        );
        
        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC,
            FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PROP, $baseFerProp, 100
        );
        
        $this->_geraEventoProvisaoRescisao(
            $this->_itens_ferias_proporcionais_rescisao, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP,
            FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PROP, $baseFerProp, 33.3333333333333
        );
        
        $baseFerProp += $valorComplemento;

        $vr_media = ($baseFerProp - $valorComplemento) - $this->_salario;
        $evento_media = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_PROV_MEDIAS_FERIAS_PROP, $this->_eventom, $this->_nrorg
        );
        $evento_Aux=$this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PROP, $this->_eventom, $this->_nrorg
        );
        $dt_ocorr=$this->_itens_calculo_principal->retornaDtOcorrenciaPorEvento($evento_Aux);
        $this->_itens_calculo_principal->geraEvento($evento_media, $dt_ocorr, $vr_media,0,1);

        $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_AUX_AVO_INTEGRAL, $this->_eventom, $this->_nrorg
        );
        $refeventoAux=$this->_itens_ferias_proporcionais_rescisao->retornaReferenciaPorEvento($eventoAux);

        $this->_itens_ferias_proporcionais_rescisao->retiraitem($eventoAux);
        
        $evento = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PROP, $this->_eventom, $this->_nrorg);
        $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha', $refeventoAux);

        $evento=$this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PROP, $this->_eventom, $this->_nrorg);
        $this->_itens_calculo_principal->alteratributoitem($evento,'Vrreffolha', $refeventoAux);

        // 13 Provisao.
        $obj_tp_calc_mov = current(
           $tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_PROV_13SAL)
        );
        $this->_itens_13sal_resc = $obj_tp_calc_mov->getInstancia();
        
        $base = $this->_calculaRemuneracaoBase(
           $vinculo, $this->_itens_13sal_resc, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_13SAL
        );
        
        $base += $valorComplemento;
        
        $vr_media = ($base - $valorComplemento) - $this->_salario;
        $evento_media = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_PROV_MEDIAS_13SAL, $this->_eventom, $this->_nrorg
        );
        $this->_itens_calculo_principal->geraEvento($evento_media,null, $vr_media,0,1);

        $this->_geraEventoProvisaoRescisao(
            $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_13SAL_RESC,
            FpatipoassoceveEntity::ASSOC_PROV_13SAL_CONT, $base, 100
        );
         
        $divisorFixoProv = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'VR_DIV_FIXO_PROVISAO');
        if($divisorFixoProv){
        // Férias Proporcionais
            $this->_geraEventoProvisaoRescisao(
                $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_FERIAS_PROPORC,
                FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PROP, $base, 100
            );
            // 1/3 Férias Proporcionais
            $this->_geraEventoProvisaoRescisao(
                $this->_itens_13sal_resc, FpatipoassoceveEntity::ASSOC_ADIC_FERI_PROP,
                FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PROP, $base, 33.3333333333333
            );
        }
        
        /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
        /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-ENCARGOS DA PROVISÃO-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
        /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
        
        /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-FERIAS VENCIDAS=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
        
        if (in_array(FpaProcessoEntity::FGTS, $this->_listaProcessos) === true) {

            if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
                $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
            } else{
                $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
            }
            FGTS::calcula(
                FpatipoincideEntity::INC_ENC_2_PROV_FER_VENC, FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_VENC,
                FpatipoassoceveEntity::ASSOC_BASE_ENC2_PROV_FER_VENC, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }
        
        if (in_array(FpaProcessoEntity::INSS, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_ENC_1_PROV_FER_VENC, FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_VENC,
                FpatipoassoceveEntity::ASSOC_BASE_ENC1_PROV_FER_VENC, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_vrEnc1Ferias, null, null, 0, false
            );
        }
        /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=FERIAS PROPORCIONAIS=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
        
        if (in_array(FpaProcessoEntity::FGTS, $this->_listaProcessos) === true) {

            if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
                $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
            } else{
                $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
            }
            
            FGTS::calcula(
                FpatipoincideEntity::INC_ENC_2_PROV_FER_PROP, FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_PROP,
                FpatipoassoceveEntity::ASSOC_BASE_ENC2_PROV_FER_PROP, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }
        
        if (in_array(FpaProcessoEntity::INSS, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_ENC_1_PROV_FER_PROP, FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_PROP,
                FpatipoassoceveEntity::ASSOC_BASE_ENC1_PROV_FER_PROP, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_vrEnc1Ferias, null, null, 0, false
            );
        }

        /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-DECIMO TERCEIRO=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
        
        if (in_array(FpaProcessoEntity::FGTS, $this->_listaProcessos) === true) {

            if ($vinculo->getNrvinculoempreg() == GpevinculohEntity::VINCULO_EMPREGATICIO_MENOR_APRENDIZ) {
                $percentual = GpevinculohEntity::PERCENTUAL_FGTS_MENOR_APRENDIZ;
            } else{
                $percentual = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::FGTS);
            }
            FGTS::calcula(
                FpatipoincideEntity::INC_ENC_2_PROV_DEC_TERC, FpatipoassoceveEntity::ASSOC_ENC2_13SAL_CONT,
                FpatipoassoceveEntity::ASSOC_BASE_ENC2_PROV_DEC_TERC, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $percentual, $this->_nrorg
            );
        }
        
        if (in_array(FpaProcessoEntity::INSS, $this->_listaProcessos) === true) {
            INSS::calcula(
                FpatipoincideEntity::INC_ENC_1_PROV_DEC_TERC, FpatipoassoceveEntity::ASSOC_ENC1_13SAL_CONT,
                FpatipoassoceveEntity::ASSOC_BASE_ENC1_PROV_DEC_TERC, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $this->_nrorg, $this->_vrEnc1DecTerceiro, null, null, 0, false
            );
        }

        /*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-CALCULA DIFERENÇA=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
        
        $gera_diferença = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'ID_GER_DIF_PROVISAO');
        
        if($gera_diferença == '1') {
            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_CALC_ESPECIFICO, $this->_nr_tipo_calculo
            );

            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_MENSAL, 0));
            $this->_itens_provisao_mes_anterior = $obj_tp_calc_mov->getInstancia();

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_FERIAS_VENC,
                FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_VENC, $this->_mes_competencia
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_VENC,
                FpatipoassoceveEntity::ASSOC_DIF1_FERIAS_VENC, $this->_mes_competencia
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_VENC,
                FpatipoassoceveEntity::ASSOC_DIF2_FERIAS_VENC, $this->_mes_competencia
            );
            
            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_VENC,
                FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_VENC, $this->_mes_competencia
            );

          /*  $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_VENC,
                FpatipoassoceveEntity::ASSOC_DIF1_ADIC_FERIAS_VENC, $this->_mes_competencia
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_VENC,
                FpatipoassoceveEntity::ASSOC_DIF2_ADIC_FERIAS_VENC, $this->_mes_competencia
            );*/

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PROP,
                FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_PROP, null
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_PROP,
                FpatipoassoceveEntity::ASSOC_DIF1_FERIAS_PROP, null
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_PROP,
                FpatipoassoceveEntity::ASSOC_DIF2_FERIAS_PROP, null
            );
            /*
            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PRO_COMP,
                FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_PRO_COMP, null
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_FERIAS_PRO_COMP,
                FpatipoassoceveEntity::ASSOC_DIF1_FERIAS_PRO_COMP, null
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_FERIAS_PRO_COMP,
                FpatipoassoceveEntity::ASSOC_DIF2_FERIAS_PRO_COMP, null
            );*/
            
            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PROP,
                FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_PROP, null
            );

         /*   $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_PROP,
                FpatipoassoceveEntity::ASSOC_DIF1_ADIC_FERIAS_PROP, null
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_PROP,
                FpatipoassoceveEntity::ASSOC_DIF2_ADIC_FERIAS_PROP, null
            );
            
            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_ADIC_FERIAS_PRO_COMP,
                FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_PRO_COMP, null
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_ADIC_FERIAS_PRO_COMP,
                FpatipoassoceveEntity::ASSOC_DIF1_ADIC_FERIAS_PRO_COMP, null
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_ADIC_FERIAS_PRO_COMP,
                FpatipoassoceveEntity::ASSOC_DIF2_ADIC_FERIAS_PRO_COMP, null
            );*/

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_13SAL_CONT,
                FpatipoassoceveEntity::ASSOC_DIFP_13SAL_CONT, $this->_mes_competencia
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_13SAL_CONT,
                FpatipoassoceveEntity::ASSOC_DIF1_13SAL_CONT, $this->_mes_competencia
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_13SAL_CONT,
                FpatipoassoceveEntity::ASSOC_DIF2_13SAL_CONT, $this->_mes_competencia
            );
            /*
            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_PROV_13SAL_CONT_COMP,
                FpatipoassoceveEntity::ASSOC_DIFP_13SAL_CONT_COMP, $this->_mes_competencia
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC1_13SAL_CONT_COMP,
                FpatipoassoceveEntity::ASSOC_DIF1_13SAL_CONT_COMP, $this->_mes_competencia
            );

            $this->_geraDiferencaAvo(
                $this->_itens_provisao_mes_anterior, FpatipoassoceveEntity::ASSOC_ENC2_13SAL_CONT_COMP,
                FpatipoassoceveEntity::ASSOC_DIF2_13SAL_CONT_COMP, $this->_mes_competencia
            );*/
        }
    }
    
    private function _geraDiferencaAvo(
        $item_calc_fonte, $assoc_fonte, $assoc_destino, $dt_ocorrencia_destino = null
    ){
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($assoc_fonte, $this->_eventom, $this->_nrorg);
        $posicoes = $item_calc_fonte->retornaItens($evento_aux);
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($assoc_destino, $this->_eventom, $this->_nrorg);
        
        foreach ($posicoes as $indice) {
            $referencia = $item_calc_fonte->retornaReferencia($indice);
            $valor_item = $item_calc_fonte->retornaValor($indice);
            if ($dt_ocorrencia_destino === null) {
                $dtocorrencia = $item_calc_fonte->retornaDtocorrencia($indice);
            } else {
                $dtocorrencia = $dt_ocorrencia_destino;
            }

            /*bloco para tratar valor de férias vencidas e encargos que deve sempre ser sobre 1/12*/
            if($assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_VENC
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIF1_FERIAS_VENC
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIF2_FERIAS_VENC
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_VENC
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIF1_ADIC_FERIAS_VENC
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIF2_ADIC_FERIAS_VENC)
            {
                $valor_item=($valor_item/12);
            }
            /*bloco para tratar referencia apenas de férias vencidas que deve sempre ser 1/12*/
            if($assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_VENC
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_VENC)
            {
                $referencia=2.5;
            }
            /*bloco para tratar valor de férias proporcionais e encargos que deve sempre ser sobre 1/12*/
            if(   $assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_PROP
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIF1_FERIAS_PROP
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIF2_FERIAS_PROP
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_PROP
                ||$assoc_destino== FpatipoassoceveEntity::ASSOC_DIF1_ADIC_FERIAS_PROP
                ||$assoc_destino== FpatipoassoceveEntity::ASSOC_DIF2_ADIC_FERIAS_PROP)
            {
                $evento_auxfer = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_PROV_FERIAS_PROP, $this->_eventom, $this->_nrorg);
                $posicao = $item_calc_fonte->retornaItens($evento_auxfer);
                foreach ($posicao as $ind) {
                    $avoFerProp = $item_calc_fonte->retornaReferencia($ind);
                }
                //tk_warning('Nr.Even '.$assoc_destino.' | Ref.Even '.$referencia.' | Vr.Even '.$valor_item.' | Avo.Even   '.$avoFerProp.' | Result '.$valor_item/$avoFerProp);
                $valor_item=($valor_item/$avoFerProp);
            }
            /*bloco para tratar referencia apenas de férias proporcionais que deve sempre ser 1/12*/
            if($assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_FERIAS_PROP
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_ADIC_FERIAS_PROP)
            {
                  $referencia=1;
            }
            /*bloco para tratar valor de 13º e encargos que deve sempre ser sobre 1/12*/
            if(   $assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_13SAL_CONT
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIF1_13SAL_CONT
                ||$assoc_destino==FpatipoassoceveEntity::ASSOC_DIF2_13SAL_CONT
            )
            {
                $evento_aux13 = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_PROV_13SAL_CONT, $this->_eventom, $this->_nrorg);
                $posicao = $item_calc_fonte->retornaItens($evento_aux13);
                foreach ($posicao as $ind) {
                    $avo13 = $item_calc_fonte->retornaReferencia($ind);
                }
                //tk_warning('Nr.Even '.$assoc_destino.' | Ref.Even '.$referencia.' | Vr.Even '.$valor_item.' | Avo.Even '.$avo13.' | Result '.$valor_item/$avo13);
                $valor_item=($valor_item/$avo13);
            }
            /*bloco para tratar referencia apenas de 13º que deve sempre ser 1/12*/
            if($assoc_destino==FpatipoassoceveEntity::ASSOC_DIFP_13SAL_CONT)
            {
                   $referencia=1;
            }
            
            //BORBA 30/09/2013 - Valores e referencia zerados não devem ser demonstrados
            if( ($referencia!=0 || $valor_item!=0) && $valor_item < 9999999){
                $this->_itens_calculo_principal->geraEvento($evento_aux, $dtocorrencia, $valor_item, $referencia, 1);
            }
        }



    }
    
    public function _analisaSalMaternidade($vinculo, $tp_calc_mov)
    {
        if (in_array(FpaProcessoEntity::SALARIO_MATERNIDADE, $this->_listaProcessos) === true){
            $afastamento = $this->_verificaAfastamentos(
               $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
            );
            if(in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE, $afastamento)) {
                $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_SALARIO_MATERNIDADE));
                $this->_itens_salario_maternidade = $obj_tp_calc_mov->getInstancia();
                $alte_situ_func = new GpealtesitufuncEntity($this->entityManager, $this->hcmParameters);
                $obj_alte_situ_func = current($alte_situ_func->retornaAlteSitFuncporVinculoNrsituacao($this->_vinculo->getNrvinculom(),GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE, $this->_nrorg));
                
                $inicioperiodo = DateUtil::subtraiIntervalo(DateUtil::setDay($obj_alte_situ_func->getDtinisitufunc(), 1), 5, DateUtil::MES);
                $fimperiodo = DateUtil::getUltimoDiaDoMes($obj_alte_situ_func->getDtinisitufunc());
                
                $aux_inicioperiodo = DateUtil::adicionaIntervalo($this->_vinculo->getDtadmissaovinc());
                if($inicioperiodo < $aux_inicioperiodo){
                    $inicioperiodo = DateUtil::setDay($aux_inicioperiodo, 1);
                }
                $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();

                $listaEventosTotalizados = $this->_media->calcula(
                   $vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $listaNrEventos, $inicioperiodo,
                    $fimperiodo, $this->_nrTipoModalidadeCalculo, $this->_nrOcorrenciaCalculo
                );
                $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
                
                $this->_media->geraEventoMedia(
                    $this->_itens_salario_maternidade, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_SALARIO_MATERNIDADE,
                    true, 6
                );
                $base = $this->_calculaRemuneracaoBase(
                   $vinculo, $this->_itens_salario_maternidade, FpatipocalculoEntity::CALC_13SAL, FpatipoincideEntity::INC_SAL_MATERNI
                );
                $this->_calculaDiversos(
                    $this->_itens_calculo_principal, FpatipoincideEntity::INC_SAL_MATERNI, FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE,
                    100, $this->_mes_competencia, $base
                );
                $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE, $this->_eventom, $this->_nrorg
                );
                $recuperareferencia=$this->_itens_calculo_principal->retornaReferenciaPorEvento($eventoAux, $this->_mes_competencia);
                if($this->_dias_normais==0&&$recuperareferencia>=30){
                    $recuperacontador=$this->_itens_calculo_principal->retornaContadorPorEvento($eventoAux, $this->_mes_competencia);
                    $recuperavalor=$this->_itens_calculo_principal->retornaValorPorEvento($eventoAux, $this->_mes_competencia);
                    $ultimoDia=0;
                    
                    foreach($afastamento as $key=>$nr_afastamento){
                        if($nr_afastamento==GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE){
                            $ultimoDia++;
                        }
                    }
                    MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $eventoAux,null, $this->_mes_competencia, $recuperavalor, $ultimoDia,null, $base,null,100);
                    $this->_itens_calculo_principal->geraEvento($eventoAux, $this->_mes_competencia, $recuperavalor, $ultimoDia, $recuperacontador);
                }
            }
        }
    }
    
    public function _geraEventoProvisaoRescisao(
         $item_origem, $evento_origem, $evento_destino, $base, $percentual
    ){
        $this->_demonstra($item_origem, $evento_origem, $evento_destino);
        
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, $evento_destino, $percentual, $this->_mes_competencia, $base
        );
    }

    public function _geraDiferencaMesAnterior(
         $item_origem, $nr_evento_origem, $nr_evento_destino, $dt_ocorrencia, $aceitanegativo=true
    ){
        $array_dtocorrencia = $this->_demonstra($item_origem, $nr_evento_origem, $nr_evento_destino, $dt_ocorrencia);
        
        for ($i=0; $i<count($array_dtocorrencia); $i++) {
            $evento_origem = $this->_assoc_eventos->retornaEventoAssociado(
                $nr_evento_origem, $this->_eventom, $this->_nrorg
            );
            $evento_destino = $this->_assoc_eventos->retornaEventoAssociado(
                $nr_evento_destino, $this->_eventom, $this->_nrorg
            );
         
            $this->_itens_calculo_principal->subtraiValor($evento_origem, $evento_destino, $array_dtocorrencia[$i], $aceitanegativo);
        }
    }

    public function _demonstra(
         $item_calc_fonte, $assoc_fonte, $assoc_destino, $dt_ocorrencia_destino = null
    ){
        $array_dtocorrencia = null;
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($assoc_fonte, $this->_eventom, $this->_nrorg);
        $posicoes = $item_calc_fonte->retornaItens($evento_aux);
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($assoc_destino, $this->_eventom, $this->_nrorg);
        
        foreach ($posicoes as $indice) {
            $referencia = $item_calc_fonte->retornaReferencia($indice);
            $valor_item = $item_calc_fonte->retornaValor($indice);
            if ($dt_ocorrencia_destino === null) {
                $dtocorrencia = $item_calc_fonte->retornaDtocorrencia($indice);
            } else {
                $dtocorrencia = $dt_ocorrencia_destino;
            }
            if( $referencia!=0 || $valor_item!=0){
                $calculoEvento = 'DEMONSTRA';
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEvento, $dtocorrencia, $valor_item, $referencia,null,null,null,100);
                $this->_itens_calculo_principal->geraEvento($evento_aux, $dtocorrencia, $valor_item, $referencia, 1);
                $array_dtocorrencia[] = $dtocorrencia;
            }
        }

        if ($array_dtocorrencia !== null) {
            return $array_dtocorrencia;
        }
    }

    public function _demonstraAdiantamento($tp_calc_mov){
        if (in_array(FpaProcessoEntity::ADIANTAMENTO_SALARIO, $this->_listaProcessos) === true) {
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_ADIANTAMENTO));
            $this->_itens_adiantamento_demonstra =  $obj_tp_calc_mov->getInstancia();
            
            if($this->_ultPagamento === FpaFormcalculoEntity::IDULTPGTOMES_S){
                $this->_demonstra(
                    $this->_itens_adiantamento_demonstra, FpatipoassoceveEntity::ASSOC_LIQUIDO,
                    FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_DB
                );
                $this->_demonstra(
                    $this->_itens_adiantamento_demonstra, FpatipoassoceveEntity::ASSOC_IRRF_ADIANTAMENTO,
                    FpatipoassoceveEntity::ASSOC_IRRF_ADIANTAMENTO_ULT_PAG_MES
                );
            }else{
                $this->_demonstra(
                    $this->_itens_adiantamento_demonstra, FpatipoassoceveEntity::ASSOC_LIQUIDO,
                    FpatipoassoceveEntity::ASSOC_ADIANTAM_SAL_ULT_PAG_DB
                );
                $this->_demonstra(
                    $this->_itens_adiantamento_demonstra, FpatipoassoceveEntity::ASSOC_IRRF_ADIANTAMENTO,
                    FpatipoassoceveEntity::ASSOC_IRRF_ADIANTAMENTO
                );
                $this->_demonstra(
                    $this->_itens_adiantamento_demonstra, FpatipoassoceveEntity::ASSOC_ARREDONDAM_SAL_CR,
                    FpatipoassoceveEntity::ASSOC_ARREDONDAM_ADIANT_DB
                );
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_ARREDONDAM_ADIANT_DB, $this->_eventom, $this->_nrorg
                );
                $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $this->_mes_competencia);
                $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                    $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_SIM
                );
            }
        }
    }

    public function _demonstraIRRFCaixa(){
        
        $comp_anterior= DateUtil::subtraiIntervalo($this->_mes_competencia, 1, DateUtil::MES);
        
        $calc_folha = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha(
            $this->_nrorg, 1, $this->_nrTipoModalidadeCalculo, $this->_nrOcorrenciaCalculo, $comp_anterior, $comp_anterior
        )[0];
        if($calc_folha){
            $nrcalculo = $calc_folha->getNrcalculofolha();
            
            $dtpagamento = $this->_dt_pagamento;
            $dtpagamento = DateUtil::setDay($dtpagamento, 1);
            
            $vreventobase =  $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->getValorEvento($nrcalculo, $this->_vinculo->getNrvinculom(), $this->_nrorg, FpatipoassoceveEntity::ASSOC_INCID_IRRF, $dtpagamento);
           
            if($vreventobase){
                $evento_base = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_INCID_IRRF, $this->_eventom, $this->_nrorg
                );
                $this->_itens_calculo_principal->geraEvento($evento_base,$this->_mes_competencia,$vreventobase , 0, 1);
            }
            
            $vreventoirrf= $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->getValorEvento($nrcalculo, $this->_vinculo->getNrvinculom(), $this->_nrorg, FpatipoassoceveEntity::ASSOC_IRRF_CALC, $dtpagamento);
            
            if($vreventoirrf) {
                $evento_irrf = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_CALC, $this->_eventom, $this->_nrorg
                );
                $this->_itens_calculo_principal->geraEvento($evento_irrf, null, $vreventoirrf, 0, 1);

                $posicao = $this->_itens_calculo_principal->procuraEvento($evento_irrf, $this->_mes_competencia);
                $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                    $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_SIM
                );
            }
        }
    }

    public function _demonstra13Salario($tp_calc_mov){
        if (in_array(FpaProcessoEntity::DECIMO_TERCEIRO_SALARIO, $this->_listaProcessos) === true) {

            if ( ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
                || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
            ) {
                $iniperiodo13saladiant = $this->_primeiroDiaAno;
                $fimperiodo13saladiant = DateUtil::subtraiIntervalo($this->_mes_competencia, 1);
                
                $eventoBaseFgts13 = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_INCID_FGTS_13SAL, $this->_eventom, $this->_nrorg
                );

                $listaEventosTotalizados = $this->_media->calcula(
                    $this->_vinculo, FpatipomovimentEntity::TP_MOV_13SAL, $eventoBaseFgts13->getNreventom(), $iniperiodo13saladiant,
                    $fimperiodo13saladiant, $this->_nrTipoModalidadeCalculo, 1
                );
                $eventoBaseFgts13anterior = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_INCID_FGTS_13_RESC_ANT, $this->_eventom, $this->_nrorg
                );
                $listaEventosOrigemDestino = array_combine(array($eventoBaseFgts13->getNreventom()), array($eventoBaseFgts13anterior->getNreventom()));

                $this->_media->geraEventoMedia(
                    $this->_itens_calculo_principal, $listaEventosTotalizados, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_MENSAL,
                    false, 1
                );
            }
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_13SAL_RESC));
            $this->_itens_13sal_demonstra =  $obj_tp_calc_mov->getInstancia();

            $this->_demonstra(
                $this->_itens_13sal_demonstra, FpatipoassoceveEntity::ASSOC_ADIANT_13SAL_DB,
                FpatipoassoceveEntity::ASSOC_ADIANT_13SAL_DB
            );

        }
    }

    public function _demonstraFerias($tp_calc_mov){
        if(in_array(FpaProcessoEntity::FERIAS, $this->_listaProcessos) === false){
            return;
        }
        
        $mesOcorrencia = DateUtil::getDataDeString($this->_mes_competencia);
            
        //ItemFerias ocorrencia 2
        $calc_FeriasOcorrencia2 = $this->_calculo_folha->retornaCalculoFolha(
            $this->_nrorg, FpatipomovimentEntity::TP_MOV_FERIAS, $mesOcorrencia, 1, 2
        )[0];
        
        $this->itemFeriasOcorr2 = new FpaitecalcfolhaEntity($this->entityManager, $this->hcmParameters, $calc_FeriasOcorrencia2->getNrcalculofolha());
        $this->itemFeriasOcorr2->retornaItensPorVinculo($this->_vinculo->getNrorg(), $this->_vinculo->getNrvinculom(), $calc_FeriasOcorrencia2->getNrcalculofolha());
        
        //ItemFerias ocorrencia 2 mes ant
        $mesOcorrencia2 = DateUtil::subtraiIntervalo($this->_mes_competencia, 1, DateUtil::MES);
        $calc_FeriasOcorrencia2 = $this->_calculo_folha->retornaCalculoFolha(
            $this->_nrorg, FpatipomovimentEntity::TP_MOV_FERIAS, $mesOcorrencia2, 1, 2
        )[0];
        
        if($calc_FeriasOcorrencia2){
            $this->itemFeriasOcorr2MesAnt = new FpaitecalcfolhaEntity($this->entityManager, $this->hcmParameters, $calc_FeriasOcorrencia2->getNrcalculofolha());
            $this->itemFeriasOcorr2MesAnt->retornaItensPorVinculo($this->_vinculo->getNrorg(), $this->_vinculo->getNrvinculom(), $calc_FeriasOcorrencia2->getNrcalculofolha());
        }else{
            $this->itemFeriasOcorr2MesAnt = null;
        }
                    
        if ($this->_dias_ferias > 0 || $this->itemFeriasOcorr2MesAnt) {
            
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS));
            $this->_itens_ferias_mc =  $obj_tp_calc_mov->getInstancia();

            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS, -1));
            $this->_itens_ferias_ma =  $obj_tp_calc_mov->getInstancia();

            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS, -2));
            $this->_itens_ferias_maa = $obj_tp_calc_mov->getInstancia();

            $mesOcorrencia = DateUtil::getDataDeString($this->_mes_competencia);
            
            //ItemFerias ocorrencia 2
            $calc_FeriasOcorrencia2 = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha(
                $this->_nrorg, FpatipomovimentEntity::TP_MOV_FERIAS, 1, 2, $mesOcorrencia, $mesOcorrencia
            )[0];
            
            $this->itemFeriasOcorr2 = new FpaitecalcfolhaEntity($this->entityManager, $this->hcmParameters, $calc_FeriasOcorrencia2->getNrcalculofolha());
            $this->itemFeriasOcorr2->retornaItensPorVinculo($this->_vinculo->getNrorg(), $this->_vinculo->getNrvinculom(), $calc_FeriasOcorrencia2->getNrcalculofolha());
            
            //ItemFerias ocorrencia 2 mes ant
            $mesOcorrencia2 = DateUtil::subtraiIntervalo($this->_mes_competencia, 1, DateUtil::MES);
            
            $calc_FeriasOcorrencia2 = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha(
                $this->_nrorg, FpatipomovimentEntity::TP_MOV_FERIAS, 1, 2, $mesOcorrencia2, $mesOcorrencia2
            )[0];
            
            if($calc_FeriasOcorrencia2){
                $this->itemFeriasOcorr2MesAnt = new FpaitecalcfolhaEntity($this->entityManager, $this->hcmParameters, $calc_FeriasOcorrencia2->getNrcalculofolha());
                $this->itemFeriasOcorr2MesAnt->retornaItensPorVinculo($this->_vinculo->getNrorg(), $this->_vinculo->getNrvinculom(), $calc_FeriasOcorrencia2->getNrcalculofolha());
            }else{
                $this->itemFeriasOcorr2MesAnt = null;
            }
            
            $gerou1p = $this->_verificaFeriasMesOcorrencia(
                FpatipoassoceveEntity::ASSOC_FERIAS, $this->_itens_ferias_mc, $mesOcorrencia
            );
            
            if (!$gerou1p) {
                $gerou1p = $this->_verificaFeriasMesOcorrencia(
                    FpatipoassoceveEntity::ASSOC_FERIAS, $this->_itens_ferias_ma, $mesOcorrencia
                );
            }
            
            //Ajuste para gerar primeira parte de férias quando existem duas na mesma competência
            //if ($gerou1p) {
                $this->_demonstraFeriasPrimeiraParte();
            //}
            
            $gerou2p = $this->_verificaFeriasMesOcorrencia(
                FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_itens_ferias_ma, $mesOcorrencia
            );
            
            if (!$gerou2p && !$gerou1p) {
                $gerou2p = $this->_verificaFeriasMesOcorrencia(
                    FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_itens_ferias_maa, $mesOcorrencia
                );
            }
            $this->_demonstraFeriasSegundaParte();
            
            $this->_geraEventoDemonstraFeriasOrgCliente($this->_itens_ferias_ma, $this->_itens_ferias_mc, $gerou2p);
        }
    }

    public function _verificaDifFerias($tp_calc_mov, $vinculo, $difComp = false){
        if(in_array(FpaProcessoEntity::FERIAS, $this->_listaProcessos) === false){
            return;
        }
        
        if ($this->_dias_ferias > 0) {
            
            if ($this->_ambiente_salario_operador === GpeParamoperEntity::IDAMBIENTESAL_REAL) {
                $nrModalidade = $this->_vinculo->historico->getNrtpmodalidsal();
            } else {
                $nrModalidade = $this->_tp_modalidade_salario_operador;
            }
            
            if($difComp){
                $tp_calc_mov = new FpatpcalcmovEntity($this->entityManager, $this->hcmParameters);
                $tp_calc_mov->retornaTipoCalculoMovimento(1); 
                
                $competencia = DateUtil::getDataDeString($this->_mes_competencia);
                
                $tp_calc_mov->atribuiNrCalculoFolha(
                    $this->_nrorg, $this->_calculo_folha, $competencia, 1,
                    1);
                $tp_calc_mov->retornaItensCalculo($vinculo);
            }
            
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS));
            $this->_itens_ferias_mc =  $obj_tp_calc_mov->getInstancia();
            
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS, -1));
            $this->_itens_ferias_ma =  $obj_tp_calc_mov->getInstancia();
			
            $obj_tp_calc_mov = current($tp_calc_mov->retornaPosicaoTpMov(FpatipomovimentEntity::TP_MOV_FERIAS, -2));
            $this->_itens_ferias_maa =  $obj_tp_calc_mov->getInstancia();
            
            $mesOcorrencia = $this->_mes_competencia;
            
            $gerou1pMc = $this->_verificaFeriasMesOcorrencia(
                FpatipoassoceveEntity::ASSOC_FERIAS, $this->_itens_ferias_mc, $mesOcorrencia
            );
            
            if (!$gerou1pMc) {
                $gerou1pMa = $this->_verificaFeriasMesOcorrencia(
                    FpatipoassoceveEntity::ASSOC_FERIAS, $this->_itens_ferias_ma, $mesOcorrencia
                );
				if(!$gerou1pMa){
					$gerou1pMaa = $this->_verificaFeriasMesOcorrencia(
						FpatipoassoceveEntity::ASSOC_FERIAS, $this->_itens_ferias_maa, $mesOcorrencia
					);
                    if(!$gerou1pMaa){
                        $gerou2pMc = $this->_verificaFeriasMesOcorrencia(
                            FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_itens_ferias_ma, $mesOcorrencia
                        );
                        if(!$gerou2pMc){
                            $gerou2pMa = $this->_verificaFeriasMesOcorrencia(
                                FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_itens_ferias_maa, $mesOcorrencia
                            );
                        }
                    }
				}
            }
            
            if ($gerou1pMc) {
                $itenscalc = clone($this->_itens_ferias_mc);
                $dtIniMedia = clone $mesOcorrencia;
            }else if ($gerou1pMa || $gerou2pMc) {
                $itenscalc = clone($this->_itens_ferias_ma);
                $dtIniMedia = clone $mesOcorrencia;
                $dtIniMedia = DateUtil::subtraiIntervalo($mesOcorrencia, 1, DateUtil::MES);
            }else if($gerou1pMaa || $gerou2pMa){
                $itenscalc = clone($this->_itens_ferias_maa);
                $dtIniMedia = clone $mesOcorrencia;
                $dtIniMedia = DateUtil::subtraiIntervalo($mesOcorrencia, 2, DateUtil::MES);
            }else{
                return;
            }
            $evento_Sal = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_SALARIO_1);
            $vrSalarioFerias = $itenscalc->retornaValorPorEvento($evento_Sal, null);
            
            if($this->_salario <= $vrSalarioFerias){
                return;
            }
            
            $difSal = $this->_salario - $vrSalarioFerias;
            
            $dtIniMedia = DateUtil::subtraiIntervalo($dtIniMedia, 1, DateUtil::MES);
            $dtFimMedia = DateUtil::adicionaIntervalo($mesOcorrencia, 1, DateUtil::MES);
            $RefFerias=0;
            $RefFerias2parte=0;
            $RefAbono=0;
            $media1Parte = 0;
            $AdicMedia1Parte = 0;
            $media2Parte = 0;
            $AdicMedia2Parte = 0;
            $MediaAbono = 0;
            $AdicMediaAbono = 0;
            
            $evento_Fer = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_FERIAS);
            $RefFerias = $itenscalc->retornaReferenciaPorEvento($evento_Fer, null);
            $dtOcorrencia1Parte = substr($itenscalc->retornaDtOcorrenciaPorEvento($evento_Fer), 0, 10);
            
            //Verifica Diferença paga no calculo de dissidio.
            $evento_dif = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_DIF_SALARIO_DISSIDIO);
            $valDifSalario = $this->_itens_calculo_principal->retornaValorPorEvento($evento_dif, null);
            if($dtOcorrencia1Parte != $this->_mes_competencia->format('d/m/Y') && $valDifSalario > 0){
                return;
            }
            
            $VrFerias=$difSal/30*$RefFerias;
            $VrAdicFerias=$VrFerias/3;
            
            $calculoEvento1parte = 'Ferias: '.$difSal.' (Diferença) / 30 * '.$RefFerias.' (Dias 1ª Parte) = '.$VrFerias;
            $calculoEventoAdic1parte = $VrFerias.' (Ferias 1ºParte) / 3 = '. $VrAdicFerias;
            
            $evento_Fer2 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE);
            $RefFerias2parte=$itenscalc->retornaReferenciaPorEvento($evento_Fer2, null);
            
            $VrFerias2Parte=$difSal/30*$RefFerias2parte;
            $VrAdicFerias2Parte=$VrFerias2Parte/3;
            $calculoEvento2parte = 'Ferias: '.$difSal.' (Diferença) / 30 * '.$RefFerias2parte.' (Dias 2ª Parte) = '.$VrFerias2Parte;
            $calculoEventoAdic2parte = $VrFerias2Parte.' (Ferias 2ºParte) / 3 = '. $VrAdicFerias2Parte;
            
            $evento_Abono = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO);
            $RefAbono+=$itenscalc->retornaReferenciaPorEvento($evento_Abono, null);
            $VrAbono=$difSal/30*$RefAbono;
            $VrAdicAbono=$VrAbono/3;
            
            $calculoEventoAbono = 'Abono: '.$difSal.' (Diferença) / 30 * '.$RefAbono.' (Dias Abono) = '.$VrAbono;
            $calculoEventoAdicAbono = $VrAbono.' (Abono) / 3 = '. $VrAdicAbono;
            
            $refTotal = $RefFerias+$RefFerias2parte+$RefAbono;
            
            $evento_Dobra = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_FERIAS_DOBRA);
            $RefDobra = $itenscalc->retornaReferenciaPorEvento($evento_Dobra, null);
            $VrDobra = $difSal/30*$RefDobra;
            $VrAdicDobra = $VrDobra/3;
            
            $calculoEventoDobra = 'Ferias Dobro: '.$difSal.' (Diferença) / 30 * '.$RefDobra.' (Dias Dobro) = '.$VrDobra;
            $calculoEventoAdicDobra = $VrDobra.' (Ferias Dobro) / 3 = '. $VrAdicDobra;
            
            $evento_Peric1 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_ADIC_PERICULO_FERIAS_1_PARTE);
            $RefPeric1 = $itenscalc->retornaReferenciaPorEvento($evento_Peric1, null);
            $vrPeric1 = $itenscalc->retornaValorPorEvento($evento_Peric1, null);
            
            if($vrPeric1){
                $vrNovoPeric1 = (($this->_salario * 0.3) / 30 * $RefPeric1) - $vrPeric1;
                $VrFerias += $vrNovoPeric1;
                $VrAdicFerias=$VrFerias/3;
            }
            
            $evento_Peric2 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_ADIC_PERICULO_FERIAS_2_PARTE);
            $RefPeric2 = $itenscalc->retornaReferenciaPorEvento($evento_Peric2, null);
            $vrPeric2 = $itenscalc->retornaValorPorEvento($evento_Peric2, null);
            
            if($vrPeric2){
                $vrNovoPeric2 = (($this->_salario * 0.3) / 30 * $RefPeric2) - $vrPeric2;
                $VrFerias2Parte += $vrNovoPeric2;
                $VrAdicFerias2Parte = $VrFerias2Parte/3;
            }
            
            $evento_media1 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_1_PARTE);
            $vrMediaFerias1=$itenscalc->retornaValorPorEvento($evento_media1, null);
            $evento_media2 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_2_PARTE);
            $vrMediaFerias2=$itenscalc->retornaValorPorEvento($evento_media2, null);
            $evento_mediaAbono = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_MEDIA_ABONO_PECUNIARIO);
            $vrMediaAbono=$itenscalc->retornaValorPorEvento($evento_mediaAbono, null);
            
            $mediaAnterior = $vrMediaFerias1 + $vrMediaFerias2 + $vrMediaAbono;
            
            $listaNrEventos = $this->_eventomMedia->retornaListaEventoMedia();
            
            $listaEventosTotalizados = $this->_media->calculaMaiorMedia(
               $vinculo, FpatipomovimentEntity::TP_MOV_FERIAS, $listaNrEventos, $dtIniMedia,
                $dtFimMedia, 1, null
            );
            
            $listaEventosOrigemDestino = array_combine(preg_split('/[\s,]+/', $listaNrEventos), preg_split('/[\s,]+/', $listaNrEventos));
            
            $itens_dif = new FpaitecalcfolhaEntity($this->entityManager, $this->hcmParameters, $this->_itens_calculo_principal->getNrcalculofolha());
            $itens_dif->setNrvinculom($vinculo->getNrvinculom());
            
            $this->_media->geraEventoMedia(
                $itens_dif, $listaEventosTotalizados, $listaEventosOrigemDestino,
                FpatipomovimentEntity::TP_MOV_MENSAL, true, 1
            );
            
            $this->_calculaAdicionais($itens_dif);

            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_ADICIONAIS, $this->_nr_tipo_calculo, $itens_dif
            );
            $this->_calculaExtra($itens_dif);

            $this->_calculo_regra->executaPontoRegra(
                $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_HORAS_EXTRAS, $this->_nr_tipo_calculo, $itens_dif
            );
            $media = $itens_dif->calculaIncidencias(
                FpatipoincideEntity::INC_FERIAS, $this->_mes_competencia, $this->_eventom
            );
            
            $incideventoEntity = new FpaincideventoEntity($this->entityManager, $this->hcmParameters);
            $incideEventosRecalculaPerc = $incideventoEntity->getEventos(
                $this->_mes_competencia, FpatipoincideEntity::RECALCULA_POR_DISSIDIO
            );
            
            //Recalcula evento pela porcentagem do Salario.
            /*if($incideEventosRecalculaPerc){
                
                $salarioMes = $this->_salario;
                $alteSalario = $this->_alteracaoSalario->retornaAlteSalarioAtualPorVinculoModalidade(DateUtil::subtraiIntervalo($dtOcorrencia1Parte, 1, DateUtil::MES), $vinculo->getNrvinculom(), 1);
                $salarioDissidio = $alteSalario->getVrsalario();
                
                $VrMultiplicador = ((($salarioDissidio - $salarioMes) / $salarioMes) * 100) / 100;
                
                foreach($listaEventosTotalizados as $nrEvento => $evento){
                    foreach($incideEventosRecalculaPerc as $nrEventoIncid){
                        if($nrEvento == $nrEventoIncid){
                            $vrEventoAntigo = $evento['VAL'];
                            
                            $media += $vrEventoAntigo * $VrMultiplicador;
                        }
                    }
                }
            }*/
            $media = $media / 30 * $refTotal; 
            
            if($media > 0 && $mediaAnterior > 0) {
                $difMedia = $media - $mediaAnterior > 0 ? $media - $mediaAnterior : 0;
                
                $media1Parte = $difMedia / $refTotal * $RefFerias;
                $AdicMedia1Parte = $media1Parte / 3;

                $calculoEvento1parte .= PHP_EOL.'Media: '.$difMedia.' (Diferença Media) / '.$refTotal.' * '.$RefFerias.' (Dias 1ª Parte) = '.$media1Parte;
                $calculoEventoAdic1parte .= PHP_EOL.$media1Parte.' (Media 1ª Parte) / 3 = '.$AdicMedia1Parte;

                $media2Parte = $difMedia / $refTotal * $RefFerias2parte;
                $AdicMedia2Parte = $media2Parte / 3;

                $calculoEvento2parte .= PHP_EOL.'Media: '.$difMedia.' (Diferença Media) / '.$refTotal.' * '.$RefFerias2parte.' (Dias 2ª Parte) = '.$media2Parte;
                $calculoEventoAdic2parte .= PHP_EOL.$media2Parte.' (Media 2ª Parte) / 3 = '.$AdicMedia2Parte;

                $MediaAbono = $difMedia / $refTotal * $RefAbono;
                $AdicMediaAbono = $MediaAbono / 3;

                $calculoEventoAbono .= PHP_EOL.'Media: '.$difMedia.' (Diferença Media) / '.$refTotal.' * '.$RefAbono.' (Dias Abono) = '.$MediaAbono;
                $calculoEventoAdicAbono .= PHP_EOL.$MediaAbono.' (Media Abono) / 3 = '.$AdicMediaAbono;
            }
            
            if($RefFerias2parte > 0) {
                
                $dtOcorrenciaAnterior = DateUtil::subtraiIntervalo($this->_mes_competencia, 1, DateUtil::MES);
                
                $calculo_folha = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha($this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, 1,
                    $this->_nrOcorrenciaCalculo, $dtOcorrenciaAnterior, $dtOcorrenciaAnterior
                );
                
                //Procura se teve diferenca de ferias 2 parte mes anterior.
                if($calculo_folha){
                    $nrCalculo = $calculo_folha[0]->getNrcalculofolha();
                    $this->_itens_origem->retornaItensPorVinculo($vinculo->getNrorg(), $vinculo->getNrvinculom(), $nrCalculo);
                    
                    $evento_DifFer2 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_DIF_FERIAS_2_PARTE);
                    $RefFerias2ParteMes = $this->_itens_origem->retornaReferenciaPorEvento($evento_DifFer2, null);
                    
                    if(!$RefFerias2ParteMes){
                        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_DIF_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg);
                        $calculoEvento2parte .=  PHP_EOL.'Total: '.$VrFerias2Parte.' = '.($VrFerias2Parte);
                        MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEvento2parte, $this->_mes_competencia, $VrFerias2Parte + $media2Parte, $RefFerias2parte,null,null,null,100);
                        $this->_itens_calculo_principal->geraEvento($evento_aux, null, $VrFerias2Parte, $RefFerias2parte, 1);
                        
                        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_DIF_MEDIA_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg);
                        $this->_itens_calculo_principal->geraEvento($evento_aux, null,$media2Parte, $RefFerias2parte, 1);
        
                        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_DIF_ADIC_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg);
                        $calculoEvento2parte .=  PHP_EOL.'Total: '.$VrAdicFerias2Parte.' = '.($VrAdicFerias2Parte);
                        MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEventoAdic2parte, $this->_mes_competencia, $VrAdicFerias2Parte + $AdicMedia2Parte, $RefFerias2parte,null,null,null,100);
                        $this->_itens_calculo_principal->geraEvento($evento_aux, null, $VrAdicFerias2Parte, $RefFerias2parte, 1);
                        
                        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_DIF_MEDIA_ADIC_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg);
                        $this->_itens_calculo_principal->geraEvento($evento_aux, null,$AdicMedia2Parte, $RefFerias2parte, 1);
                    }
                }
                
            }
            
            if($dtOcorrencia1Parte == $this->_mes_competencia->format('d/m/Y')){
                
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_FERIAS, $this->_eventom, $this->_nrorg);
                $calculoEvento1parte .=  PHP_EOL.'Total + Periculosidade: '.$VrFerias.' = '.($VrFerias);
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEvento1parte, $this->_mes_competencia, $VrFerias + $media1Parte, $RefFerias,null,null,null,100);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null, $VrFerias, $RefFerias,1);
                
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_MEDIA_FERIAS, $this->_eventom, $this->_nrorg);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null,$media1Parte,$RefFerias,1);
                
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_ADIC_FERIAS, $this->_eventom, $this->_nrorg);
                $calculoEventoAdic1parte .=  PHP_EOL.'Total: '.$VrAdicFerias.' + '.$AdicMedia1Parte.' = '.($VrAdicFerias);
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEventoAdic1parte, $this->_mes_competencia, $VrAdicFerias + $AdicMedia1Parte, $RefFerias,null,null,null,100);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null, $VrAdicFerias, $RefFerias,1);
            
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_MEDIA_ADIC_FERIAS, $this->_eventom, $this->_nrorg);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null,$AdicMedia1Parte,$RefFerias,1);
                
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_ABONO_PECUNIO, $this->_eventom, $this->_nrorg);
                $calculoEventoAbono .=  PHP_EOL.'Total: '.$VrAbono.' = '.($VrAbono);
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEventoAbono, $this->_mes_competencia, $VrAbono + $MediaAbono, $RefAbono,null,null,null,100);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null, $VrAbono, $RefAbono,1);
                
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_MEDIA_ABONO_PECUNIO, $this->_eventom, $this->_nrorg);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null,$MediaAbono,$RefAbono,1);
                
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_ADIC_ABONO, $this->_eventom, $this->_nrorg);
                $calculoEventoAdicAbono .=  PHP_EOL.'Total: '.$VrAdicAbono.' = '.($VrAdicAbono);
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEventoAdicAbono, $this->_mes_competencia, $VrAdicAbono + $AdicMediaAbono, $RefAbono,null,null,null,100);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null, $VrAdicAbono, $RefAbono,1);
                
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_MEDIA_ADIC_ABONO, $this->_eventom, $this->_nrorg);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null,$AdicMediaAbono,$RefAbono,1);
                
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_FERIAS_DOBRO, $this->_eventom, $this->_nrorg);
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEventoDobra, $this->_mes_competencia, $VrDobra, $RefDobra,null,null,null,100);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null, $VrDobra, $RefDobra,1);

                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_ADIC_FERIAS_DOBRO, $this->_eventom, $this->_nrorg);
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEventoAdicDobra, $this->_mes_competencia, $VrAdicDobra, $RefDobra,null,null,null,100);
                $this->_itens_calculo_principal->geraEvento($evento_aux,null, $VrAdicDobra, $RefDobra,1);
            }
        }
    }

    public function _verificaFeriasMesOcorrencia(
        $nrTipoAssocEvento,  $itensFerias, $mesOcorrencia
    ){
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nrTipoAssocEvento, $this->_eventom, $this->_nrorg);
        $nrEvento = $itensFerias->procuraEvento($evento_aux, $mesOcorrencia);
        if ($nrEvento !== -1 && $itensFerias->retornaValor($nrEvento) !== 0 ){
            return true;
        }
        else{
            return false;
        }

    }

    public function _demonstraFeriasPrimeiraParte(){

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_FERIAS, FpatipoassoceveEntity::ASSOC_FERIAS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_1_PARTE, FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_1_PARTE,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_FERIAS, FpatipoassoceveEntity::ASSOC_ADIC_FERIAS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_1_PARTE, FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_1_PARTE,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_PENSAO_FERIAS, FpatipoassoceveEntity::ASSOC_PENSAO_FERIAS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO, FpatipoassoceveEntity::ASSOC_ABONO_PECUNIARIO,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_ABONO, FpatipoassoceveEntity::ASSOC_ADIC_ABONO,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_MEDIA_ABONO_PECUNIARIO, FpatipoassoceveEntity::ASSOC_MEDIA_ABONO_PECUNIARIO,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_ABONO, FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_ABONO,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_FERIAS_DOBRA, FpatipoassoceveEntity::ASSOC_FERIAS_DOBRA,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_FERIAS_DOBRA, FpatipoassoceveEntity::ASSOC_ADIC_FERIAS_DOBRA,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_INSALUBRE_FERIAS_1_PARTE, FpatipoassoceveEntity::ASSOC_ADIC_INSALUBRE_FERIAS_1_PARTE,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc, true
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_PERICULO_FERIAS_1_PARTE, FpatipoassoceveEntity::ASSOC_ADIC_PERICULO_FERIAS_1_PARTE,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc, true
        );
        
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS, FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS, $this->_eventom, $this->_nrorg
        );

        $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $this->_mes_competencia);
        $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
            $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_NAO
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_IRRF_FERIAS, FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_FERI,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc, true
        );
        
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_IRRF_JA_DESC_FERI, $this->_eventom, $this->_nrorg
        );
        
        $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $this->_mes_competencia);
        if ($posicao !== -1) {
            $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_NAO
            );
        }
        
        $mes_anterior = DateUtil::subtraiIntervalo($this->_mes_competencia, 1, DateUtil::MES);
        $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $mes_anterior);
        if ($posicao !== -1) {
            $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_NAO
            );
        }
        
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIANT_13SAL, FpatipoassoceveEntity::ASSOC_ADIANT_13SAL,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_13SAL_12AVOS, FpatipoassoceveEntity::ASSOC_13SAL_12AVOS,
            $this->_itens_ferias_ma, $this->_itens_ferias_mc
        );
        
    }

    public function _demonstraFeriasSegundaParte(){

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_MEDIA_FERIAS_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_2_PARTE, FpatipoassoceveEntity::ASSOC_ADIC_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_INSALUBRE_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_ADIC_INSALUBRE_FERIAS_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma, true
        );
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_ADIC_PERICULO_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_ADIC_PERICULO_FERIAS_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma, true
        );
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_MEDIA_ADIC_FERIAS_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );

        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_PENSAO_FERIAS_2_PARTE, FpatipoassoceveEntity::ASSOC_PENSAO_FERIAS_2_PARTE,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );
        $this->_geraEventoDemonstraFerias(
            FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P, FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P,
            $this->_itens_ferias_maa, $this->_itens_ferias_ma
        );
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P, $this->_eventom, $this->_nrorg
        );
        $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $this->_mes_competencia);
        $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
            $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_NAO
        );
    }
    
    public function _geraEventoDemonstraFeriasOrgCliente(
        $itemAnterior, $itemCorrente, $gerou2p
    ){
        
        $incideventoEntity = new FpaincideventoEntity($this->entityManager, $this->hcmParameters);
        $incideDemonstraFolha = $incideventoEntity->getEventos(
            $this->_mes_competencia, FpatipoincideEntity::COMP_SAL_FERIAS
        );
        
        if(!$incideDemonstraFolha){
            return;
        }
        
        $this->_demonstraFeriasResumoOrgCli = array();
        foreach($incideDemonstraFolha as $nrTipoAssocEventoFonte){
            
            //$evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            //    $nrTipoAssocEventoFonte, $this->_eventom, $this->_nrorg
            //);
            $evento_aux = $this->_eventom->getEvento($nrTipoAssocEventoFonte);
            
            if(!$evento_aux){
                MsgCalculo::getInstance()->adicionaMensagem('Evento '.$nrTipoAssocEventoFonte.' sem associação criada');
                continue;
            }
            $this->_geraValorReferenciaFeriasOrgCliente($evento_aux, $itemAnterior);
            $this->_geraValorReferenciaFeriasOrgCliente($evento_aux, $itemCorrente);
            
            $this->geraValorReferenciaFeriasOcor2OrgCliente($evento_aux, $this->itemFeriasOcorr2MesAnt, $demonstraForaMes);
            $this->geraValorReferenciaFeriasOcor2OrgCliente($evento_aux, $this->itemFeriasOcorr2, $demonstraForaMes);
        }
        
        if ($this->_demonstraFeriasResumoOrgCli['VAL'] > 0) {
            $evento_Ferias = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_FERIAS, $this->_eventom, $this->_nrorg
            );
            
            $this->_geraValorReferenciaFerias($evento_Ferias, $itemAnterior);
            $this->_geraValorReferenciaFerias($evento_Ferias, $itemCorrente);
            $valor = $this->_demonstraFeriasResumoOrgCli['VAL'];
            
            if($this->_demonstraFeriasResumo[FpatipoassoceveEntity::ASSOC_FERIAS]['VAL'] > 0){
                // 1º Parte
                $nrTipoAssocEventoDestino = FpatipoassoceveEntity::ASSOC_OUTROS_ADICIONAIS_FERIAS_1_PARTE;
                $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nrTipoAssocEventoDestino, $this->_eventom, $this->_nrorg);
                
                $referencia = $this->_demonstraFeriasResumo[FpatipoassoceveEntity::ASSOC_FERIAS]['REF'];
                
                $valor1Parte = $valor / 30 * $referencia;
            
                $this->_itens_calculo_principal->geraEvento(
                    $evento_aux,
                    $this->_demonstraFeriasResumo[FpatipoassoceveEntity::ASSOC_FERIAS]['DAT'],
                    $valor1Parte,
                    $referencia,
                    1
                );
            }
            
            if($gerou2p){
                $evento_Ferias2 = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE, $this->_eventom, $this->_nrorg
                );
                
                $this->_geraValorReferenciaFerias($evento_Ferias2, $itemAnterior);
                $this->_geraValorReferenciaFerias($evento_Ferias2, $itemCorrente);
                if($this->_demonstraFeriasResumo[FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE]['VAL'] > 0){
                    //2º Parte
                    $nrTipoAssocEventoDestino = FpatipoassoceveEntity::ASSOC_OUTROS_ADICIONAIS_FERIAS_2_PARTE;
                    $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nrTipoAssocEventoDestino, $this->_eventom, $this->_nrorg);
                    
                    $referencia = $this->_demonstraFeriasResumo[FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE]['REF'];
                    
                    $valor2Parte = $valor / 30 * $referencia;
                
                    $this->_itens_calculo_principal->geraEvento(
                        $evento_aux,
                        $this->_demonstraFeriasResumo[FpatipoassoceveEntity::ASSOC_FERIAS_2_PARTE]['DAT'],
                        $valor2Parte,
                        $referencia,
                        1
                    );
                }
            }
        }
    }
    
    public function _geraValorReferenciaFeriasOrgCliente(
         $evento_aux,  $itensFerias
    ){
        $itens = $itensFerias->retornaItens($evento_aux);
        if (count($itens) > 0) {
            $referencia = 0;
            $valor_item = 0.0;
            foreach ($itens as $indice) {
                $referencia += $itensFerias->retornaReferencia($indice);
                $valor_item += $itensFerias->retornaValor($indice);
                
            }
            $this->_demonstraFeriasResumoOrgCli['REF'] += $referencia;
            $this->_demonstraFeriasResumoOrgCli['VAL'] += $valor_item;
        }
    }
    
    //Busca Valor ocorrencia 2.
    public function geraValorReferenciaFeriasOcor2OrgCliente($evento_aux,  $itensFerias, $demonstraForaMes = false){
        $itens2 = $itensFerias->retornaItens($evento_aux);
        if (count($itens2) > 0) {
            $referencia = 0;
            $valor_item = 0.0;
            foreach ($itens2 as $indice2) {
                $referencia += $itensFerias->retornaReferencia($indice2);
                $valor_item += $itensFerias->retornaValor($indice2);
            }
            $this->_demonstraFeriasResumoOrgCli[$evento_aux->getNreventom()]['REF'] += $referencia;
            $this->_demonstraFeriasResumoOrgCli[$evento_aux->getNreventom()]['VAL'] += $valor_item;
        }
    }
    
    public function _geraEventoDemonstraFerias(
        $nrTipoAssocEventoFonte, $nrTipoAssocEventoDestino,  $itemAnterior,
         $itemCorrente, $demonstraForaMes = false
    ){
        $this->_demonstraFeriasResumo = array();
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
            $nrTipoAssocEventoFonte, $this->_eventom, $this->_nrorg
        );
        
        $demonstraMa = $this->_geraValorReferenciaFerias($evento_aux, $itemAnterior, $demonstraForaMes);
        $demonstraMc = $this->_geraValorReferenciaFerias($evento_aux, $itemCorrente, $demonstraForaMes);
        
        $this->geraValorReferenciaFeriasOcor2($evento_aux, $this->itemFeriasOcorr2MesAnt, $demonstraForaMes);
        $this->geraValorReferenciaFeriasOcor2($evento_aux, $this->itemFeriasOcorr2, $demonstraForaMes);
        
        if ($nrTipoAssocEventoFonte !== $nrTipoAssocEventoDestino) {
            $evento_aux = $this->_assoc_eventos->retornaEventoAssociado(
                $nrTipoAssocEventoDestino, $this->_eventom, $this->_nrorg
            );
        }
        
        $calculoEvento = 'Valor gerado no calculo de Ferias';
        MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_aux, $calculoEvento, $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['DAT'],
                $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['VAL'],
                $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['REF']
            ,null,null,null,null);
            
        if ($this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['VAL'] > 0) {
            $this->_itens_calculo_principal->geraEvento(
                $evento_aux,
                $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['DAT'],
                $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['VAL'],
                $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['REF'],
                1
            );
            
            //Ajuste para manter os sub totais de férias como não demonstrativos
            if ($evento_aux->getNreventom() == 1510 || $evento_aux->getNreventom() == 1520) {
                $posicao = $this->_itens_calculo_principal->procuraEvento($evento_aux, $this->_demonstraFeriasResumo[$nrTipoAssocEventoFonte]['DAT']);
                $this->_itens_calculo_principal->atribuiCalculoDemonstrativo(
                    $posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_NAO
                );
            }
        }
    }
    
    public function _consolidaInssOcor(){

        /*Retorna objeto do evento associado a base de INSS  folha mensal*/
        $eventoAuxBase = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_INCID_INSS , $this->_eventom, $this->_nrorg
        );
        $ocorrencias = array(1,2,3,4,5);
        
        foreach($ocorrencias as $ocorrencia){
            
            if($this->_nrOcorrenciaCalculo == $ocorrencia){
                continue;
            }
            $tipoLancamento = 'REFERENCIA_VALOR';
            
            if($this->_nrOcorrenciaCalculo > 1){
                $tipoLancamento .= '_RECALCULO';
            }
            
            $listaEventosTotalizadosBASE = $this->_media->calcula(
                $this->_vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $eventoAuxBase->getNreventom(), $this->_mes_competencia,
                $this->_ult_dia_mes, $this->_nrTipoModalidadeCalculo, $ocorrencia
            );
            
            if($listaEventosTotalizadosBASE){
                
                //Altera o evento 3070 da ocorrencia anterior para 3071 e exclui o 3070.
                $calc_folhaAnterior = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha(
                    $this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, 1, $ocorrencia, $this->_mes_competencia, $this->_mes_competencia
                )[0];
                $itemCalcCompetenciaAnterior = new FpaitecalcfolhaEntity($this->entityManager, $this->hcmParameters, $calc_folhaAnterior->getNrcalculofolha());
                $itemCalcCompetenciaAnterior->retornaItensPorVinculo($this->_vinculo->getNrorg(), $this->_vinculo->getNrvinculom(), $calc_folhaAnterior->getNrcalculofolha());
                
                $liquido = $itemCalcCompetenciaAnterior->verificaLiquido(
                    $this->_assoc_eventos, $this->_eventom, $this->_nrorg
                );
                
                if(!$liquido){
                    continue;
                }
                
                $eventoBase = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_INCID_INSS_CONSOL, $this->_eventom, $this->_nrorg
                );
        
                $listaEventosOrigemDestino = array_combine(array($eventoAuxBase->getNreventom()), array($eventoBase->getNreventom()));
                
                $this->_media->geraEventoMedia(
                    $this->_itens_calculo_principal, $listaEventosTotalizadosBASE, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_MENSAL,
                    False, 1, $tipoLancamento
                );
                
                //Exclui evento 3071 caso exista.
                $evento_InssAnterior3071 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_INCID_INSS_CONSOL);
                $indice = $itemCalcCompetenciaAnterior->procuraEvento($evento_InssAnterior3071);
                $eveInssAnterior3071 = $itemCalcCompetenciaAnterior->getItem($indice);
                if($eveInssAnterior3071){
                    $itemCalcCompetenciaAnterior->excluiItem($eveInssAnterior3071, $indice);
                }
                
                //Altera evento 3070 para 3071 e exclui o 3070.
                $evento_InssAnterior = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_INCID_INSS);
                $indice = $itemCalcCompetenciaAnterior->procuraEvento($evento_InssAnterior);
                $eveInssAnterior = $itemCalcCompetenciaAnterior->getItem($indice);
                $valor = $eveInssAnterior->getVreventofolha();
                $evento_InssAnterior3071 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_INCID_INSS_CONSOL);
                $itemCalcCompetenciaAnterior->geraEvento($evento_InssAnterior3071, null, $valor, 0, 1, $tipoLancamento);
                $itemCalcCompetenciaAnterior->excluiItem($eveInssAnterior, $indice);
                $itemCalcCompetenciaAnterior->persist();
                
                /*Retorna objeto do evento associado a base de INSSE folha mensal*/
                $eventoAuxInss = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_INSS_CALC , $this->_eventom, $this->_nrorg
                );
                
                $listaEventosTotalizadosINSS = $this->_media->calcula(
                    $this->_vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $eventoAuxInss->getNreventom(), $this->_mes_competencia,
                    $this->_ult_dia_mes, $this->_nrTipoModalidadeCalculo, $ocorrencia
                );
                
                //Evento 1131
                $eventoInss = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_INSS_CALC_CONSOL, $this->_eventom, $this->_nrorg
                );
                
                $listaEventosTotal1131 = $this->_media->calcula(
                    $this->_vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $eventoInss->getNreventom(), $this->_mes_competencia,
                    $this->_ult_dia_mes, $this->_nrTipoModalidadeCalculo, $ocorrencia
                );
                
                if($listaEventosTotalizadosINSS && $listaEventosTotal1131){
                    $listaEventosTotalizadosINSS[1130]['VAL'] += $listaEventosTotal1131[1131]['VAL'];    
                }
                
                $listaEventosOrigemDestino = array_combine(array($eventoAuxInss->getNreventom()), array($eventoInss->getNreventom()));
                
                $this->_media->geraEventoMedia(
                    $this->_itens_calculo_principal, $listaEventosTotalizadosINSS, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_MENSAL,
                    False, 1, $tipoLancamento
                );
            }
        }
    }
    
     public function _consolidaIrrfOcor(){

        /*Retorna objeto do evento associado a base de INSS  folha mensal*/
        $eventoAuxBase = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_INCID_IRRF , $this->_eventom, $this->_nrorg
        );
        $ocorrencias = array(1,2,3,4,5);
        
        foreach($ocorrencias as $ocorrencia){
            
            if($this->_nrOcorrenciaCalculo == $ocorrencia){
                continue;
            }
            $tipoLancamento = 'REFERENCIA_VALOR';
            
            if($this->_nrOcorrenciaCalculo > 1){
                $tipoLancamento .= '_RECALCULO';
            }
            
            $listaEventosTotalizadosBASE = $this->_media->calcula(
                $this->_vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $eventoAuxBase->getNreventom(), $this->_mes_competencia,
                $this->_ult_dia_mes, $this->_nrTipoModalidadeCalculo, $ocorrencia
            );
            
            if($listaEventosTotalizadosBASE){
    
                $eventoBase = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_INCID_IRRF_COMP, $this->_eventom, $this->_nrorg
                );
                
                 //Altera o evento 3080 da ocorrencia anterior para 3081 e exclui o 3080.
                $calc_folhaAnterior = $this->entityManager->getRepository(Repositories::FPA_CALCULOFOLHA)->retornaCalculoFolha(
                    $this->_nrorg, FpatipomovimentEntity::TP_MOV_MENSAL, 1, $ocorrencia, $this->_mes_competencia, $this->_mes_competencia
                )[0];
                $itemCalcCompetenciaAnterior = new FpaitecalcfolhaEntity($this->entityManager, $this->hcmParameters, $calc_folhaAnterior->getNrcalculofolha());
                $itemCalcCompetenciaAnterior->retornaItensPorVinculo($this->_vinculo->getNrorg(), $this->_vinculo->getNrvinculom(), $calc_folhaAnterior->getNrcalculofolha());
                
                $liquido = $itemCalcCompetenciaAnterior->verificaLiquido(
                    $this->_assoc_eventos, $this->_eventom, $this->_nrorg
                );
                
                if(!$liquido){
                    continue;
                }
                
                //verifica se a data de ocorrencia do irrf e no mes.
                $evento_InssAnterior = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_INCID_IRRF);
                $indice = $itemCalcCompetenciaAnterior->procuraEvento($evento_InssAnterior);
                $eveInssAnterior = $itemCalcCompetenciaAnterior->getItem($indice);
                
                $ocorrenciaIrrf = $eveInssAnterior->getDtocorrencia();
                
                if($this->_mes_competencia->format('m/Y') !== $ocorrenciaIrrf->format('m/Y')){
                    continue;
                }
                
                $listaEventosOrigemDestino = array_combine(array($eventoAuxBase->getNreventom()), array($eventoBase->getNreventom()));
                $this->_media->geraEventoMedia(
                    $this->_itens_calculo_principal, $listaEventosTotalizadosBASE, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_MENSAL,
                    False, 1, $tipoLancamento
                );
                
                //Exclui evento 3071 caso exista.
                $evento_InssAnterior3071 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_INCID_IRRF_COMP);
                $indice = $itemCalcCompetenciaAnterior->procuraEvento($evento_InssAnterior3071);
                $eveInssAnterior3071 = $itemCalcCompetenciaAnterior->getItem($indice);
                if($eveInssAnterior3071){
                    $itemCalcCompetenciaAnterior->excluiItem($eveInssAnterior3071, $indice);
                }
                
                //Altera evento 3070 para 3071 e exclui o 3070.
                $valor = $eveInssAnterior->getVreventofolha();
                $evento_InssAnterior3071 = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_INCID_IRRF_COMP);
                $itemCalcCompetenciaAnterior->geraEvento($evento_InssAnterior3071, null, $valor, 0, 1, $tipoLancamento);
                $itemCalcCompetenciaAnterior->excluiItem($eveInssAnterior, $indice);
                $itemCalcCompetenciaAnterior->persist();
                
                /*Retorna objeto do evento associado a base de INSSE folha mensal*/
                $eventoAuxInss = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_IRRF_CALC , $this->_eventom, $this->_nrorg
                );
                
                $listaEventosTotalizadosINSS = $this->_media->calcula(
                    $this->_vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $eventoAuxInss->getNreventom(), $this->_mes_competencia,
                    $this->_ult_dia_mes, $this->_nrTipoModalidadeCalculo, $ocorrencia
                );
                
                //Evento 1131
                $eventoInss = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_IRRF_CALC_COMP, $this->_eventom, $this->_nrorg
                );
                
                $listaEventosTotal1131 = $this->_media->calcula(
                    $this->_vinculo, FpatipomovimentEntity::TP_MOV_MENSAL, $eventoInss->getNreventom(), $this->_mes_competencia,
                    $this->_ult_dia_mes, $this->_nrTipoModalidadeCalculo, $ocorrencia
                );
                
                if($listaEventosTotalizadosINSS && $listaEventosTotal1131){
                    $listaEventosTotalizadosINSS[1330]['VAL'] += $listaEventosTotal1131[1333]['VAL'];    
                }
                
                $listaEventosOrigemDestino = array_combine(array($eventoAuxInss->getNreventom()), array($eventoInss->getNreventom()));
                
                $this->_media->geraEventoMedia(
                    $this->_itens_calculo_principal, $listaEventosTotalizadosINSS, $listaEventosOrigemDestino, FpatipomovimentEntity::TP_MOV_MENSAL,
                    False, 1, $tipoLancamento
                );
            }
        }
    }
    
    public function _geraValorReferenciaFerias(
         $evento_aux,  $itensFerias, $demonstraForaMes = false
    ){
        $return = false;
        $itens = $itensFerias->retornaItens($evento_aux);
        if (count($itens) > 0) {
            $referencia = 0;
            $valor_item = 0.0;
            foreach ($itens as $indice) {
                $dtocorrencia = $itensFerias->retornaDtocorrencia($indice);
                if ($this->_mes_competencia->format('d/m/Y') == $dtocorrencia->format('d/m/Y') || $demonstraForaMes === true) {
                    $referencia += $itensFerias->retornaReferencia($indice);
                    $valor_item += $itensFerias->retornaValor($indice);
                }
            }
            if($this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['REF']>0 && $referencia>0){
                MsgCalculo::getInstance()->adicionaMensagem('Foram encontrados mais de um lançamento de férias para o vínculo: '.$itensFerias->retornaNrvinculom($indice));
            }
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['REF'] += $referencia;
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['VAL'] += $valor_item;
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['DAT'] = $dtocorrencia;
            $return = true;
        }
        return $return;
    }
    
    //Busca Valor ocorrencia 2.
    public function geraValorReferenciaFeriasOcor2($evento_aux,  $itensFerias, $demonstraForaMes = false){
        $itens2 = $itensFerias->retornaItens($evento_aux);
        if (count($itens2) > 0) {
            $referencia = 0;
            $valor_item = 0.0;
            foreach ($itens2 as $indice2) {
                $dtocorrencia = $itensFerias->retornaDtocorrencia($indice2);
                if ($this->_mes_competencia->format('d/m/Y') == $dtocorrencia->format('d/m/Y') || $demonstraForaMes === true) {
                    $referencia += $itensFerias->retornaReferencia($indice2);
                    $valor_item += $itensFerias->retornaValor($indice2);
                }
            }
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['REF'] += $referencia;
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['VAL'] += $valor_item;
            $this->_demonstraFeriasResumo[$evento_aux->getNreventom()]['DAT'] = $dtocorrencia;
        }
    }

    public function _verificaTrabalhoEfetivo($vinculo){
        if ($this->_nrCalendario === null) {
            MsgCalculo::getInstance()->adicionaMensagem('Calendário não parametrizado na estrutura do vínculo.');
            $this->_dias_trabalhados = 0;
            return;
        }
        
        $this->_inicio_periodo = $this->_mes_competencia;
        $this->_fim_periodo = $this->_ult_dia_mes;
        
        $vinculo->ajustaIntervaloAdmResc($this->_inicio_periodo, $this->_fim_periodo, $this->_nrControleAdmissao);
         
        $afastamento = $this->_verificaAfastamentos(
           $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
        );
        
        $gozo_ferias = $this->_verificaFerias($vinculo, $this->_inicio_periodo, $this->_fim_periodo);
        $vet_dias_uteis = array();
        $this->_calendario->carregaDiasUteis($this->_nrCalendario, $this->_inicio_periodo, $this->_fim_periodo);
        $this->_nrCalendarioAnterior = $this->_nrCalendario;
        
        $vet_dias_uteis = $this->_calendario->getVetDiasUteis();
        
        $this->_detalhaTrabalho(
            $afastamento, $gozo_ferias, $vet_dias_uteis, $this->_dias_uteis, $this->_dias_rsr, $this->_dias_normais,
            $this->_dias_afastados, $this->_dias_ferias
        );
        
        $this->_dias_trabalhados = $this->_dias_uteis;
        $nrEscala = $this->_vinculo->historico->getNrescalatrabm();
        if (is_numeric($nrEscala) === false) {
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem escala de trabalho.');
            return;
        }
        $idutapuraAtest = $this->escalaVinculo->historico->getIdutapuratest();
        if($idutapuraAtest==GpeescalatrabhEntity::IDUTAPURATEST_SIM){
            if (!$this->_ini_periodo_apura or !$this->_fim_periodo_apura) {
                MsgCalculo::getInstance()->adicionaMensagem('Escala de trabalho do vinculo não possui periodo de inicio e fim informado', MsgCalculo::ERRO);
                return;
            }
            $Atest = $this->_verificaAfastamentos(
               $vinculo, $this->_situacao_funcional, $this->_ini_periodo_apura, $this->_fim_periodo_apura
            );
            $Afast = $this->_verificaAfastamentos(
               $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
            );
            $this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO]=0;
        }else{
            $Atest = $this->_verificaAfastamentos(
               $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
            );
            $Afast = $this->_verificaAfastamentos(
               $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
            );
        }
        
        if((in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO, $Atest) == true)||
            (in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_DOENCA_MENOR_15, $Afast) == true)||
            (in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_ACIDENTE_MENOR_15, $Afast) == true)){
            $diasatestadoaux=0;
            $diasafastameaux=0;
            for ($i=0; $i < count($Atest); $i++) {
                if (($Atest[$i] == GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO)) {
                    $diasatestadoaux++;
                }
            }
            for ($i=0; $i < count($Afast); $i++) {
                if (($Afast[$i] == GpesitufuncmEntity::SITUACAO_FUNCIONAL_DOENCA_MENOR_15)||
                    ($Afast[$i] == GpesitufuncmEntity::SITUACAO_FUNCIONAL_ACIDENTE_MENOR_15)) {
                    $diasafastameaux++;
                }
            }
            $this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO]=$diasatestadoaux;
            $this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_DOENCA_MENOR_15]=$diasafastameaux;
            $this->_dias_normais-=($diasatestadoaux+$diasafastameaux);
            $this->_dias_atestados=($diasatestadoaux+$diasafastameaux);
            if($this->_dias_normais<0){
                $this->_dias_normais=0;
            }
        }
        
        $atestados = $this->_verificaAtestados($vinculo, $this->_inicio_periodo, $this->_fim_periodo);
        
        if($atestados > 0){
            $this->_dias_atestados += $atestados;
            $this->_dias_afastados -= $atestados;
            if($this->_dias_afastados < 0){
                $this->_dias_afastados = 0;
            }
            
            $evento = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_ATESTADO_MEDICO);
			$this->_itens_calculo_principal->geraEvento($evento, null, 0, $this->_dias_atestados, 1);
        }
        
        if ((($this->_tipoSalario ===  GpealtesalarioEntity::IDTPSALARIO_MENSAL)
            && ($vinculo->historico->getIdtppagamento() === GpevinculohEntity::IDTPPAGAMENTO_MENSAL)
            || ($this->_tipoSalario === GpealtesalarioEntity::IDTPSALARIO_HORA)
            && ($vinculo->historico->getIdtppagamento() === GpevinculohEntity::IDTPPAGAMENTO_MENSAL_SALARIO_HORA))
        ) {
            $dias_totais = $this->_dias_normais + $this->_dias_ferias + $this->_dias_afastados+$this->_dias_atestados;
            
            if ($this->_dias_normais > 30) {
                $this->_dias_trabalhados -= ($dias_totais - 30);
                $this->_dias_normais -= ($dias_totais - 30);
                
            } else {
                if ($this->_mes_competencia_int == 2) {
                    if (($this->_inicio_periodo->format('d/m/Y') === $this->_mes_competencia->format('d/m/Y'))
                        &&($this->_fim_periodo->format('d/m/Y') === $this->_ult_dia_mes->format('d/m/Y'))
                    ) {
                        if($this->_dias_afastados<28){
                            $this->_dias_trabalhados += (30 - $dias_totais);
                            $this->_dias_normais += (30 - $dias_totais);
                        }
                        
                    }else {
                        if ($this->_nrControleAdmissao == 30) {
							if(!($this->_vinculo->getDtrescisaovinc())){									
								$this->_dias_normais += $this->_nrControleAdmissao - $this->_ult_dia_mes->format('d');
							}	
                        }
                    } 
                } else {
                    if ($this->_dias_atestados>0 || ($this->_dias_afastados>0 && $this->_dias_afastados<31)){
                        if ($this->_dias_normais+$this->_dias_afastados+$this->_dias_atestados > 30){
                            $this->_dias_normais = ($this->_nrControleAfastamento - $this->_dias_afastados - $this->_dias_atestados);
                            if($this->_dias_normais+$this->_dias_atestados > 30){
                                $this->_dias_normais-=1;
                            }
                            if($this->_dias_normais<0){
                                $this->_dias_normais=0;
                            }
                        }
                    }
                }
            }
            if(in_array(1, $gozo_ferias) == true && $this->_nrControleFerias==30 && count($afastamento)==31){
                $this->_dias_normais = $this->_dias_normais > 0 ? $this->_dias_normais-=1 : 0;
            }
        } else {
            if ($vinculo->historico->getIdtppagamento() === null) {
                $msg = 'Nao parametrizado Tipo de Pagamento para o vinculo ';
                $msg .=$vinculo->getNrvinculom().'.';
                MsgCalculo::getInstance()->adicionaMensagem($msg);
            } else {
                $msg = 'Tipo de Pagamento incompativel entre a Alteracao Salarial e o Vinculo ';
                $msg .=$vinculo->getNrvinculom().'.';
                MsgCalculo::getInstance()->adicionaMensagem($msg);
            }
        }
    
        $this->_dias_maternidade = $this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE];
        
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_DIAS_TRAB, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
    }

    public function _detalhaTrabalho(array $afastamento, array $gozo_ferias, array $vet_dias_uteis, &$diasUteis,
                                      &$diasDsr, &$diasNormais, &$diasAfastados, &$diasFerias)
    {
        $this->_dias_uteis_ferias = 0;
        $this->_dias_rsr_ferias = 0;
        $this->_sit_func_resumo = $this->_situacao_funcional->getSituacaoFuncionalResumo();
        for ($i=0; $i < count($afastamento); $i++) {
            if ($afastamento[$i] !== -1) {
                $afast = $afastamento[$i];
                
                $this->_sit_func_resumo[$afast]++;
                
                $sit_func = $this->_situacao_funcional->retornaSituacaoFuncional(
                    $this->_nrOrgPadrao, $this->_nrorg, $afastamento[$i]
                );
                
                if ($sit_func->historico && $sit_func->historico->getIdsuspremunera() == GpesitufunchEntity::IDSUSPREMUNERA_SIM) {
                    if ($sit_func->historico && $sit_func->historico->getIdafastsitufunc() == GpesitufunchEntity::IDAFASTSITUFUNC_NAO) {
                        if ($vet_dias_uteis[$i] == 'S') {
                            $diasUteis++;
                        } else {
                            $diasDsr++;
                        }
                        if($sit_func->getNrsitufuncm() == GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO
                            ||$sit_func->getNrsitufuncm()== GpesitufuncmEntity::SITUACAO_FUNCIONAL_DOENCA_MENOR_15
                            ||$sit_func->getNrsitufuncm()== GpesitufuncmEntity::SITUACAO_FUNCIONAL_ACIDENTE_MENOR_15){
                            $diasNormais++;
                        }
                    }else{
                        $diasAfastados++;
                    }
                } elseif ($gozo_ferias[$i] != -1) {
                    $diasFerias++;
                    if ($vet_dias_uteis[$i] == 'S') {
                        $diasUteis++;
                        $this->_dias_uteis_ferias++;
                    } else {
                        $diasDsr++;
                        $this->_dias_rsr_ferias++;
                    }
                } else {
                    $diasNormais++;
                    if ($vet_dias_uteis[$i] == 'S') {
                        $diasUteis++;
                    } else {
                        $diasDsr++;
                    }
                }
            } else {
                if ($gozo_ferias[$i] != -1) {
                    $diasFerias++;
                    if ($vet_dias_uteis[$i] == 'S') {
                        $diasUteis++;
                        $this->_dias_uteis_ferias++;
                    } else {
                        $diasDsr++;
                        $this->_dias_rsr_ferias++;
                    }
                }else{
                    $diasNormais++;
                    if ($vet_dias_uteis[$i] == 'S') {
                        $diasUteis++;
                    } else {
                        $diasDsr++;
                    }
                }
            }
        }
        if(isset($this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO])){
            $this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_ATESTADO]+=
            $this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_DOENCA_MENOR_15];
        }
        if(isset($this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_DOENCA_MENOR_15])){
            $this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_DOENCA_MENOR_15]=0;
        }
    }

    public function _geraReferenciaSitFunc(){
        foreach ($this->_sit_func_resumo as $key=>$situacao) {
            
            if ($key > 0 && $situacao > 0) {
                $sit_func = $this->_situacao_funcional->retornaSituacaoFuncional(
                    $this->_nrOrgPadrao, $this->_nrorg, $key
                );
                $eventos = $this->_sit_evento->retornaEvento($key, $this->_mes_competencia);
                foreach ($eventos as $nr_evento) {
                    $evento = $this->_eventom->retornaEvento($nr_evento);
                    if ($evento->historico){
						if ($evento->historico->getIdunidrefereven() !== FpaeventohEntity::IDUNIDREFEREVEN_DIA) {
							$referencia = FpaeventomEntity::compatibilizaReferenciaHoras(
								$situacao, FpaeventohEntity::IDUNIDREFEREVEN_DIA, $this->_jornada_diaria
							);
						} else {
						    if($situacao == $this->_ult_dia_mes->format('d')){
								$referencia = 30;
							} else {
								$referencia = $situacao;
							}
						}
						$this->_itens_calculo_principal->geraEvento($evento, null, 0, $referencia, 1);
					}
                }
            }
        }
    }

    public function _verificaFerias($vinculo, $inicioPeriodo, $fimPeriodo){

        $this->_ferias->retornaFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());

        if ($this->_simulacao === false) {
            $nrTpVinculo =$vinculo->getNrtipovinculom();
            if ($nrTpVinculo === null) {
                MsgCalculo::getInstance()->adicionaMensagem('Não parametrizado o tipo de vínculo.');
            }
            
            if ($this->_nrTpVinculoAnterior !== $nrTpVinculo) {
                $objTpFeriasVinc = $this->_tpFeriasVinc->retornaTpFeriasPorTpVinculo(
                    $this->_nrorg, $this->_nrOrgPadrao, $nrTpVinculo, $this->_jornada_semanal
                );
            }

            if($this->_nr_tipo_calculo != FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR) {
                if ($this->_nrTipoModalidadeCalculo == 1 && !$this->_simulacao && !$this->_parcial) {
                    $this->_ferias->verificaPeriodoAquisitivo(
                       $vinculo, $this->_eventom, $this->_alteracao_situacao_funcional,
                        $this->_faltas_intervalo, $objTpFeriasVinc, $this->_mes_competencia, $this->_jornada_diaria,
                        $this->_nrTipoModalidadeCalculo, $this->_nrOcorrenciaCalculo
                    );
                }
            }
        }
        $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());

        try{
            $gozo_ferias = $this->_gozo_ferias->retornaDiasFerias($inicioPeriodo, $fimPeriodo);
        }
        catch(Exception $e){
            MsgCalculo::getInstance()->adicionaMensagem('Erro ao buscar dias de férias do vínculo: Ao tentar buscar o erro foi: '.$e->getMessage());
        }
        return $gozo_ferias;
    }

    public function _verificaAfastamentos($vinculo, $situacao_funcional,
                                           $inicioPeriodo, $fimPeriodo)
    {
        $this->_alteracao_situacao_funcional->retornaAlteracaoSituacaoFuncional(
           $vinculo->getNrorg(), $vinculo->getNrvinculom(), $vinculo->getDtadmissaovinc()
        );
        $afastamento = $this->_alteracao_situacao_funcional->retornaDiasAfastamento(
            $situacao_funcional, $inicioPeriodo, $fimPeriodo, false, $vinculo->getNrvinculom()
        );
        return $afastamento;

    }
    
    public function _verificaAtestados($vinculo, $inicioPeriodo, $fimPeriodo)
    {
        $situFuncs = $this->_alteracao_situacao_funcional->retornaSituacaoFuncionalDentroPeriodo(
           $vinculo->getNrorg(), $vinculo->getNrvinculom(), $inicioPeriodo, $fimPeriodo
        );
        $dias = 0;
        
        foreach($situFuncs as $situFunc){
                
            if(!$situFunc->getQtdiasatestadoempr() > 0){
                continue;
            }
            
            $dtinisitufunc = $situFunc->getDtinisitufunc();
            $nrDiasAtestado = $situFunc->getQtdiasatestadoempr();
            $dtFimAtestado = DateUtil::adicionaIntervalo($dtinisitufunc, $nrDiasAtestado - 1);
            
            //Dia Ini SituFunc entre a competencia.
            if($dtinisitufunc > $inicioPeriodo && $dtFimAtestado > $fimPeriodo){
                $dias = DateUtil::getQtdeDiasEntre($dtinisitufunc, $fimPeriodo) + 1;
            }else if($dtinisitufunc > $inicioPeriodo && $fimPeriodo > $dtFimAtestado){
                $dias = DateUtil::getQtdeDiasEntre($dtinisitufunc, $dtFimAtestado) + 1;
            }//Dia Fim SituFunc entra a competencia
            else if($inicioPeriodo < $dtFimAtestado){
                $dias = DateUtil::getQtdeDiasEntre($inicioPeriodo, $dtFimAtestado) + 1;
            }
        }
        
        return $dias;

    }
    
    public function _retrocesso($item_corrente){
        $item_corrente->executaRetrocesso($this->_eventom);
    }

    public function _setaValorTipoSalario($dataLimite){
        
        if ($this->_ambiente_salario_operador === GpeParamoperEntity::IDAMBIENTESAL_REAL) {
            $nrModalidade = $this->_vinculo->historico->getNrtpmodalidsal();
        } else {
            $nrModalidade = $this->_tp_modalidade_salario_operador;
        }
        $this->_dataBaseDissidio = null;
        
        $carregou = $this->_alteracaoSalario->carregaAlteracaoSalario($dataLimite,  $this->_vinculo->getNrvinculom(), $nrModalidade);
        if ($carregou === true) {
            $this->_salario = $this->_alteracaoSalario->getSalario();
            
            if(($this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_13SAL || $this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_ADIANT_13SAL) 
                && $this->_idConsalReducao == "N")
            {
                $this->_salario = $this->_alteracaoSalario->retornaAlteSalarioMaior($this->_mes_competencia, $this->_vinculo->getNrvinculom(), $nrModalidade);
            }
            
            $this->_tipoSalario = $this->_alteracaoSalario->getTipoSalario();
            $this->_tipoAltSal = $this->_alteracaoSalario->getTipoAlteSal();
            $this->_dataDissidio = $this->_alteracaoSalario->getDtalterasalario();
            if($this->_tipoAltSal==GpealtesalarioEntity::ALTERACAO_SALARIO_DISSIDIO||
			    $this->_tipoAltSal==5||
				$this->_tipoAltSal==9){
                if ($this->_alteracaoSalario->getDataBaseDissidio() != null) {
                    $this->_dataBaseDissidio= DateUtil::getDataDeString($this->_alteracaoSalario->getDataBaseDissidio());
                }
            }
        } else {
            $msg = 'Não encontrado valor de salário para o vínculo '. $this->_vinculo->getNrvinculom().'.<br />';
            $msg .= 'Favor verificar Tipo de Modalidade Salarial ou a Competência';
            
            MsgCalculo::getInstance()->adicionaMensagem($msg);
            
        }
        
        $this->salarioProporcional = null;
        
        if($this->_idPropSal == 'S'){
            $this->proporcionalizaSalario();
        }

        if($this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR && $this->_vr_salarioDissidio!=null){
            $this->_salario = $this->_vr_salarioDissidio;
        }
    }
    
    public function proporcionalizaSalario(){
        
        if ($this->_ambiente_salario_operador === GpeParamoperEntity::IDAMBIENTESAL_REAL) {
            $nrModalidade = $this->_vinculo->historico->getNrtpmodalidsal();
        } else {
            $nrModalidade = $this->_tp_modalidade_salario_operador;
        }
        
        $salarios = $this->_alteracaoSalario->retornaAlteSalarioUltimas($this->_mes_competencia, $this->_vinculo->getNrvinculom(), $nrModalidade);
        
        if($salarios[0] && $salarios[1]){
            $salarioAtual = $salarios[0];
            $salarioAnterior = $salarios[1];
            
            if($salarioAtual->getDtaltesalario()->format('m') == DateUtil::getDataDeString($this->_mes_competencia)->format('m') && $salarioAtual->getDtaltesalario()->format('d') > 1){
            
                $diaReajuste = $salarioAtual->getDtaltesalario()->format('d');
                
                $diasNovoSalario = 30 - $diaReajuste;
                
                $vrSalarioAtual = $salarioAtual->getVrsalario();
                $vrSalarioAnterior = $salarioAnterior->getVrsalario();
                
                $vrSalarioAtualProp = round(($vrSalarioAtual / 30) * ($diasNovoSalario + 1), 2);
                $vrSalarioAntProp = round(($vrSalarioAnterior / 30) * ($diaReajuste - 1), 2);
                
                $this->salarioProporcional = $vrSalarioAtualProp + $vrSalarioAntProp;
            }
        }
    }
    
    
    public function _verificaDifSalarial($dataLimite, $vinculo){
        if((DateUtil::isBetween($this->_dataDissidio, $this->_mes_competencia, $this->_ult_dia_mes))
            && ($this->_tipoAltSal==GpealtesalarioEntity::ALTERACAO_SALARIO_DISSIDIO ||
                $this->_tipoAltSal==GpealtesalarioEntity::ALTERACAO_SALARIO_CONVENSAO ||
                $this->_tipoAltSal==GpealtesalarioEntity::ALTERACAO_SALARIO_ACORDO)){
            if ($this->_ambiente_salario_operador === GpeParamoperEntity::IDAMBIENTESAL_REAL) {
                $nrModalidade = $this->_vinculo->historico->getNrtpmodalidsal();
            } else {
                $nrModalidade = $this->_tp_modalidade_salario_operador;
            }
            
            $dataLimite = DateUtil::subtraiIntervalo($dataLimite, 1, DateUtil::MES);
            
            $parcelas=0;
            $carregou = $this->_alteracaoSalario->carregaAlteracaoSalario($dataLimite,  $this->_vinculo->getNrvinculom(), $nrModalidade);
            if ($carregou === true) {
                $salAnterior = $this->_alteracaoSalario->getSalario();
                $difSal=$this->_salario-$salAnterior;
                $calculoEvento = $this->_salario.'(Salario) - '.$salAnterior.' (Salario Anterior) *';
                
                if ($this->_dataBaseDissidio != null) {
                    if($this->_dataBaseDissidio < $this->_vinculo->getDtadmissaovinc()){
                        $this->_dataBaseDissidio = DateUtil::getDataDeString($this->_vinculo->getDtadmissaovinc());
                        $prop_admissao=true;
                    }

                    if($this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR && $this->_nrOcorrenciaCalculo==1){
                        $dtRescisao = DateUtil::getDataDeString($vinculo->getDtrescisaovinc());
                        $parcelas= $this->_calculaMeses($this->_dataBaseDissidio, $dtRescisao);
                        $parcelas -= 1;
                    }else{
                        $parcelas= $this->_calculaMeses($this->_dataBaseDissidio, $dataLimite);
                    }
                        if($prop_admissao==true && $parcelas >=1){
                        $prop=(30-$this->_dataBaseDissidio->format('d') + 1) / 30;
                        $parcelas-=1;
                        $parcelas+=$prop;
                    }
                } else {
                    $parcelas=0;
                }
            } else {
                $msg = 'Não encontrado valor de salário anterior para realizar diferença salarial para o vínculo '. $this->_vinculo->getNrvinculom().'.<br />';
                $msg .= 'Favor verificar Tipo de Modalidade Salarial ou a Competência';
                
                MsgCalculo::getInstance()->adicionaMensagem($msg);
                
            }
            if ($parcelas>0) {
                $evento_difSalario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_DIF_SALARIO_DISSIDIO, $this->_eventom, $this->_nrorg
                );
                $calculoEvento .= $parcelas.' = '.$difSal*$parcelas;
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_difSalario, $calculoEvento, $this->_mes_competencia, $difSal*$parcelas, $parcelas,null,null,null,100);
                $this->_itens_calculo_principal->geraEvento($evento_difSalario,null, $difSal*$parcelas, $parcelas,1);
            }
        }
    }

    public function _geraEventoSalarioRepousoRemunerado(
         $itens_calculo,  $evento_salario,  $evento_rsr = null,
        $nr_tipo_calculo
    ){
        if (($nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ) {
            $dias_trab_aux = $this->_dias_normais;
            
            if ($evento_rsr !== null) {
                $referencia = $evento_rsr->compatibilizaReferenciaDiasParaN(
                    $this->_dias_rsr, $this->_jornada_diaria
                );
                $itens_calculo->geraEvento($evento_rsr, null, 0, $referencia, 1);
                $dias_trab_aux = $this->_dias_normais - $this->_dias_rsr < 0 ? 0 : $this->_dias_normais - $this->_dias_rsr;
            }
            
            if ($evento_salario !== null) {
                $referencia = $evento_salario->compatibilizaReferenciaDiasParaN(
                    $dias_trab_aux, $this->_jornada_diaria
                );
                $itens_calculo->geraEvento($evento_salario, null, 0, $referencia, 1);
            }
            $this->_dias_remuneracao = $this->_dias_normais; 
            
        } else {
            $this->_dias_remuneracao = 30; 
            if($evento_salario){
                $referencia = $evento_salario->compatibilizaReferenciaDiasParaN(30, $this->_jornada_diaria);
                $itens_calculo->geraEvento($evento_salario, null, 0, $referencia, 1);
                $posicao = $itens_calculo->procuraEvento($evento_salario, null);
    
                if ($posicao !== -1) {
                    $itens_calculo->atribuiCalculoDemonstrativo($posicao, FpaitecalcfolhaEntity::IDEVENDEMONCALC_SIM);
                }
            }
        }
    }

    public function _geraReferenciaSalario(
         $itens_calculo, $nr_tipo_calculo, $tipoRemuneracao, $nrVinculom
    ){

        $evento_salario = null;
        $evento_rsr = null;

        switch ($tipoRemuneracao) {
            case GpevinculohEntity::IDREMUNERACAO_SAL1:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_1, $this->_eventom, $this->_nrorg
                );
                break;
            case GpevinculohEntity::IDREMUNERACAO_SAL1_RSR:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_1, $this->_eventom, $this->_nrorg
                );
                $evento_rsr = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_REPOUSO_REMUNERADO, $this->_eventom, $this->_nrorg
                );
                break;
            case GpevinculohEntity::IDREMUNERACAO_SAL2:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_2, $this->_eventom, $this->_nrorg
                );
                break;
            case GpevinculohEntity::IDREMUNERACAO_SAL2_RSR:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SALARIO_2, $this->_eventom, $this->_nrorg
                );
                $evento_rsr = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_REPOUSO_REMUNERADO, $this->_eventom, $this->_nrorg
                );
                break;
            case GpevinculohEntity::IDREMUNERACAO_ESTAGIO:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_BOLSA_ESTAGIO, $this->_eventom, $this->_nrorg
                );
                break;
            case GpevinculohEntity::IDREMUNERACAO_SOCIO:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_SOCIO, $this->_eventom, $this->_nrorg
                );
                break;
            case GpevinculohEntity::IDREMUNERACAO_AUTONOMO:
                $evento_salario = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_AUTONOMO, $this->_eventom, $this->_nrorg
                );
                break;
            case GpevinculohEntity::IDREMUNERACAO_NENHUM:
                break;
            default:
                MsgCalculo::getInstance()->adicionaMensagem('Tipo de Remuneração incompatível para o vínculo '.$nrVinculom.'.');
                break;
        }
        $this->_geraEventoSalarioRepousoRemunerado(
            $itens_calculo, $evento_salario, $evento_rsr, $nr_tipo_calculo
        );
    }

    public function _calculaSalario($itens_calculo){
        
        if($this->salarioProporcional){
            $this->_calculaDiversos(
                $itens_calculo, null, FpatipoassoceveEntity::ASSOC_SALARIO_1, 100, $this->_mes_competencia, $this->salarioProporcional
            );
            $this->_calculaDiversos(
                $itens_calculo, null, FpatipoassoceveEntity::ASSOC_SALARIO_2, 100, $this->_mes_competencia, $this->salarioProporcional
            );
        }else{
            $this->_calculaDiversos(
                $itens_calculo, null, FpatipoassoceveEntity::ASSOC_SALARIO_1, 100, $this->_mes_competencia, 0.0
            );
            $this->_calculaDiversos(
                $itens_calculo, null, FpatipoassoceveEntity::ASSOC_SALARIO_2, 100, $this->_mes_competencia, 0.0
            );
        }
        
        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_REPOUSO_REMUNERADO, 100, $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_BOLSA_ESTAGIO, 100, $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_SOCIO, 100, $this->_mes_competencia, 0.0
        );

        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_AUTONOMO, 100, $this->_mes_competencia, 0.0
        );

        if (in_array(FpaProcessoEntity::SALARIO_MATERNIDADE, $this->_listaProcessos) === true){
            if($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){
                $this->_calculaDiversos(
                    $itens_calculo, FpatipoincideEntity::INC_SAL_MATERNI, FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE,
                    100, $this->_mes_competencia, 0.0
                );
            }
        }else{
            $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE, $this->_eventom, $this->_nrorg
            );
            $itens_calculo->retiraitem($eventoAux);
        }
        
        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_DIFERENCA_SALARIO, 100, $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, null, FpatipoassoceveEntity::ASSOC_FALTAS_ABONADAS, 100, $this->_mes_competencia, 0.0
        );
        
        if($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_PROVISAO_CONTABIL){
            $this->_calculaDiversos(
                $itens_calculo, null, FpatipoassoceveEntity::ASSOC_ATESTADO_MEDICO, 100, $this->_mes_competencia, 0.0
            );
        }
    }

    public function _calculaSalarioFamilia($vinculo){
        if (in_array(FpaProcessoEntity::SALARIO_FAMILIA, $this->_listaProcessos) === true){
            $afastamento = $this->_verificaAfastamentos(
               $vinculo, $this->_situacao_funcional, $this->_inicio_periodo, $this->_fim_periodo
            );
            if(in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_NORMAL, $afastamento) or
                in_array(13, $afastamento) or                
                in_array(100043, $afastamento) or
                in_array(GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE, $afastamento)){
                      
                $diasProporcionaliza = $this->_dias_normais;
                $diasProporcionaliza = $diasProporcionaliza > $this->_nrControleAdmissao ? $this->_nrControleAdmissao : $diasProporcionaliza;
                
                $SalarioFamilia = new SalarioFamilia();
                
                $SalarioFamilia->calcula(
                    FpatipoincideEntity::INC_SAL_FAMILIA, FpatipoassoceveEntity::ASSOC_SALARIO_FAMILIA,
                    $this->_mes_competencia, $this->_itens_calculo_principal, $this->_assoc_eventos, $this->_eventom,
                    $vinculo, $diasProporcionaliza, 
                    $this->_salario, $this->entityManager 
                );
            }
        }
    }

    public function _calculaContribuicaoSindical($vinculo){
        if (in_array(FpaProcessoEntity::CONTRIBUICAO_SINDICAL, $this->_listaProcessos) === true) {
            ContribuicaoSindical::calcula(
                FpatipoassoceveEntity::ASSOC_CONTRIB_SINDICAL, $this->_mes_competencia, $this->_itens_calculo_principal,
                $this->_assoc_eventos, $this->_eventom, $vinculo
            );
            $this->_calculaDiversos(
                $this->_itens_calculo_principal, FpatipoincideEntity::INC_CONT_SINDICAL,
                FpatipoassoceveEntity::ASSOC_CONTRIB_SINDICAL, 100, $this->_mes_competencia, 0.0
            );
        }
    }

    public function _calculaDiversos($itens_calculo, $incidencia, $nr_evento, $percentual, $mes_competencia,
        $base = 0.0
    ) {
        if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ){
            if ( $this->_itens_calculo_principal!==$itens_calculo ){
                $this->_baseCorrespPeriodoIntegral = true;
            } else {
                if (($incidencia == FpatipoincideEntity::INC_FALTAS) or ($incidencia == FpatipoincideEntity::INC_HORA_EXTRA)) {
                    $this->_baseCorrespPeriodoIntegral = true;
                } else {
                    $this->_baseCorrespPeriodoIntegral = false;
                }
            }

        } else {
            $this->_baseCorrespPeriodoIntegral = true;
        }
        
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nr_evento, $this->_eventom, $this->_nrorg);
        
        if ($evento_aux !== null) {
            $itens = $itens_calculo->retornaItens($evento_aux);
            if ($base === 0.0) {
                $base = $this->_calculaBase($itens_calculo, $incidencia, $mes_competencia);
            } else{
                $this->_baseCorrespPeriodoIntegral = true;
            }
            
            $tipo_referencia = $evento_aux->historico->getIdunidrefereven();
            $qtd_dias = 0;
            foreach ($itens as $indice) {
                $referencia = $itens_calculo->retornaReferencia($indice);
                
                switch ($tipo_referencia) {
                    case FpaeventohEntity::IDUNIDREFEREVEN_PERCENTUAL:
                        if($referencia!=0){
                            $valor_item = ($base * $referencia)/100;
                            $calculoEvento = '('.$base.' (Base) * '.$referencia.' (Referência)) / 100';
                        }else{
                            $valor_item=$itens_calculo->retornaValor($indice);
                            $calculoEvento = 'Valor Evento Folha';
                        }
                        
                        break;
                    case FpaeventohEntity::IDUNIDREFEREVEN_DIA :
                    case FpaeventohEntity::IDUNIDREFEREVEN_HORA :
                    case FpaEventohEntity::IDUNIDREFEREVEN_HORA_MINUTO:
                        if ($this->_baseCorrespPeriodoIntegral === false) {
                            $valor_hora = $base / $this->_calculaHoraEfetivas();
                        } else {
                            if (($incidencia == FpatipoincideEntity::INC_FALTAS) or ($incidencia == FpatipoincideEntity::INC_HORA_EXTRA)) {
								$valor_hora = $this->_salario / ($this->_jornada_diaria * 30);
                            } else {
								$valor_hora = $base / ($this->_jornada_diaria * 30);
							}
                        }

                        $calculoEvento = 'Valor Hora: ('.$valor_hora. ' * '.$percentual.') / 100';
                        $valor_hora = ($valor_hora * $percentual)/100;
                        $calculoEvento .= ' = '.$valor_hora.PHP_EOL;
                       
                        $ref_hora = FpaeventomEntity::compatibilizaReferenciaHoras(
                            $referencia, $tipo_referencia, $this->_jornada_diaria
                        );
                        $valor_item = $valor_hora * $ref_hora;
                        $calculoEvento .= 'Referencia Hora: '.$ref_hora.PHP_EOL.'Valor Evento: '.$valor_hora.' * '.$ref_hora.' = '.$valor_item;
                        if ($referencia === $ref_hora) {
                            $qtd_dias += ($referencia / $this->_jornada_diaria);
                        } else {
                            if ($tipo_referencia === FpaeventohEntity::IDUNIDREFEREVEN_DIA) {
                                $qtd_dias += $referencia;
                            } else {
                                $qtd_dias += ($ref_hora / $this->_jornada_diaria);
                            }
                        }
                        break;
                    case FpaeventohEntity::IDUNIDREFEREVEN_12_AVOS:
                        $valor_item = ($base * $referencia)/12;
                        $calculoEvento = '('.$base.' (Base) * '.$referencia.' (Referência) = '.$valor_item;
                        $calculoEvento .= PHP_EOL.'('.$valor_item.' (Valor) * '.$percentual.' (Percentual) / 100 = ';
                        $valor_item = ($valor_item * $percentual)/100;
                        $calculoEvento .= $valor_item;
                        break;
                    default:
                        $msg = 'Tipo de referência '.$tipo_referencia.' não tratada - CalculaDiversos - CALCULO.PHP';
                        $msg .= ' Evento: '.$evento_aux->historico->getNmeventoh();
                        $msg .= ' Ref: '.$referencia.' Valor: '.$valor_item;
                        $msg .= ' Vínculo: '.$this->_vinculo->getNrvinculom().' Valor: ';
                        MsgCalculo::getInstance()->adicionaMensagem('Tipo de referência '.$tipo_referencia.' não tratada. Evento: '.$evento_aux->historico->getNmeventoh().' Ref: '.$referencia.' Valor: '.$valor_item);
                        break;
                }
                $dtocorrencia = $itens_calculo->retornaDtocorrencia($indice);
                MemoriaCalculo::getInstance()->escreveEventos($itens_calculo->getNrcalculofolha(), $evento_aux, $calculoEvento, $dtocorrencia,(float)$valor_item, $referencia, $tipo_referencia, $base, $incidencia, $percentual);
                
                $itens_calculo->geraEvento($evento_aux, $dtocorrencia, (float)$valor_item, $referencia, 1);
                unset($dtocorrencia);
            }
            return $qtd_dias;
        } else {
            MsgCalculo::getInstance()->adicionaMensagem('Evento não associado ('.$nr_evento.').');
        }
    }

    public function _atribuiValor( $itens_calculo, $nr_evento, $valor) {
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nr_evento, $this->_eventom, $this->_nrorg);
        $itens = $itens_calculo->retornaItens($evento_aux);

        foreach ($itens as $indice) {
            $referencia = $itens_calculo->retornaReferencia($indice);
            $dtocorrencia = $itens_calculo->retornaDtocorrencia($indice);
            MemoriaCalculo::getInstance()->escreveEventos($itens_calculo->getNrcalculofolha(), $evento_aux, $this->calculoEventoMemoria, $dtocorrencia, $valor, $referencia,null, $this->baseMemoria,null,null);
            $itens_calculo->geraEvento($evento_aux, $dtocorrencia, $valor, $referencia, 1);
        }
    }

    public function _calculaBase(FpaitecalcfolhaEntity$itens_calculo, $incidencia, $mes_competencia){
        if ($incidencia !== null) {
            $base = $itens_calculo->calculaIncidencias($incidencia, $mes_competencia, $this->_eventom);
            $this->calculoEventoMemoria = 'Valor da Incidencia '.$incidencia;
            if ($base === 0.0) {
                $this->_baseCorrespPeriodoIntegral = true;
                $base = $this->_salario;
                $this->calculoEventoMemoria = $base.' Valor Salario';
            }
        } else {
            $this->_baseCorrespPeriodoIntegral = true;
            $base = $this->_salario;
            $this->calculoEventoMemoria = $base.' Valor Salario';
        }

        return $base;
    }

    public function _calculaHoraEfetivas(){
        return $this->_dias_normais * $this->_jornada_diaria;
    }

    public function _calculaDsrSuplementar($itens_calculo, $vinculo
    ){
        
        if (DateUtil::getDiaSemana($vinculo->getDtrescisaovinc()) == 5){
            $evento_dsr = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_DSR_SUPLEMENTAR, $this->_eventom, $this->_nrorg
            );

            $itens_calculo->geraEvento($evento_dsr, null, 0, 1, 1);

            $this->_calculaDiversos(
                $itens_calculo, null, FpatipoassoceveEntity::ASSOC_DSR_SUPLEMENTAR, 100,
                $this->_mes_competencia, 0.0
            );
        }
    }
    
    public function _calculaFaltas($itens_calculo){
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_FALTAS_DIA, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_FALTAS_HORA, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_FALTAS_HORA_MINUTO, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_FALTAS_DIA_MES_ANT, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_FALTAS_HORA_MES_ANT, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_ATRASOS, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_geraPerdaDsr($itens_calculo);
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_PERDA_RSR_DIA, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_PERDA_RSR_HORA, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_DEVOL_DESCONTO_DSR, 100,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_FALTAS, FpatipoassoceveEntity::ASSOC_DEVOL_DESCONTO_FALTA, 100,
            $this->_mes_competencia, 0.0
        );
    }

    public function _cancelaGozoFerias($vinculo, $dtinigozo, $dtfimgozo){

        $this->_ferias->retornaFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
        $this->_gozo_ferias->retornaGozoFerias($vinculo->getNrorg(), $vinculo->getNrvinculom());
        $itemGozo = $this->_gozo_ferias->procuraGozoFerias($dtinigozo);
        $exclusaoDisponivel;
        
        if ($itemGozo !== null) {
            $exclusaoDisponivel = $this->_gozo_ferias->validacaoESocial($itemGozo->getNrgozoferias(), 'excluir');
        }
        
        if(isset($exclusaoDisponivel) && $exclusaoDisponivel === true) {
            if(is_object($itemGozo)) {
                $ferias = $this->_ferias->procuraFerias($itemGozo->getNrferias());
                if(!strstr($itemGozo->getDsgozoferias(),'COLET')){
                    $this->_gozo_ferias->deletaGozoFerias($itemGozo->getNrgozoferias(), $itemGozo->getNrorg(), $itemGozo->getNrferias());
                }
                if(is_object($ferias)) {
                    $itemGozoRemanescente = $this->_ferias->getGozoFerias($ferias->getNrferias());
                    $dtfimaquisitivo = DateUtil::getDataDeString($ferias->getDtfimaquisicao());
                    
                    if (count($itemGozoRemanescente) > 0) {
                        $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_GOZADO_PARCIAL);
                    } else {
                        if ($dtfimaquisitivo > $this->_mes_competencia) {
                            $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_ABERTO);
                        } else {
                            $ferias->setIdcontrolferias(FpaferiasEntity::IDCONTROLFERIAS_ADQUIRIDO);
                        }
                    }
                    $this->entityManager->persist($ferias);
                    $this->entityManager->flush($ferias);
                }
            }else{
                MsgCalculo::getInstance()->adicionaMensagem('Não foi encontrado gozo de férias iniciado em '.$dtinigozo.' para cancelar', MsgCalculo::ERRO);
            }
        } else {
            MsgCalculo::getInstance()->adicionaMensagem('Operação com chave '.$nrchave.
            ' bloqueada. O registro já existe dentre as informações disponibilizadas para o eSocial.', MsgCalculo::ERRO);
        }
    }

    public function _geraPerdaDsr( $itens_calculo){
        if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ) {
            if ($this->_dias_rsr > 0){
                
                $evento_dsr = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_PERDA_RSR_HORA,
                    $this->_eventom, $this->_nrorg
                );
                $evento_dsr_dia = $this->_assoc_eventos->retornaEventoAssociado(FpatipoassoceveEntity::ASSOC_PERDA_RSR_DIA,
                    $this->_eventom, $this->_nrorg
                );
                
                if ($evento_dsr !== null) {
                    $itensHora = $itens_calculo->retornaItens($evento_dsr);
                }
                if($evento_dsr_dia !== null){
                    $itensDia = $itens_calculo->retornaItens($evento_dsr_dia);
                }
                if(!($itensHora || $itensDia)){
                    $lista_evento_faltas = $this->_eventomMedia->retornaListaEventoFalta($this->_nrorg, $this->_nrOrgPadrao, array(FpaeventohEntity::IDFALTASFERIAS_SOMA), true);
                    if ($lista_evento_faltas) {
                        foreach($lista_evento_faltas as $eventoFalta) {
                            $itens = $itens_calculo->retornaItens($eventoFalta);
                            if ($itens) {
                                if($eventoFalta->historico->getIdunidrefereven() == FpaeventohEntity::IDUNIDREFEREVEN_HORA || $eventoFalta->historico->getIdunidrefereven() == FpaEventohEntity::IDUNIDREFEREVEN_HORA_MINUTO){
                                    $referencia = $evento_dsr->compatibilizaReferenciaDiasParaN(
                                        1, $this->_jornada_diaria
                                    );
                                    $itens_calculo->geraEvento($evento_dsr, null, 0, $referencia, 1);
                                    return;
                                }
                                else if($eventoFalta->historico->getIdunidrefereven() == FpaeventohEntity::IDUNIDREFEREVEN_DIA){
                                    $referencia = $evento_dsr_dia->compatibilizaReferenciaDiasParaN(
                                        1, $this->_jornada_diaria
                                    );
                                    if ($this->_vinculo->getNrtipovinculom() != GpevinculohEntity::TIPO_VINCULO_ESTAGIARIO) {
                                        $itens_calculo->geraEvento($evento_dsr_dia, null, 0, $referencia, 1);
                                    }
                                    return;
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public function _calculaAdicionais($itens_calculo){
        $listaAdicionaisNoturnos = Inicializa::getListaEventoAdicionalNoturno();

        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_AD_INSALUBRE, FpatipoassoceveEntity::ASSOC_ADIC_INSALUBRE, 20,
            $this->_mes_competencia, 0.0
        );
        $this->_calculaDiversos(
            $itens_calculo, FpatipoincideEntity::INC_AD_PERICULO, FpatipoassoceveEntity::ASSOC_ADIC_PERICULO, 20,
            $this->_mes_competencia, 0.0
        );
        foreach($listaAdicionaisNoturnos as $nrAdicionalNoturno => $referencia){
            $this->_calculaDiversos(
                $itens_calculo, FpatipoincideEntity::INC_AD_NOTURNO, $nrAdicionalNoturno, $referencia , $this->_mes_competencia, 0.0
            );
        }
    }
    
    public function _calculaExtra( $itens_calculo){
        $listaHorasExtras = Inicializa::getListaEventoHoraExtra();
        foreach($listaHorasExtras as $nrHoraExtra => $referencia){
            $this->_calculaDiversos(
                $itens_calculo, FpatipoincideEntity::INC_HORA_EXTRA, $nrHoraExtra, $referencia + 100, $this->_mes_competencia, 0.0
            );
        }
    }

    public function _calculaMeses($dt_inicio, $dt_fim){
        $data1 = $dt_inicio;
        $arr = explode('/', $data1);
        $data2 = $dt_fim;
        $arr2 = explode('/', $data2);
        $mes1 = $arr[1];
        $ano1 = $arr[2];
        $mes2 = $arr2[1];
        $ano2 = $arr2[2];
        $a1 = ($ano2 - $ano1)*12;
        $m1 = ($mes2 - $mes1)+1;
        $divisor = ($m1 + $a1);
        if ($divisor>12){
            $divisor=12;
        }
        return $divisor;
    }

    public function _calculaReflexo( $itens_calculo, $nrIncidencia, $nrEvento){
       
        if (!(($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR))
        ) {
            return;
        }
        $nrEscala = $this->_vinculo->historico->getNrescalatrabm();
        if (is_numeric($nrEscala) === false) {
            MsgCalculo::getInstance()->adicionaMensagem('Vínculo sem escala de trabalho.');
            return;
        }
        $idutapuraDsr = $this->escalaVinculo->historico->getIdutapuradsr();
        
        if($idutapuraDsr==GpeescalatrabhEntity::IDUTAPURADSR_SIM){
            if ($this->_itens_calculo_principal->getNrcalculofolha() == $itens_calculo->getNrcalculofolha()) {
                $base = $itens_calculo->calculaIncidencias($nrIncidencia, $this->_mes_competencia, $this->_eventom, true);
                
                if (is_array($base)) {
                    $calendario = new CalendarioLogic($this->entityManager, $this->hcmParameters);
                    foreach ($base as $dataTimestamp => $valorBase) {
                        $diasUteis = 0;
                        $diasDsr = 0;
                        $diasNormais = 0;
                        $diasAfastados = 0;
                        $diasFerias = 0;
                        $dateTime = new DateTime();                
                        $dtOcorrencia = $dateTime->setTimestamp($dataTimestamp);
                        
                        $primeiroDiaOcorrencia = DateUtil::subtraiIntervalo(DateUtil::setDay($dtOcorrencia, $this->_dia_fecha_apuracao+1), 1, DateUtil::MES);
                        $ultimoDiaOcorrencia = DateUtil::setDay($dtOcorrencia, $this->_dia_fecha_apuracao);
                        
                        $this->_vinculo->ajustaIntervaloAdmResc($primeiroDiaOcorrencia, $ultimoDiaOcorrencia, $this->_nrControleAdmissao);
                        $calendario->carregaDiasUteis($this->_nrCalendario, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);
                        
                        $afastamento = $this->_verificaAfastamentos(
                            $this->_vinculo, $this->_situacao_funcional, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia
                        );
                        
                        $gozo_ferias = $this->_verificaFerias($this->_vinculo, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                        $this->_detalhaTrabalho(
                            $afastamento, $gozo_ferias, $calendario->getVetDiasUteis(), $diasUteis, $diasDsr, $diasNormais, $diasAfastados,
                            $diasFerias
                        );
                        
                        $this->_geraEventoCalculoReflexo(
                            $itens_calculo, $nrEvento, $dtOcorrencia, $valorBase, $diasDsr, $diasUteis
                        );
                    }
                } else {
                    $calendario = new CalendarioLogic($this->entityManager, $this->hcmParameters);
                    
                    $primeiroDiaOcorrencia = DateUtil::subtraiIntervalo(DateUtil::setDay($this->_mes_competencia, $this->_dia_fecha_apuracao+1), 1, DateUtil::MES);
                    $ultimoDiaOcorrencia = DateUtil::setDay($this->_mes_competencia, $this->_dia_fecha_apuracao);
                    
                    $calendario->carregaDiasUteis($this->_nrCalendario, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                    $afastamento = $this->_verificaAfastamentos(
                        $this->_vinculo, $this->_situacao_funcional, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia
                    );
                    $gozo_ferias = $this->_verificaFerias($this->_vinculo, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);

                    $this->_detalhaTrabalho(
                        $afastamento, $gozo_ferias, $calendario->getVetDiasUteis(), $diasUteis, $diasDsr, $diasNormais, $diasAfastados,
                        $diasFerias
                    );
                    $this->_dias_rsr=$diasDsr;
                    $this->_dias_uteis=$diasUteis;
                    
                    $this->_geraEventoCalculoReflexo(
                        $itens_calculo, $nrEvento, $this->_mes_competencia, $base, $this->_dias_rsr, $this->_dias_uteis
                    );
                }
            }
        } else {
            if ($this->_itens_calculo_principal->getNrcalculofolha() == $itens_calculo->getNrcalculofolha()) {
                $base = $itens_calculo->calculaIncidencias($nrIncidencia, $this->_mes_competencia, $this->_eventom, true);
                if (is_array($base)) {
                    $calendario = new CalendarioLogic($this->entityManager, $this->hcmParameters);
                    foreach ($base as $dataTimestamp => $valorBase) {
                        $diasUteis = 0;
                        $diasDsr = 0;
                        $diasNormais = 0;
                        $diasAfastados = 0;
                        $diasFerias = 0;
                        $dateTime = new DateTime();
                        $dtOcorrencia = $dateTime->setTimestamp($dataTimestamp);
                        
                        $primeiroDiaOcorrencia = DateUtil::setDay($dtOcorrencia, 1);
                        
                        if ($this->_nr_tipo_calculo == FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR
                        ) {
                            $ultimoDiaOcorrencia = DateUtil::getDataDeString($this->_vinculo->getDtrescisaovinc());
                        }
                        else{
                            $ultimoDiaOcorrencia = DateUtil::getUltimoDiaDoMes($dtOcorrencia);
                        }
                        $calendario->carregaDiasUteis($this->_nrCalendario, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);
                        
                        $afastamento = $this->_verificaAfastamentos(
                            $this->_vinculo, $this->_situacao_funcional, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia
                        );
                        $gozo_ferias = $this->_verificaFerias($this->_vinculo, $primeiroDiaOcorrencia, $ultimoDiaOcorrencia);
                        
                        $this->_detalhaTrabalho(
                            $afastamento, $gozo_ferias, $calendario->getVetDiasUteis(), $diasUteis, $diasDsr, $diasNormais, $diasAfastados,
                            $diasFerias
                        );
                        
                        if ($dtOcorrencia->format('d/m/Y') == $this->_mes_competencia->format('d/m/Y')) {
                            $diasDsr = $this->_dias_rsr;
                            $diasUteis = $this->_dias_uteis;
                        }
                        
                        $idfaltasreflexo = $this->escalaVinculo->historico->getIdfaltasreflexo();
                        
                        if ($dtOcorrencia->format('d/m/Y') == $this->_mes_competencia->format('d/m/Y') && $idfaltasreflexo==GpeescalatrabhEntity::IDFALTASREFLEXO_SIM){

                            $evento_falta = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_FALTAS_DIA);
                            $ref_falta=$this->_itens_calculo_principal->retornaReferenciaPorEvento($evento_falta, $dtOcorrencia);

                            $evento_dsr = $this->_eventom->retornaEvento(FpatipoassoceveEntity::ASSOC_PERDA_RSR_DIA);
                            $ref_dsr=$this->_itens_calculo_principal->retornaReferenciaPorEvento($evento_dsr, $dtOcorrencia);
                                
                            if($ref_falta>$diasUteis){
                                $diasUteis=0;
                            }else{
                                $diasUteis=$diasUteis-$ref_falta;
                            }
                            
                            if($ref_dsr>$diasDsr){
                                $diasDsr=0;
                            }else{
                                $diasDsr=$diasDsr-$ref_dsr;
                            }
                        }
                        
                        $this->_geraEventoCalculoReflexo(
                            $itens_calculo, $nrEvento, $dtOcorrencia, $valorBase, $diasDsr, $diasUteis
                        );
                        
                    }
                } else {
                    $this->_geraEventoCalculoReflexo(
                        $itens_calculo, $nrEvento, $this->_mes_competencia, $base, $this->_dias_rsr, $this->_dias_uteis
                    );
                }
            }
        }

    }

    public function _geraEventoCalculoReflexo($itens_calculo, $nrEvento,
                                                $dataOcorrencia, $valorBase, $diasDsr, $diasUteis)
    {
        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nrEvento, $this->_eventom, $this->_nrorg);
        $valor = 0;
        if($valorBase > 0 && $diasUteis > 0){
            $valor = ($valorBase / $diasUteis) * $diasDsr;
        }
        $calculoEvento = '('.$valorBase.'(Base) / '.$diasUteis.'(Dias Uteis)) * '.$diasDsr.'(Dias Dsr)';
        MemoriaCalculo::getInstance()->escreveEventos($itens_calculo->getNrcalculofolha(), $evento_aux, $calculoEvento, $dataOcorrencia,(float)$valor, $diasDsr,null, $valorBase,null,100);
        $itens_calculo->geraEvento($evento_aux, $dataOcorrencia, (float)$valor, $diasDsr, 1);
    }

    public function _calculaValeTransporte(){
        if($this->_vinculo->historico->getIdremuneracao()!= GpeVinculohEntity::IDREMUNERACAO_ESTAGIO){
            ValeTransporte::calcula(
                $this->_salario, $this->_mes_competencia, $this->_itens_calculo_principal, $this->_assoc_eventos,
                $this->_eventom, $this->_nrorg
            );
        }
    }

    public function _calculaLicencaRemun(){
        $this->_calculaDiversos(
            $this->_itens_calculo_principal, null, FpatipoassoceveEntity::ASSOC_LICENCA_REMUN, 100,
            $this->_mes_competencia, $this->_salario
        );
    }
    
    public function _calculaTotais(){
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_ANTES_TOTALIZACOES, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
        $valor_preservar = $this->preservarValores();
        $totais = $this->_itens_calculo_principal->retornaTotais($this->_eventom);
        $total_proventos = $totais[FpaeventomEntity::IDTIPOEVENTO_PROVENTO];
        $calculoEventoProv = 'Total dos Eventos Proventos';
        $total_desconto = $totais[FpaeventomEntity::IDTIPOEVENTO_DESCONTO];
        $calculoEventoDesc = 'Total dos Eventos Desconto';
        
        $liquido = $total_proventos - $total_desconto;
        
        $calculoEventoLiquido = $total_proventos.' (Proventos) - '.$total_desconto.' (Descontos) = '.$liquido;
        
        if ($liquido - $valor_preservar < 0) {
            
            $valor_complemento = abs($liquido - $valor_preservar);
            
            $calculoEventoLiquidoNegativo = $liquido.' (Liquido) - '.$valor_preservar.' (Eventos de Estorno) = '.$valor_complemento;
            
            $evento_liquido_negativo = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_COMPLEMENTO_SAL_CR, $this->_eventom, $this->_nrorg
            );
            MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_liquido_negativo, $calculoEventoLiquidoNegativo, $this->_mes_competencia, $valor_complemento,0,null,null,null,null);
            $this->_itens_calculo_principal->geraEvento(
                $evento_liquido_negativo, null, $valor_complemento, 0, 2
            );
            $totais = $this->_itens_calculo_principal->retornaTotais($this->_eventom);
            $total_proventos = $totais[FpaeventomEntity::IDTIPOEVENTO_PROVENTO];
            
            /*$total_proventosArre = Valor::arredonda(
                $total_proventos, $this->_idTipoArredonda, $this->_nrDigitoArredonda, $this->_nrLimiteArredonda
            );*/
            $total_desconto = $totais[FpaeventomEntity::IDTIPOEVENTO_DESCONTO];
            /*$total_descontoArred = Valor::arredonda(
                $total_desconto, $this->_idTipoArredonda, $this->_nrDigitoArredonda, $this->_nrLimiteArredonda
            );*/
            $liquido = bcsub($total_proventos, $total_desconto, 10);
            $calculoEventoLiquido = $total_proventos.' (Proventos) - '.$total_desconto.' (Descontos) = '.$liquido;
        }
        $this->_calculo_regra->executaPontoRegra(
            $this->_idDebug, FpaPtregraEntity::PTREGRA_APOS_LIQUIDO_NEGATIVO, $this->_nr_tipo_calculo, $this->_itens_calculo_principal
        );
        
        if ($this->_idTipoArredonda !== false) {
            
            $arredondaFerias = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'NAO_ARREDONDA_FERIAS');
            $arredondaPlr = $this->entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($this->_nrorg, $this->_nrOrgPadrao, $this->_mes_competencia, 'NAO_ARREDONDA_PLR');
            
            if (($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_RESCISAO)
                && ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
                && ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_FERIAS || $arredondaFerias != '1')
                && ($this->_nr_tipo_calculo !== FpatipocalculoEntity::CALC_PLR || $arredondaPlr != '1')
            ) {
                $valorAux = Valor::arredonda(
                    $liquido, $this->_idTipoArredonda, $this->_nrDigitoArredonda, $this->_nrLimiteArredonda
                );
                
                if ($valorAux > $liquido) {
                    
                    $valorArredondamento = $valorAux - $liquido;
                    if ($valorArredondamento > 0) {
                        $evento_arredondamento = $this->_assoc_eventos->retornaEventoAssociado(
                            FpatipoassoceveEntity::ASSOC_ARREDONDAM_SAL_CR, $this->_eventom, $this->_nrorg
                        );
                        $this->_itens_calculo_principal->geraEvento(
                            $evento_arredondamento, null, $valorArredondamento, 0, 2
                        );
                        unset($evento_arredondamento);
                        $totais = $this->_itens_calculo_principal->retornaTotais($this->_eventom);
                        $total_proventos = $totais[FpaeventomEntity::IDTIPOEVENTO_PROVENTO];
                        $total_desconto = $totais[FpaeventomEntity::IDTIPOEVENTO_DESCONTO];
                        $liquido = $total_proventos - $total_desconto;
                        $calculoEventoLiquido = $total_proventos.' (Proventos) - '.$total_desconto.' (Descontos) = '.$liquido;
                    }
                }
            }
        }

        $evento_provento = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_PROVENTOS, $this->_eventom, $this->_nrorg
        );
        $evento_desconto = $this->_assoc_eventos->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_DESCONTOS, $this->_eventom, $this->_nrorg
        );
        
        if ($this->_parcial === true) {
            $evento_liquido = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_LIQUIDO_PARCIAL, $this->_eventom, $this->_nrorg
            );
        } else {
            if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
                || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
            ) {
                $evento_liquido = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_LIQUIDO_RESCISAO, $this->_eventom, $this->_nrorg
                );
            } else{
                $evento_liquido = $this->_assoc_eventos->retornaEventoAssociado(
                    FpatipoassoceveEntity::ASSOC_LIQUIDO, $this->_eventom, $this->_nrorg
                );
            }
        }

        MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_provento, $calculoEventoProv, $this->_mes_competencia, $total_proventos,0,null,null,null,null);
        $this->_itens_calculo_principal->geraEvento($evento_provento, null, (float)$total_proventos, 0, 1);
     
        MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_desconto, $calculoEventoDesc, $this->_mes_competencia, $total_desconto,0,null,null,null,null);
        $this->_itens_calculo_principal->geraEvento($evento_desconto, null, (float)$total_desconto, 0, 1);
        
        MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento_liquido, $calculoEventoLiquido, $this->_mes_competencia,(float)$liquido,0,null,null,null,null);
        $this->_itens_calculo_principal->geraEvento($evento_liquido, null, (float)$liquido, 0, 1);

        if ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FERIAS) {
            $this->_calculaTotaisFerias($liquido);
        }
    }

    public function _calculaTotaisFerias($liquido){

        $base = $this->_itens_calculo_principal->calculaIncidencias(
            FpatipoincideEntity::INC_SUBTOTAL_FERIAS, $this->_mes_competencia, $this->_eventom
        );

        $this->calculoEventoMemoria = 'Valor da Incidência '.FpatipoincideEntity::INC_SUBTOTAL_FERIAS.' = '.$base;
        $this->baseMemoria = $base;
        $this->_atribuiValor($this->_itens_calculo_principal, FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FERIAS, $base);

        $base = $liquido - $base;
        $this->calculoEventoMemoria = 'Valor da Incidência '.FpatipoincideEntity::INC_SUBTOTAL_FERIAS.' - '.$liquido.' (Liquido) = '.$base;
        $this->baseMemoria = $liquido;
        $this->_atribuiValor($this->_itens_calculo_principal, FpatipoassoceveEntity::ASSOC_SUB_TOTAL_FE_2_P, $base);

    }

    public function _calculaGrupoIncidencias(){
        $itensGrupo = $this->_itemGrupo->getItems();
        
        foreach($itensGrupo as $itemGrupo){
            $nrTipoIncidencia = $itemGrupo->getNrtipoincide();
            $valor = $this->_itens_calculo_principal->calculaIncidencias($nrTipoIncidencia, $this->_mes_competencia, $this->_eventom);
            
            $valor = $itemGrupo->calculaValor($valor);
            $referencia = $itemGrupo->determinaReferencia();
            
            if (empty($referencia) === true){
                $referencia = 0;
            }
            
            if ($itemGrupo->getIdretvalor() === FpaGrpitemEntity::IDRETVALOR_NAO) {
                $valor = 0;
            }
            
            if ($itemGrupo->getIdretreferencia() === FpaGrpitemEntity::IDRETREFERENCIA_SIM) {
                $referencia = $this->_itens_calculo_principal->getTotalReferencias();
            }
            
            
            $evento = $this->_eventom->retornaEvento($itemGrupo->getNreventom());
           
            if ($itemGrupo->getNreventom() == FpatipoassoceveEntity::ASSOC_INSS_ACID_TRAB) {
                
                $vrFap = $this->estrutura->historico->getVrfap();
                
                if ($vrFap && $referencia > 0) {
                    $vrBase = $valor * 100 / $referencia;
                    $referencia = $referencia * $vrFap;
                    $valor = $vrBase * $referencia / 100;
                    $calculoEvento = $vrBase.' (Base) * '.$referencia.' (Referência) / 100 = '.$valor;
                }
            }
            
            MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento, $calculoEvento, $this->_mes_competencia, $valor, $referencia,null, $vrBase, $nrTipoIncidencia,100);
            $this->_itens_calculo_principal->geraEvento($evento, $this->_mes_competencia, $valor, $referencia, 1);
        }
        
    }

    public function _geraEventoRelacionado(){
        $this->_eventoRelacionado = array();
        $this->geraNoMensal=false;
        if ( ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
        ) {
            $refSalario_1=0;
            $refSalario_2=0;
            $refSalario_M=0;

            $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SALARIO_1, $this->_eventom, $this->_nrorg
            );
            $refSalario_1=$this->_itens_calculo_principal->retornaReferenciaPorEvento($eventoAux);

            $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SALARIO_2, $this->_eventom, $this->_nrorg
            );
            $refSalario_2=$this->_itens_calculo_principal->retornaReferenciaPorEvento($eventoAux);

            $eventoAux = $this->_assoc_eventos->retornaEventoAssociado(
                FpatipoassoceveEntity::ASSOC_SALARIO_MATERNIDADE, $this->_eventom, $this->_nrorg
            );
            $refSalario_M=$this->_itens_calculo_principal->retornaReferenciaPorEvento($eventoAux);

            if(($refSalario_1+$refSalario_2+$refSalario_M)>0){
                $this->geraNoMensal=true;
            }
        }
        $this->_carregaEventoRelacionadoOcupacao();      
        
        $this->_carregaEventoRelacionadoEstrutura();   

        $this->_carregaEventoRelacionadoVinculo();
        
        foreach($this->_eventoRelacionado as $item){

            $valor = 0;
            $referencia= 0;
            $percentual = $item->getVrpercent();
            $descricaoReferencia = $this->_valores_referencia->getDescricaoReferencia($item->getNrvalorreferenciam());
            if ($item->getIdretreferencia() === FpaVinceventoEntity::IDRETREFERENCIA_SIM){
                if($descricaoReferencia){
                    $referencia = $this->_valores_referencia->getReferencia($descricaoReferencia);
                }
            } else {
                if ($item->getVrreffixo() != 0){
                    $referencia = $item->getVrreffixo();
                } else {
                    
                    $referencia = $item->determinaReferencia();
                }
            }
            if ($item->getVreventofixo() != 0){
                $valor = $item->getVreventofixo();
                $calculoEvento = 'Valor Evento Fixo';
            }
            else {
                if($descricaoReferencia){
                    $valor = $this->_valores_referencia->getValorReferencia($descricaoReferencia);
                    if ($percentual !== 100 && empty($percentual) === false) {
                        $valor = ($valor * $percentual) / 100;
                        $calculoEvento = '('.$valor.' * '.$percentual.'(Percentual)) / 100';
                    }

                    $multiplicador = $item->getVrmultiplic();
                    if ($multiplicador !== 1 && empty($multiplicador) === false) {
                        $valor = $valor * $multiplicador;
                        $calculoEvento .= ' * '.$multiplicador.'(VrMultiplic)';
                    }

                    $divisor = $item->getVrdivide();
                    if ($divisor !== 1 && empty($divisor) === false) {
                        $valor = $valor / $divisor;
                        $calculoEvento .= ' / '.$divisor.'(VrDivide)';
                    }
                }else{
                    if ($item->getVrpercent() != 0){
                        
                        $valor=$this->_salario * $item->getVrpercent()/100;
                        $calculoEvento = '('.$this->_salario.'(Salario) * '.$item->getVrpercent().'(VrPercent)) / 100';
                    }
                }
            }
            if (empty($referencia) === true){
                $referencia = 0;
            }
            $calculoEvento .= ' = '.$valor;
            if($valor>$item->getVrtetoevento()){
                $valor=$item->getVrtetoevento();
                $calculoEvento .= PHP_EOL.'valor = '.$valor.'(Valor Teto do Evento)';
            }elseif($valor<$item->getVrpisoevento()){
                $valor=$item->getVrpisoevento();
                $calculoEvento .= PHP_EOL.'valor = '.$valor.'(Valor Piso do Evento)';
            }
            $evento = $this->_eventom->retornaEvento($item->getNreventom());
            $eventoRelacionado = $this->tipoEventoRelacionado[$item->getNreventom()];
            MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(), $evento, $calculoEvento, $this->_mes_competencia, $valor, $referencia,null,null,null, $percentual, $eventoRelacionado);
            $this->_itens_calculo_principal->geraEvento($evento, null, $valor, $referencia, 1);
        }
    }

    public function _carregaEventoRelacionadoVinculo(){

        $lista = $this->_vincEvento->retornaAssociacoesVinculoEvento(
            $this->_nrorg, $this->_vinculo->getNrvinculom(), $this->_mes_competencia
        );
        
        foreach($lista as $item){
            $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(), $item->getPeriodicidademes(),
                $item->getDtinivigencia(), $item->getDtfimvigencia(), $item->getIdgeraafastado()); 
            if ($carregaEvento === true) {
                $this->_eventoRelacionado[$item->getNreventom()] = $item;
                $this->tipoEventoRelacionado[$item->getNreventom()] = 'Vinculo';
            }
        }
    }

    public function _carregaEventoRelacionadoOcupacao(){

        $alteracaoOcupacao = $this->_alteracaoOcupacao->retornaUltimaAlteracaoOcupacaoVinculo(
            $this->_nrorg, $this->_ult_dia_mes, $this->_vinculo->getNrvinculom()
        );
        if (is_object($alteracaoOcupacao) === true){
            $nrOcupacao = $alteracaoOcupacao->getNrocupacaom();
            $lista = $this->_ocupacaoEvento->retornaAssociacoesOcupacaoEvento($this->_nrorg, $nrOcupacao);
            foreach($lista as $item){
                $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(), $item->getPeriodicidademes(),
                    $item->getDtinivigencia(), $item->getDtfimvigencia(), $item->getIdgeraafastado()); 
                if ($carregaEvento === true) {
                    $this->_eventoRelacionado[$item->getNreventom()] = $item;
                    $this->tipoEventoRelacionado[$item->getNreventom()] = 'Ocupação';
                }
            }
        }
    }

    public function _carregaEventoRelacionadoEstrutura(){

        $nrEstrutura = $this->_vinculo->historico->getNrestrutlegal();
        $lista = $this->_estruturaEvento->retornaAssociacoesEstruturaEvento($this->_nrorg, $nrEstrutura);
        foreach($lista as $item){
            $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(), $item->getPeriodicidademes(),
                $item->getDtinivigencia(), $item->getDtfimvigencia(), $item->getIdgeraafastado()); 
            if ($carregaEvento === true) {
                $this->_eventoRelacionado[$item->getNreventom()] = $item;
                $this->tipoEventoRelacionado[$item->getNreventom()] = 'Estrutura Legal';
            }
        }
        $nrEstrutura = $this->_vinculo->historico->getNrestrutgeren();
        $lista = $this->_estruturaEvento->retornaAssociacoesEstruturaEvento($this->_nrorg, $nrEstrutura);
        foreach($lista as $item){
            $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(), $item->getPeriodicidademes(),
                $item->getDtinivigencia(), $item->getDtfimvigencia(), $item->getIdgeraafastado()); 
            if ($carregaEvento === true) {
                $this->_eventoRelacionado[$item->getNreventom()] = $item;
                $this->tipoEventoRelacionado[$item->getNreventom()] = 'Estrutura Gerencial';
            }
        }

        $nrEstrutura = $this->_vinculo->historico->getNrestrutsind();
        $lista = $this->_estruturaEvento->retornaAssociacoesEstruturaEvento($this->_nrorg, $nrEstrutura);
        foreach($lista as $item){
            $carregaEvento = $this->_validaCarregamentoEventoRelacionado($item->getIdtipomovimento(), $item->getPeriodicidademes(),
                $item->getDtinivigencia(), $item->getDtfimvigencia(), $item->getIdgeraafastado()); 

            if ($carregaEvento === true) {
                $this->_eventoRelacionado[$item->getNreventom()] = $item;
                $this->tipoEventoRelacionado[$item->getNreventom()] = 'Estrutura Sindical';
            }
        }
    }

    public function preservarValores(){
        $valor = 0;
        foreach( $this->_eventom->preservar as $evento_preserv ){
            $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($evento_preserv, $this->_eventom, $this->_nrorg);
            $itens = $this->_itens_calculo_principal->retornaItens($evento_aux);
            foreach ($itens as $indice) {
                $valor += $this->_itens_calculo_principal->retornaValor($indice);
            }
        }
        return $valor;
    }
    
    public function _validaCarregamentoEventoRelacionado($idTipoMovimento, $periodicidadeMes, $dtIniVigencia, $dtFimVigencia = null, $idGeraAfastado = null){
        $carregaEvento = false;
        $geraEvenSituacao = $this->_valores_referencia->getValorReferencia(FpaValorreferenciamEntity::GERA_EVEN_REL_MP936);
        if((int)$this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_NORMAL]<=0
            && (int)$this->_sit_func_resumo[GpesitufuncmEntity::SITUACAO_FUNCIONAL_MATERNIDADE]<=0
            && !$this->geraNoMensal
            && (($idGeraAfastado == 'N')||($idGeraAfastado == null))
            && !$this->_sit_func_resumo[100040] 
            && (!$this->_sit_func_resumo[100041] && !$geraEvenSituacao > 0)
            && (!$this->_sit_func_resumo[100044] && !$geraEvenSituacao > 0)
        ) {
            $carregaEvento = false;
            return $carregaEvento;
        }
        if($this->_mes_competencia < $dtIniVigencia){
            $carregaEvento = false;
            return $carregaEvento;
        }elseif($dtFimVigencia != null){
            if($this->_mes_competencia > $dtFimVigencia){
                $carregaEvento = false;
                return $carregaEvento;
            }
        }
        foreach ($this->_gruposCalulos as $gruposcalculos) {
            if($gruposcalculos['nrtpagrupa'] == $idTipoMovimento && $gruposcalculos['nrtipocalculo'] == $this->_nr_tipo_calculo){
                if ($periodicidadeMes[$this->_mes_competencia_int-1]=='S'){
                    $carregaEvento = true;
                    break;
                }
            }
        }
        return $carregaEvento;
    }
    
    public function _geraPensao(){

        foreach($this->_eventoRelacionado as $item){
            if($this->tipoEventoRelacionado[$item->getNreventom()] == 'Vinculo' && $item->getNrtipoincide()){
                $valor = 0;
                $referencia= 0;
                $percentual = $item->getVrpercent();

                $descricaoReferencia = $this->_valores_referencia->getDescricaoReferencia($item->getNrvalorreferenciam());

                // Verifica se a referencia vem da tabela ValorReferencia ou se eh passada fixa no item
                if ($item->getIdretreferencia() === FpaVinceventoEntity::IDRETREFERENCIA_SIM){
                    if($descricaoReferencia){
                        $referencia = $this->_valores_referencia->getReferencia($descricaoReferencia);
                    }
                } else {
                    if ($item->getVrreffixo() != 0){
                        $referencia = $item->getVrreffixo();
                    } else {
                        // Pegar a referencia conforme o campo IDREFGERAR;
                        $referencia = $item->determinaReferencia();
                    }
                }

                $base = $this->_calculaBase($this->_itens_calculo_principal, $item->getNrtipoincide(), $this->_mes_competencia);
                $valor = $base;

                if ($percentual !== 100 && empty($percentual) === false) {
                    $valor = ($base * $percentual) / 100;
                    $calculoEvento = '('.$base.' * '.$percentual.'(Percentual)) / 100';
                }

                $multiplicador = $item->getVrmultiplic();
                if ($multiplicador !== 1 && empty($multiplicador) === false) {
                    $valor = $valor * $multiplicador;
                    $calculoEvento .= ' * '.$multiplicador.'(VrMultiplic)';
                }

                $divisor = $item->getVrdivide();
                if ($divisor !== 1 && empty($divisor) === false) {
                    $valor = $valor / $divisor;
                    $calculoEvento .= ' / '.$divisor.'(VrDivide)';
                }


                if (empty($referencia) === true){
                    $referencia = 0;
                }
                //10/07/2014
                //Limita o valor entre o piso e o teto

                $calculoEvento .= ' = '.$valor;

                if($valor>$item->getVrtetoevento()){
                    $valor=$item->getVrtetoevento();
                    $calculoEvento .= PHP_EOL.'valor = '.$valor.'(Valor Teto do Evento)';
                }elseif($valor<$item->getVrpisoevento()){
                    $valor=$item->getVrpisoevento();
                    $calculoEvento .= PHP_EOL.'valor = '.$valor.'(Valor Piso do Evento)';
                }

                // Gerar novo evento no itemCalculo com valor, referencia;
                $evento = $this->_eventom->retornaEvento($item->getNreventom());
                $eventoRelacionado = $this->tipoEventoRelacionado[$item->getNreventom()];
                MemoriaCalculo::getInstance()->escreveEventos($this->_itens_calculo_principal->getNrcalculofolha(),$evento,$calculoEvento,$this->_mes_competencia,$valor,$referencia,null,null,null,$percentual,$eventoRelacionado);
                $this->_itens_calculo_principal->geraEvento($evento, $this->_mes_competencia, $valor, $referencia, 1);
            }
        }
    }
}